{$O+}

Unit InitDat;

Interface

Uses
  Edvar,
  StatVar,
  Dos,
  Crt,
  ScreenWP,
  Mouse;
  // SysUtils,
  // Variants,
  // Classes,
  // Graphics,
  // Controls,
  // Forms,
  // Dialogs;
  // Menus



Function Reserved_Word(invar : str50):boolean;
Procedure ShowMessage(Instring1 : String78; Instring2: String78;
                       Instring3 : String78);

// Procedure ShowMessage1(Instring1 : String78);
Procedure CloseMessageWindow;
Function StringToInt(Instring : string): Integer;
Procedure Assign_Variable_Type;
Procedure ReadLabels;
Procedure Assign_SymTab;
Procedure Assign_PasTab;
Procedure InitGlobVars;

Implementation

var
   Reserve : Array [1..22] of String[22];

Function Scan(instring: string; var spos: integer):String;
var
   substring : string;
   c, word_len : byte;
begin
   c := spos;
   word_len := 0;
   if (length(instring)=0) then
      begin
            Scan:='';
            exit;
      end;
   while (instring[spos]<> ' ') do
      begin
        inc(word_len);
        inc(spos);
      end;
   substring:= copy(instring,c,word_len);
   while (instring[spos]= ' ') do
      inc(spos);
   Scan := Substring;
end;

Procedure ShowMessage(Instring1 : String78; Instring2: String78;
                       Instring3 : String78);
      { Show a message on the upper half of the screen }
      { centring each line in a temporary pop up window }
var
   Line1,
   TemSt,
   St1    : String78;
   msgString : string;
   Ch : char;
   LeadSpaces : integer;



Begin
    msgString:= concat(Instring1,'.  ');
    msgString:= concat(msgString, Instring2);  
    msgString:= concat(msgString,'.  ');
    msgString:= concat(msgString, Instring3);
    msgString:= concat(msgString,'.  ');
    //MessageDlg(Format(msgString, [name]), mtConfirmation,
    //      [mbYes], 0);
end;





Procedure CloseMessageWindow;
     { Close the window used for displaying temporary messages }
begin
  // RestoreWindow(4,13,72,5);
end;

Function StringToInt(Instring : string): Integer;
var
    valu,
    code1  : integer;
begin
    val(Instring, valu, code1);
    StringToInt := Valu;
end;

Function UpCaseStr(Instring : String):String;
   { This takes a string supplied to it and returns it all in }
   { capital letters }
var
   outstring : string;
   i : integer;
begin
   OutString:=Instring;
   for i:=1 to Length(Instring) do Outstring[i]:=Upcase(Instring[i]);
   UpCaseStr:=OutString;
end;


Function Strip_UnderScores(instr : String):String;
var
  outstr      : String;
  i, len      : integer;
begin
  outstr:=instr;
  for i:=1 to Length(instr) do
     begin
        if ((instr[i]=' ')and (i<>0)) then
           outStr[i]:='_';
        if instr[i]=',' then
           outStr[i]:='_';
        if instr[i]=')' then
           outStr[i]:='_';
        if instr[i]='(' then
           outStr[i]:='_';
        if instr[i]='/' then
           outStr[i]:='_';
        if instr[i]='.' then
           outStr[i]:='_';
     end;
  if (outStr[1]='_') then
     delete(outStr,1,1);
  for i:=2 to Length(outStr) do
     begin
         if ((outStr[i]='_') and (outStr[i-1]='-')) then
            delete(outStr,i-1,1);
     end;
  for i:=2 to Length(outStr) do
     begin
         if ((outStr[i]='_') and (outStr[i-1]='_')) then
            delete(outStr,i-1,1);
     end;
  len := Length(outStr);
  if (outStr[len]='_') then
     delete(outStr,len,1);
  Strip_UnderScores:=outStr;
end;

Function OnlyBlanks(Intxt : string): boolean;
var
    j : integer;
begin
    j:=0;
    OnlyBlanks := True;
    repeat
        Inc(j);
    until ((j >= Length(Intxt)) or (Intxt[j] <> ' '));
    If ((Length(Intxt)>0) and (Intxt[j] <> ' ')) then
        OnlyBlanks := False;
end;

Procedure ReadLabels;

Var
    Infile  : TEXT;
    Num     : string[3];
   // Name    : String[40];
    Name150 : String[150];
    ValStr  : String[7];
    Blank2  : String[2];
    Blank1  : String[1];
    Dtype   : String[5];
    VarnStr : String[8];
    FullStr : string;
    cpos     : integer;

    StringIn: String;
    ValInx,
    VarInx,
    CodeInx,
    VarCnt,
    ValCnt : integer;
    ch     : char;

begin
    ChangeDir(prdrive+'\pom\data');
    cursoron:=GetCursorMode;
    OpenFiles := 0;
    File_ary_pos := 0;
    readopen('ORCASE.DTA',infile);
    VarCnt := 0;
    Repeat
       Inc(VarCnt);
       Readln(infile,FullStr);
       cpos:=1;
       while(fullstr[cpos]=' ') do
          inc(cpos);
       Num    :=Scan(fullstr,cpos);
       Name150:=Scan(fullstr,cpos);
       ValStr :=Scan(fullstr,cpos);
       Dtype  :=Scan(fullstr,cpos);
       varnstr :=Scan(fullstr,cpos);
       while ((Name150[1] = ' ') and (length(name150)>1)) do delete(Name150,1,1);
       if (pos(' ',name150)<>0) then
          delete(name150,pos(' ',name150),(length(name150)-pos(' ',name150))+1);
       // PDT NOV 2009
       If (name150 = ' ') then
          begin
              ShowMessage('One of the variables in the file ORCASE.DTA',
                          'does not have a name.  You must edit ORCASE.DTA',
                          'press any key to continue');
              ch := readkey;
              CloseMessageWindow;
              ClrScr;
              Halt(0);
          end;
       New(VarArray[VarCnt]);
       With VarArray[VarCnt]^ do
          begin
             New(LongPtr);
             LongPtr^:=Name150;
             New(BigPtr);
             BigPtr^:= UpcaseStr(Name150);
             If (ValStr[1]='T') then
               IfVallabs:= True
             Else
               IfVallabs:= False;
             If (DType = 'MONEY') then
                IfMoney := TRUE
             else
                IfMoney := FALSE;
             Varname := VarnStr;
             Assigned:= True;
             Level := 0;
             Ifbool := False;
             Ifreal := False;
             IfDisplay := TRUE;
          end;
    until (eof(infile));
    VarArray[VarCnt + 1] := Nil;
    HighestVar := VarCnt;
    RawVarMax := VarCnt;
    closefile('ORCASE.DTA',infile);
    readopen('ORVALLAB.dta',infile);
    repeat
       readln(infile, num);
       while (num[1]=' ') do delete (num,1,1);
       Val(num,VarInx,codeinx);
       If (codeinx = 0) then
         begin
           New(VarArray[VarInx]^.ValPtr);
           ValCnt := 0;
           repeat
             read(infile, num);
             read(infile, blank2);
             readln(infile, name150);
             if (onlyBlanks(name150)) then
                name150:= num;
             if (num <> 'END') then
               begin
                 Inc(ValCnt);
                 while (num[1]=' ') do delete (num,1,1);
                 Val(num,ValInx,codeinx);
                 with VarArray[VarInx]^.ValPtr^ do
                   begin
                      N_Ary[ValCnt]:=ValInx;
                      New(V_Ary[ValCnt]);
                      name150:= strip_underscores(name150);
                      V_Ary[ValCnt]^ := name150;
                   end;
               end
             else
               begin
                 with VarArray[VarInx]^.ValPtr^ do
                   begin
                      New(V_Ary[Valcnt+1]);
                      V_Ary[Valcnt+1]^:='------------- End of List -------------';
                      N_Ary[Valcnt+1]:=Maxint;
                      Str(ValCnt+1,StringIn);
                      New(V_Ary[0]);
                      V_Ary[0]^:=StringIn;
                   end;
               end;
           until (num = 'END')
         end;
    until(eof(infile));
    closefile('ORVALLAB.dta',infile);
    ChangeDir(prdrive+'\pom');
end;


Procedure Assign_Variable_Type;

      Procedure sort(var Sort_Array : Variable_Array; cnt : integer);
        { This takes the variable names in an array and sorts them into }
        { alphabetical order }
            var
               i,j,k,gap   :  integer;
               temp        :  str50;
            begin
               gap:= (cnt - 1) div 2;
               while gap> 0 do
                   begin
                       for i:=gap+1 to (cnt-1) do
                           begin
                               j:= i-gap;
                               while j>0 do
                                  begin
                                      k:=j+gap;
                                      if Sort_Array[j]^ <= Sort_Array[k]^ then
                                          j:=0
                                      else
                                            begin
                                                temp:=Sort_Array[j]^;
                                                Sort_Array[j]^:=Sort_Array[k]^;
                                                Sort_Array[k]^:=temp
                                             end;
                                       if (j>=gap) then j:=j-gap
                                       else j:=0
                                   end
                            end;
                        gap:=gap div 2
                    end
            end;

      Procedure Read_ValLab_Variables;
        { This reads a list of variables which have sets of value labels }
        { and stores them in an array }
      var
         xcnt,
         ycnt   : integer;
         StringIn : Str50;

      begin
         xcnt:=1;
         ycnt:=1;
         while xcnt <= HighestVar do
           begin
             If (VarArray[xcnt]^.IfValLabs = true) then
               begin
                  New(Value_Label_Ary[ycnt]);
                  Value_Label_Ary[ycnt]^:=VarArray[xcnt]^.LongPtr^;
                  ycnt:=ycnt+1;
               end;
             xcnt:=xcnt+1;
           end;
           New(Value_Label_Ary[ycnt]);
           Value_Label_Ary[ycnt]^:='------------- End of List -------------';
           Str(ycnt,StringIn);
           New(Value_Label_Ary[0]);
           Value_Label_Ary[0]^:=StringIn;
           Sort(Value_Label_Ary, ycnt);
      end;

      Procedure Read_File_Type (Var In_Array: Variable_Array;
                                Var In_Array2 : Variable_Array; level : byte);
          { This opens a file with the name instring and then reads all the }
          { variables in the file.   It creates two different arrays.  One }
          { containing all the variables of the appropriate type, and a second}
          { containing only those which have value labels }
      var
          StringIn    : String[12];
          Blank2      : String[1];
          VarStr      : String[3];
          blank29     : string[26];
          targdat,
          datype      : string[1];
          varname,
          labels,
          instring,
          format,
          VarStr38    : String;
          longvar     : String[49];
          FullStr     : string;
          cpos,
          vcnt,
          cnt,
          catcnt      : integer;
          Infil       : Text;

          Procedure Close_Array;
          begin
              New(In_Array[0]);
              In_Array[0]^:='1';
              New(In_Array[cnt]);
              In_Array[cnt]^:='------------- End of List -------------';
              New(In_Array2[0]);
              In_Array2[0]^:='1';
              New(In_Array2[cnt]);
              In_Array2[cnt]^:='------------- End of List -------------';
              CloseFile(Instring, infil);
          end;

      begin
          if (level = Household) then
             targdat := 'H'
          else if (level = Family) then
             targdat := 'T'
          else
             targdat := 'I';
          instring:= 'ORCASE.DTA';
          ReadOpen(Instring, infil);
          If (Ioresult<>0) then
             LexicalError('Error the file', Instring, 'Could not be opened');
          cnt:=1;
          catcnt:=1;
          If eof(infil) then
              begin
                 Close_Array;
                 Exit;
              end;
          repeat
              repeat
                 Readln(infil,FullStr);
                 cpos:=1;
                 while(fullstr[cpos]=' ') do
                    inc(cpos);
                 VarStr   :=Scan(fullstr,cpos);
                 VarStr38 :=Scan(fullstr,cpos);
                 labels   :=Scan(fullstr,cpos);
                 format   :=Scan(fullstr,cpos);
                 varname  :=Scan(fullstr,cpos);
                 datype   :=Scan(fullstr,cpos);
              until ((datype = targdat) or (eof(infil)));
              if (datype  = targdat) then
              begin
                VarArray[StringToInt(Varstr)]^.level := level;
                While(VarStr38[1]=' ') do delete(VarStr38,1,1);
                while (VarStr38[length(varstr38)] = ' ') do
                     delete(varstr38,length(varstr38),1);
                vcnt:= FindVarNumber(VarStr38);
                if (Length(varstr38)>37) then
                      delete(varstr38,37,Length(varstr38)-37);
                //vcnt:= FindVarNumber(VarStr38);
                New(In_Array[cnt]);
                if (vcnt>=167) then
                begin
                   longvar:= 'dead';
                   longvar:= 'recent';
                end;
                longvar:=VarArray[vcnt]^.LongPtr^;
                while (length(longvar) < 38) do
                  longvar := longvar + ' ';
                longvar := longvar+' | '+VarArray[vcnt]^.Varname;
                In_Array[cnt]^:= longvar;
                if VarArray[vcnt]^.IfVallabs then
                  begin
                      New(In_Array2[catcnt]);
                      In_Array2[catcnt]^:=longvar;
                      catcnt:=succ(catcnt);
                  end;
                cnt:=cnt+1;
              end;
          until eof(InFil);
          CloseFile(Instring, infil);
          New(In_Array[cnt]);
          In_Array[cnt]^:='------------- End of List -------------';
          Str(Cnt,StringIn);
          New(In_Array[0]);
          In_Array[0]^:=StringIn;
          New(In_Array2[catcnt]);
          In_Array2[catcnt]^:='------------- End of List -------------';
          Str(CatCnt,StringIn);
          New(In_Array2[0]);
          In_Array2[0]^:=StringIn;
          Sort(In_Array, cnt);
          Sort(In_Array2, catcnt);
      end;

      Procedure Create_Total_Vars;
         { This creates a variable array with the names of all the variables }
      var
         st : string[2];
         i : integer;
      begin
         for i:=1 to Highestvar do
            begin
               New(Tot_Var_Ary[i]);
               Tot_Var_Ary[i]^:=VarArray[i]^.LongPtr^;
            end;
         str(HighestVar + 1, St);
         New(Tot_Var_Ary[0]);
         Tot_Var_Ary[0]^:=St;
         Sort(Tot_Var_Ary, HighestVar + 1);
         New(Tot_Var_Ary[HighestVar + 1]);
         Tot_Var_Ary[HighestVar + 1]^:='------------- End of List -------------';
      end;

begin
    ChangeDir(prdrive+'\pom\data');
    Read_File_Type (Hhold_Array, Hhold_Cat_Ary,Household);
    Read_File_Type (Taxun_Array, Taxun_Cat_Ary,Family);
    Read_File_Type (Ind_Array, Ind_Cat_Ary,Individual);
    Read_ValLab_Variables;
    Create_Total_Vars;
    ChangeDir(prdrive+'\pom');
end;

Procedure Assign_SymTab;
    { This assigns values to the elements of an array which describes all }
    { the valid elements of POM's language.  In each case there is a string}
    { which describes the language element and a number associated with it }
begin
    SymTab[1].symbol:=',';
    SymTab[1].tokn:=COMMA;
    SymTab[2].symbol:='TO';
    SymTab[2].tokn:=to1;
    SymTab[3].symbol:='=';
    SymTab[3].tokn:=EQUALS;
    SymTab[4].symbol:='POLICY_STATUS';
    SymTab[4].tokn:=Policy_Status;
    SymTab[5].symbol:=';';
    SymTab[5].tokn:=SEMIC;
    SymTab[6].symbol:='AND';
    SymTab[6].tokn:=AND1;
    SymTab[7].symbol:='-';
    SymTab[7].tokn:=MINUS;
    SymTab[8].symbol:='+';
    SymTab[8].tokn:=PLUS;
    SymTab[9].symbol:='OR';
    SymTab[9].tokn:=OR1;
    SymTab[10].symbol:='NOT';
    SymTab[10].tokn:=NOT1;
    SymTab[11].symbol:='(';
    SymTab[11].tokn:=LBRACK;
    SymTab[12].symbol:=')';
    SymTab[12].tokn:=RBRACK;
    SymTab[13].symbol:='}';
    SymTab[13].tokn:=RCURLY;
    SymTab[14].symbol:='{';
    SymTab[14].tokn:=LCURLY;
    SymTab[15].symbol:='TRUE';
    SymTab[15].tokn:=TRUE1;
    SymTab[16].symbol:='FALSE';
    SymTab[16].tokn:=FALSE1;
    SymTab[17].symbol:='SUM';
    SymTab[17].tokn:=SUM;
    SymTab[18].symbol:='TO_POWER_OF';
    SymTab[18].tokn:=to_power_of;
    SymTab[19].symbol:='GROSSING_VAR';
    SymTab[19].tokn:=GROSSING_VAR;
    SymTab[20].symbol:='ABS';
    SymTab[20].tokn:=Abs1;
    SymTab[21].symbol:='DATA';
    SymTab[21].tokn:=DATA;
    SymTab[22].symbol:='DIV';
    SymTab[22].tokn:=DIV1;
    SymTab[23].symbol:='*';
    SymTab[23].tokn:=TIMES;
    SymTab[24].symbol:='/';
    SymTab[24].tokn:=DIVIDE;
    SymTab[25].symbol:='MOD';
    SymTab[25].tokn:=MODULO;
    SymTab[26].symbol:='IF';
    SymTab[26].tokn:=IF1;
    SymTab[27].symbol:='THEN';
    SymTab[27].tokn:=THEN1;
    SymTab[28].symbol:='ELSE';
    SymTab[28].tokn:=ELSE1;
    SymTab[29].symbol:='TARGET_DATA';
    SymTab[29].tokn:=target_data;
    SymTab[30].symbol:='<>';
    SymTab[30].tokn:=NE;
    SymTab[31].symbol:='EQ';
    SymTab[31].tokn:=EQUALS;
    SymTab[32].symbol:='NE';
    SymTab[32].tokn:=NE;
    SymTab[33].symbol:='GT';
    SymTab[33].tokn:=GT;
    SymTab[34].symbol:='GE';
    SymTab[34].tokn:=GE;
    SymTab[35].symbol:='LT';
    SymTab[35].tokn:=LT;
    SymTab[36].symbol:='LE';
    SymTab[36].tokn:=LE;
    SymTab[37].symbol:='SOURCE';
    SymTab[37].tokn:=SOURCE;
    SymTab[38].symbol:='RANDOM_NUMBER';
    SymTab[38].tokn:=RANDOM;
    SymTab[39].symbol:='EXP';
    SymTab[39].tokn:=EXP1;
    SymTab[40].symbol:='PER_MONTH';
    SymTab[40].tokn:=Per_Month;
    SymTab[41].symbol:=']';
    SymTab[41].tokn:=rsquare;
    SymTab[42].symbol:='[';
    SymTab[42].tokn:=lsquare;
    SymTab[43].symbol:='ARRAY';
    SymTab[43].tokn:=ARRAY1;
    SymTab[44].symbol:='NAME';
    SymTab[44].tokn:=NAME;
    SymTab[45].symbol:='VAR';
    SymTab[45].tokn:=VARLABEL;
    SymTab[46].symbol:='VALUE';
    SymTab[46].tokn:=VALUELABEL;
    SymTab[47].symbol:='INTEGER';
    SymTab[47].tokn:= INTEGER1;
    SymTab[48].symbol:='REAL';
    SymTab[48].tokn:=REAL1;
    SymTab[49].symbol:='MONEY';
    SymTab[49].tokn:=MONEY1;
    SymTab[50].symbol:='BOOLEAN';
    SymTab[50].tokn:=BOOLEAN1;
    SymTab[51].symbol:='WIDTH';
    SymTab[51].tokn:=WIDTH;
    SymTab[52].symbol:='NUMBER';
    SymTab[52].tokn:=number;
    SymTab[53].symbol:='GREATER_THAN';
    SymTab[53].tokn:=GT;
    SymTab[54].symbol:='LESS_THAN';
    SymTab[54].tokn:=LT;
    SymTab[55].symbol:='<>';
    SymTab[55].tokn:=NE;
    SymTab[56].symbol:='>';
    SymTab[56].tokn:=GT;
    SymTab[57].symbol:='>=';
    SymTab[57].tokn:=GE;
    SymTab[58].symbol:='<';
    SymTab[58].tokn:=LT;
    SymTab[59].symbol:='<=';
    SymTab[59].tokn:=LE;
    SymTab[60].symbol:='WRITEVAR';
    SymTab[60].tokn:=WRITEVAR;
    SymTab[61].symbol:='WRITE';
    SymTab[61].tokn:=WRITE1;
    SymTab[62].symbol:='MOD';
    SymTab[62].tokn:=MODULO;
    SymTab[63].symbol:='.';
    SymTab[63].tokn:=FullStop;
    SymTab[64].symbol:=':';
    SymTab[64].tokn:=Colon;
    SymTab[65].symbol:='VARIABLE';
    Symtab[65].tokn:=Variable;
    Symtab[66].symbol:='USER VARIABLE';
    Symtab[66].tokn:=UserVar;
    SymTab[67].symbol:='OF';
    SymTab[67].tokn:=TIMES;
    Symtab[68].symbol:='ANALYSIS LEVEL';
    Symtab[68].tokn:=Analysis_Level;
    Symtab[69].symbol:='INDIVIDUAL''S';
    Symtab[69].tokn:=Individual;
    Symtab[70].symbol:='TAX_UNIT''S';
    Symtab[70].tokn:=Family;
    Symtab[71].symbol:='HOUSEHOLD''S';
    Symtab[71].tokn:=Household;
    Symtab[72].symbol:='END OF ANALYSIS LEVEL';
    Symtab[72].tokn:=End_Anal_Level;
    Symtab[73].symbol:='NUMBER_IN_TAX_UNIT';
    Symtab[73].tokn:=Number_in_Family;
    Symtab[74].symbol:='NUMBER_IN_HOUSEHOLD';
    Symtab[74].tokn:=Number_in_HouseHold;
    Symtab[75].symbol:='ANY_IN_TAX_UNIT';
    Symtab[75].tokn:=Any_in_Family;
    Symtab[76].symbol:='ANY_IN_HOUSEHOLD';
    Symtab[76].tokn:=Any_in_HouseHold;
    SymTab[77].symbol:='TOTAL_HOUSEHOLD';
    Symtab[77].tokn:=Total_Household;
    Symtab[78].symbol:='TOTAL_TAX_UNIT';
    Symtab[78].tokn:=Total_Family;
    SymTab[79].symbol:='CASELOAD_CALIBRATION';
    SymTab[79].tokn:=CASELOAD_CALIBRATION;
    SymTab[80].symbol:='SPOUSE''S';
    SymTab[80].tokn:=Spouses;
    SymTab[81].symbol:='HEAD_OF_HOUSEHOLD''S';
    SymTab[81].tokn:=Head_of_Households;
    SymTab[82].symbol:='HEAD_OF_TAX_UNIT''S';
    SymTab[82].tokn:=Head_of_Familys;
    SymTab[83].symbol:='WIFE''S';
    SymTab[83].tokn:=Wifes;
    SymTab[84].symbol:='HUSBAND''S';
    SymTab[84].tokn:=Husbands;
    SymTab[85].symbol:='POINTER';
    SymTab[85].tokn:=Pointer;
    SymTab[86].symbol:='END_OF_POINTER';
    SymTab[86].tokn:=End_of_Pointer;
    SymTab[87].symbol:='WITHDRAWN_BY';
    SymTab[87].tokn:=Withdrawn_By;
    SymTab[88].Symbol:='IS';
    SymTab[88].tokn:=IS_FLAG;
    SymTab[89].Symbol:='MONEY';
    SymTab[89].Tokn:=MONEY;
    SymTab[90].Symbol := 'LESS';
    SymTab[90].Tokn := Less;
    SymTab[91].Symbol := 'PER_YEAR';
    SymTab[91].Tokn := Per_Year;
    SymTab[92].Symbol := 'REAL NUMBER';
    SymTab[92].Tokn := RealNumber;
    SymTab[93].Symbol := 'MULTIPLY FRACTION';
    SymTab[93].Tokn := FracMult;
    SymTab[94].Symbol := 'PER CENT';
    SymTab[94].Tokn := Percent;
    SymTab[95].Symbol := 'START_TAX';
    SymTab[95].Tokn := Start_Tax;
    SymTab[96].Symbol := 'START_BENEFIT';
    SymTab[96].Tokn := Start_Benefit;
    SymTab[97].Symbol := 'END_TAX';
    SymTab[97].Tokn := End_Tax;
    SymTab[98].Symbol := 'END_BENEFIT';
    SymTab[98].Tokn := End_Benefit;
    SymTab[99].Symbol := 'CONSTANT';
    SymTab[99].Tokn := User_Const;
    SymTab[100].Symbol := 'START_CHARGE';
    SymTab[100].Tokn := Start_Charge;
    SymTab[101].Symbol := 'END_CHARGE';
    SymTab[101].Tokn := End_Charge;
    SymTab[102].Symbol := 'START_POLICY';
    SymTab[102].Tokn := Start_Policy;
    SymTab[103].Symbol := 'END_POLICY';
    SymTab[103].Tokn := End_Policy;
    SymTab[104].symbol:='POLICY_TARGET_DATA';
    SymTab[104].tokn:=Policy_Target_Data;
    SymTab[105].Symbol := 'UNIT_COST';
    SymTab[105].Tokn := Unit_Cost;
    SymTab[106].symbol:='UNITS';
    SymTab[106].tokn:=Units;
    SymTab[107].symbol:='DESCRIPTION';
    SymTab[107].tokn:=Description;
    SymTab[108].symbol:='UNKNOWN SYMBOL';
    SymTab[108].tokn:=EOF1;
end;

Procedure Assign_PasTab;
    { This assigns values to the elements of an array which describes all }
    { the valid elements of POM's language.  In each case there is a string}
    { which describes the language element and a number associated with it }
begin
    SymTab[1].symbol:=',';
    PasTab[1].tokn:=COMMA;
    PasTab[2].symbol:='to';
    PasTab[2].tokn:=to1;
    PasTab[3].symbol:='=';
    PasTab[3].tokn:=EQUALS;
    PasTab[4].symbol:='"';
    PasTab[4].tokn:=QUOTE;
    PasTab[5].symbol:=';';
    PasTab[5].tokn:=SEMIC;
    PasTab[6].symbol:='and';
    PasTab[6].tokn:=AND1;
    PasTab[7].symbol:='-';
    PasTab[7].tokn:=MINUS;
    PasTab[8].symbol:='+';
    PasTab[8].tokn:=PLUS;
    PasTab[9].symbol:='or';
    PasTab[9].tokn:=OR1;
    PasTab[10].symbol:='not';
    PasTab[10].tokn:=NOT1;
    PasTab[11].symbol:='(';
    PasTab[11].tokn:=LBRACK;
    PasTab[12].symbol:=')';
    PasTab[12].tokn:=RBRACK;
    PasTab[13].symbol:='}';
    PasTab[13].tokn:=RCURLY;
    PasTab[14].symbol:='{';
    PasTab[14].tokn:=LCURLY;
    PasTab[15].symbol:='';
    PasTab[15].tokn:=FIRST;
    PasTab[16].symbol:='';
    PasTab[16].tokn:=COUNT;
    PasTab[17].symbol:='';
    PasTab[17].tokn:=SUM;
    PasTab[18].symbol:='TO_POWER_OF';
    PasTab[18].tokn:=to_power_of;
    PasTab[19].symbol:='GROSSING_VAR';
    PasTab[19].tokn:=GROSSING_VAR;
    PasTab[20].symbol:='ABS';
    PasTab[20].tokn:=Abs1;
    PasTab[21].symbol:='';
    PasTab[21].tokn:=DATA;
    PasTab[22].symbol:='DIV';
    PasTab[22].tokn:=DIV1;
    PasTab[23].symbol:='*';
    PasTab[23].tokn:=TIMES;
    PasTab[24].symbol:='div0';
    PasTab[24].tokn:=DIVIDE;
    PasTab[25].symbol:='Mod';
    PasTab[25].tokn:=MODULO;
    PasTab[26].symbol:='if';
    PasTab[26].tokn:=IF1;
    PasTab[27].symbol:='then';
    PasTab[27].tokn:=THEN1;
    PasTab[28].symbol:='else';
    PasTab[28].tokn:=ELSE1;
    PasTab[29].symbol:='TARGET_DATA';
    PasTab[29].tokn:=target_data;
    PasTab[30].symbol:='<>';
    PasTab[30].tokn:=NE;
    PasTab[31].symbol:='=';
    PasTab[31].tokn:=EQUALS;
    PasTab[32].symbol:='<>';
    PasTab[32].tokn:=NE;
    PasTab[33].symbol:='>';
    PasTab[33].tokn:=GT;
    PasTab[34].symbol:='>=';
    PasTab[34].tokn:=GE;
    PasTab[35].symbol:='<';
    PasTab[35].tokn:=LT;
    PasTab[36].symbol:='<=';
    PasTab[36].tokn:=LE;
    PasTab[37].symbol:='SOURCE';
    PasTab[37].tokn:=SOURCE;
    PasTab[38].symbol:='RANDOM';
    PasTab[38].tokn:=RANDOM;
    PasTab[39].symbol:='EXP';
    PasTab[39].tokn:=EXP1;
    PasTab[40].symbol:='Ln';
    PasTab[40].tokn:=Per_Month;
    PasTab[41].symbol:=']';
    PasTab[41].tokn:=rsquare;
    PasTab[42].symbol:='[';
    PasTab[42].tokn:=lsquare;
    PasTab[43].symbol:='ARRAY';
    PasTab[43].tokn:=ARRAY1;
    PasTab[44].symbol:='';
    PasTab[44].tokn:=NAME;
    PasTab[45].symbol:='';
    PasTab[45].tokn:=VARLABEL;
    PasTab[46].symbol:='';
    PasTab[46].tokn:=VALUELABEL;
    PasTab[47].symbol:='INTEGER';
    PasTab[47].tokn:= INTEGER1;
    PasTab[48].symbol:='REAL';
    PasTab[48].tokn:=REAL1;
    PasTab[49].symbol:='MONEY';
    PasTab[49].tokn:=MONEY1;
    PasTab[50].symbol:='BOOLEAN';
    PasTab[50].tokn:=BOOLEAN1;
    PasTab[51].symbol:='';
    PasTab[51].tokn:=WIDTH;
    PasTab[52].symbol:='';
    PasTab[52].tokn:=number;
    PasTab[53].symbol:='>';
    PasTab[53].tokn:=GT;
    PasTab[54].symbol:='<';
    PasTab[54].tokn:=LT;
    PasTab[55].symbol:='<>';
    PasTab[55].tokn:=NE;
    PasTab[56].symbol:='>';
    PasTab[56].tokn:=GT;
    PasTab[57].symbol:='>=';
    PasTab[57].tokn:=GE;
    PasTab[58].symbol:='<';
    PasTab[58].tokn:=LT;
    PasTab[59].symbol:='<=';
    PasTab[59].tokn:=LE;
    PasTab[60].symbol:='';
    PasTab[60].tokn:=WRITEVAR;
    PasTab[61].symbol:='Mod';
    PasTab[61].tokn:=MODULO;
    PasTab[62].symbol:='Mod';
    PasTab[62].tokn:=MODULO;
    PasTab[63].symbol:='';
    PasTab[63].tokn:=FullStop;
    PasTab[64].symbol:=':';
    PasTab[64].tokn:=Colon;
    PasTab[65].symbol:='';
    PasTab[65].tokn:=Variable;
    PasTab[66].symbol:='';
    PasTab[66].tokn:=UserVar;
    PasTab[67].symbol:='*';
    PasTab[67].tokn:=TIMES;
    PasTab[68].symbol:='';
    PasTab[68].tokn:=Analysis_Level;
    PasTab[69].symbol:='';
    PasTab[69].tokn:=Individual;
    PasTab[70].symbol:='';
    PasTab[70].tokn:=Family;
    PasTab[71].symbol:='';
    PasTab[71].tokn:=Household;
    PasTab[72].symbol:='';
    PasTab[72].tokn:=End_Anal_Level;
    PasTab[73].symbol:='';
    PasTab[73].tokn:=Number_in_Family;
    PasTab[74].symbol:='';
    PasTab[74].tokn:=Number_in_HouseHold;
    PasTab[75].symbol:='';
    PasTab[75].tokn:=Any_in_Family;
    PasTab[76].symbol:='';
    PasTab[76].tokn:=Any_in_HouseHold;
    PasTab[77].symbol:='';
    PasTab[77].tokn:=Total_Household;
    PasTab[78].symbol:='';
    PasTab[78].tokn:=Total_Family;
    PasTab[79].symbol:='';
    PasTab[79].tokn:=CASELOAD_CALIBRATION;
    PasTab[80].symbol:='';
    PasTab[80].tokn:=Spouses;
    PasTab[81].symbol:='';
    PasTab[81].tokn:=Head_of_Households;
    PasTab[82].symbol:='';
    PasTab[82].tokn:=Head_of_Familys;
    PasTab[83].symbol:='';
    PasTab[83].tokn:=Wifes;
    PasTab[84].symbol:='';
    PasTab[84].tokn:=Husbands;
    PasTab[85].symbol:='';
    PasTab[85].tokn:=Pointer;
    PasTab[86].symbol:='';
    PasTab[86].tokn:=End_of_Pointer;
    PasTab[87].symbol:='';
    PasTab[87].tokn:=Withdrawn_By;
    PasTab[88].Symbol:=':=';
    PasTab[88].tokn:=IS_FLAG;
    PasTab[89].Symbol:='';
    PasTab[89].Tokn:=MONEY;
    PasTab[90].Symbol := 'Less';
    PasTab[90].Tokn := Less;
    PasTab[91].Symbol := '';
    PasTab[91].Tokn := Per_Year;
    PasTab[92].Symbol := '';
    PasTab[92].Tokn := RealNumber;
    PasTab[93].Symbol := '';
    PasTab[93].Tokn := FracMult;
    PasTab[94].Symbol := '';
    PasTab[94].Tokn := Percent;
    PasTab[95].Symbol := 'START_TAX';
    PasTab[95].Tokn := Start_Tax;
    PasTab[96].Symbol := 'START_BENEFIT';
    PasTab[96].Tokn := Start_Benefit;
    PasTab[97].Symbol := 'END_TAX';
    PasTab[97].Tokn := End_Tax;
    PasTab[98].Symbol := 'END_BENEFIT';
    PasTab[98].Tokn := End_Benefit;
    PasTab[99].Symbol := 'CONSTANT';
    PasTab[99].Tokn := User_Const;
    PasTab[100].Symbol := 'START_CHARGE';
    PasTab[100].Tokn := Start_Charge;
    PasTab[101].Symbol := 'END_CHARGE';
    PasTab[101].Tokn := End_Charge;
    PasTab[102].Symbol := 'START_POLICY';
    PasTab[102].Tokn := Start_Policy;
    PasTab[103].Symbol := 'END_POLICY';
    PasTab[103].Tokn := End_Policy;
    PasTab[104].symbol:='POLICY_TARGET_DATA';
    PasTab[104].tokn:=Policy_Target_Data;
    PasTab[105].Symbol := 'UNIT_COST';  
    PasTab[105].Tokn := Unit_Cost;
    PasTab[106].symbol:='UNITS';
    PasTab[106].tokn:=Units;
    PasTab[107].symbol:='DESCRIPTION';
    PasTab[107].tokn:=Description;
    PasTab[108].symbol:='UNKNOWN SYMBOL';
    PasTab[108].tokn:=EOF1;
end;

Procedure InitGlobVars;
Var
   i : integer;

begin
    userfileNum := 0;
    Weight_Mode := 0;
    Above_Text_Area := False;
    Assign_PasTab;
    Assign_SymTab;
    SetMinMaxX(1, 632);
    SetMinMaxY(1, 104);
    Command_Screen_Col := 40;
    Command_Screen_Row := 6;
    for i:= 1 to TotalVars do VarArray[i]:= Nil;
    globerr := false;
    reserve[1]:='MARRIED';
    reserve[2]:='WIFPOS';
    reserve[3]:='HUSPOS';
    reserve[4]:='XCALC1';
    reserve[5]:='XCALC2';
    reserve[6]:='FAMILIES';
    reserve[7]:='NUMBER_IN_HOUSE';
    reserve[8]:='PENSIONABLE';
    reserve[9]:='HOUSEHOLD_TYPE';
    reserve[10]:='INCOME_BAND';
    reserve[11]:='GROSS_INCOME';
    reserve[12]:='NUMBER_IN_FAM';
    reserve[13]:='INDIVUAL_GAIN_OR_LOSS';
    reserve[14]:='FAMILY_GAIN_OR_LOSS';
    reserve[15]:='HOUSEHOLD_GAIN_OR_LOSS';
    reserve[16]:='NET_INCOME_BEFORE';
    reserve[17]:='NET_INCOME_AFTER';
    reserve[19]:='CHANGE_IN_INCOME';
    reserve[20]:='TYPE_OF_FAMILY';
    reserve[21]:='NET_FAMILY_INCOME';
    reserve[22]:='';
end;

Function Reserved_Word(invar : str50):boolean;
var
   cnt : integer;
begin
   cnt := 1;
   while ((Length(Reserve[cnt])>0) and (invar <> Reserve[cnt])) do
       inc(cnt);
   if (Reserve[cnt] = invar) then
       Reserved_Word := True
   else
       Reserved_Word := False;
end;

End.

