unit main;

interface

uses
  Windows, Messages, SynEdit, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, SynEditPrint, SynEditRegexSearch, SynEditMiscClasses,
  SynEditSearch, SynHighlighterAsm, SynHighlighterUNIXShellScript,
  SynHighlighterRuby, SynHighlighterPython, SynHighlighterPerl,
  SynHighlighterBat, SynHighlighterXML, SynHighlighterPHP,
  SynHighlighterJScript, SynHighlighterHtml, SynHighlighterCSS,
  SynHighlighterVB, SynHighlighterPas, SynHighlighterJava,
  SynEditHighlighter, SynHighlighterCpp, ComCtrls, inifiles, strutils,
  XPMan, StdCtrls, InitDat, EdVar, StatVar, ExtCtrls, Dos, ToolStat, TranUtil;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    OpenReadonly1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    Close3: TMenuItem;
    ToggleReadonly1: TMenuItem;
    Fileinfo1: TMenuItem;
    N1: TMenuItem;
    Print1: TMenuItem;
    Printersetup1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    Delete1: TMenuItem;
    N3: TMenuItem;
    Selectall1: TMenuItem;
    SelectNormal1: TMenuItem;
    SelectColumn1: TMenuItem;
    SelectLine1: TMenuItem;
    Search2: TMenuItem;
    Search1: TMenuItem;
    SearchAgain1: TMenuItem;
    SearchBackwards1: TMenuItem;
    Replace1: TMenuItem;
    N4: TMenuItem;
    GototoLine1: TMenuItem;
    View1: TMenuItem;
    ViewinHex1: TMenuItem;
    N6: TMenuItem;
    Addlinenumbers1: TMenuItem;
    ViewCurrentLine1: TMenuItem;
    Wordwrap1: TMenuItem;
    WordCount1: TMenuItem;
    Syntax1: TMenuItem;
    Normal1: TMenuItem;
    CC1: TMenuItem;
    Pascal1: TMenuItem;
    ASM1: TMenuItem;
    XML1: TMenuItem;
    VB1: TMenuItem;
    Perl1: TMenuItem;
    Python1: TMenuItem;
    JavaScript1: TMenuItem;
    HTML1: TMenuItem;
    CSS1: TMenuItem;
    XML2: TMenuItem;
    PHP1: TMenuItem;
    UNIXScript1: TMenuItem;
    DOSBatch1: TMenuItem;
    ools1: TMenuItem;
    Baseconverter1: TMenuItem;
    ASCIITable1: TMenuItem;
    N5: TMenuItem;
    ToLowercase1: TMenuItem;
    ToUppercase1: TMenuItem;
    Capitalize1: TMenuItem;
    Insertdateandtime1: TMenuItem;
    ExecuteCommandLine1: TMenuItem;
    Sort1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    N8: TMenuItem;
    N7: TMenuItem;
    PageControl1: TPageControl;
    SynCppSyn1: TSynCppSyn;
    SynJavaSyn1: TSynJavaSyn;
    SynPasSyn1: TSynPasSyn;
    SynVBSyn1: TSynVBSyn;
    SynCssSyn1: TSynCssSyn;
    SynHTMLSyn1: TSynHTMLSyn;
    SynJScriptSyn1: TSynJScriptSyn;
    SynPHPSyn1: TSynPHPSyn;
    SynXMLSyn1: TSynXMLSyn;
    SynBatSyn1: TSynBatSyn;
    SynPerlSyn1: TSynPerlSyn;
    SynPythonSyn1: TSynPythonSyn;
    SynRubySyn1: TSynRubySyn;
    SynUNIXShellScriptSyn1: TSynUNIXShellScriptSyn;
    SynAsmSyn1: TSynAsmSyn;
    SynEditSearch1: TSynEditSearch;
    SynEditRegexSearch1: TSynEditRegexSearch;
    fPrintOut: TSynEditPrint;
    PopupMenu1: TPopupMenu;
    Cut2: TMenuItem;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    N9: TMenuItem;
    New3: TMenuItem;
    Open3: TMenuItem;
    Save3: TMenuItem;
    SaveAs3: TMenuItem;
    Close2: TMenuItem;
    StatusBar1: TStatusBar;
    OpenFileDialog: TOpenDialog;
    SaveFileDialog: TSaveDialog;
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    Ruby1: TMenuItem;
    FontDialog1: TFontDialog;
    Font1: TMenuItem;
    PopupMenu2: TPopupMenu;
    New2: TMenuItem;
    Open2: TMenuItem;
    Save2: TMenuItem;
    SaveAs2: TMenuItem;
    Close1: TMenuItem;
    XPManifest1: TXPManifest;
    FullScreen1: TMenuItem;
    ShowStatusBar1: TMenuItem;
    IndButton: TButton;
    FamButton: TButton;
    HHoldButton: TButton;
    CatButton: TButton;
    CreatedButton: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Any_in_Household: TButton;
    Number_In_Household: TButton;
    Total_Household: TButton;
    Any_In_Tax_Unit: TButton;
    Number_in_Tax_Unit: TButton;
    Total_Tax_Unit: TButton;
    Head_of_Households: TButton;
    Head_of_Tax_Units: TButton;
    Husbands: TButton;
    Wifes: TButton;
    Panel2: TPanel;
    Label2: TLabel;
    Less: TButton;
    Per_Year: TButton;
    Withdrawn_By: TButton;
    Per_Cent: TButton;
    Panel3: TPanel;
    Label3: TLabel;
    Start_Benefit: TButton;
    End_Benefit: TButton;
    Start_Tax: TButton;
    End_Tax: TButton;
    Button1: TButton;
    ranslate1: TMenuItem;
    Per_Month: TButton;
    Procedure Selwin (Vary : Variable_Array; TitleStr : string);
    procedure Exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure REChange(Sender: TObject);
    procedure EditorKeyPress(Sender: TObject; var Key: Char);
    procedure EditorKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure EditorKeyUp(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure EditorMouseDown(Sender: TObject; Button: TMouseButton;
                              Shift: TShiftState; X, Y: Integer);
    procedure Normal1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CreateNewEditor;
    procedure Open1Click(Sender: TObject);
    procedure SelectSyntax(var Filename: string);
    procedure Save1Click(Sender: TObject);
    procedure Saveas1Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure OpenReadonly1Click(Sender: TObject);
    procedure ToggleReadonly1Click(Sender: TObject);
    procedure Close3Click(Sender: TObject);
    procedure Fileinfo1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Printersetup1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Wordwrap1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Redo1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Selectall1Click(Sender: TObject);
    procedure SelectNormal1Click(Sender: TObject);
    procedure SelectColumn1Click(Sender: TObject);
    procedure SelectLine1Click(Sender: TObject);
    procedure WordCount1Click(Sender: TObject);
    procedure Search1Click(Sender: TObject);
    procedure SearchAgain1Click(Sender: TObject);
    procedure SearchBackwards1Click(Sender: TObject);
    procedure Replace1Click(Sender: TObject);
    procedure GototoLine1Click(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Addlinenumbers1Click(Sender: TObject);
    procedure CC1Click(Sender: TObject);
    procedure Pascal1Click(Sender: TObject);
    procedure ASM1Click(Sender: TObject);
    procedure XML1Click(Sender: TObject);
    procedure XML2Click(Sender: TObject);
    procedure VB1Click(Sender: TObject);
    procedure Perl1Click(Sender: TObject);
    procedure Python1Click(Sender: TObject);
    procedure Ruby1Click(Sender: TObject);
    procedure JavaScript1Click(Sender: TObject);
    procedure HTML1Click(Sender: TObject);
    procedure CSS1Click(Sender: TObject);
    procedure PHP1Click(Sender: TObject);
    procedure UNIXScript1Click(Sender: TObject);
    procedure DOSBatch1Click(Sender: TObject);
    procedure Baseconverter1Click(Sender: TObject);
    procedure ASCIITable1Click(Sender: TObject);
    procedure ToLowercase1Click(Sender: TObject);
    procedure ToUppercase1Click(Sender: TObject);
    procedure Capitalize1Click(Sender: TObject);
    procedure Insertdateandtime1Click(Sender: TObject);
    procedure ExecuteCommandLine1Click(Sender: TObject);
    procedure Sort1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Display(const S: string);
    procedure ViewinHex1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure ViewCurrentLine1Click(Sender: TObject);
    procedure PageControl1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PageControl1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PageControl1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ShowFullScreen(fullscreen: Boolean);
    procedure FullScreen1Click(Sender: TObject);
    procedure ShowStatusBar1Click(Sender: TObject);
    procedure IndbuttonClick(Sender: TObject);
    procedure CreatedButtonClicked(Sender: TObject);
    procedure FamButtonClicked(Sender: TObject);
    procedure HHoldButtClick(Sender: TObject);
    procedure CatButtonClick(Sender: TObject);
    procedure Any_in_HouseholdClick(Sender: TObject);
    procedure Any_In_Tax_UnitClick(Sender: TObject);
    procedure Head_of_HouseholdsClick(Sender: TObject);
    procedure Head_of_Tax_UnitsClick(Sender: TObject);
    procedure HusbandsClick(Sender: TObject);
    procedure Number_In_HouseholdClick(Sender: TObject);
    procedure Number_in_Tax_UnitClick(Sender: TObject);
    procedure Total_HouseholdClick(Sender: TObject);
    procedure Total_Tax_UnitClick(Sender: TObject);
    procedure WifesClick(Sender: TObject);
    Procedure InsertWithBrackets(aString : string);
    Procedure InsertSimple(aString : string);
    procedure LessClick(Sender: TObject);
    procedure Per_CentClick(Sender: TObject);
    procedure Per_YearClick(Sender: TObject);
    procedure Withdrawn_ByClick(Sender: TObject);
    procedure End_BenefitClick(Sender: TObject);
    procedure End_TaxClick(Sender: TObject);
    procedure Start_BenefitClick(Sender: TObject);
    procedure Start_TaxClick(Sender: TObject);
    procedure Translate1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure AdvanceOneWord(Sender: TObject);
    procedure Per_MonthClick(Sender: TObject);
    //procedure EditBeginningLine;
  private
    { Private declarations }
    fSearchFromCaret: boolean;
    procedure WMDropFiles(var msg : TMessage); message WM_DROPFILES;
    procedure DoSearchReplaceText(AReplace: boolean; ABackwards: boolean);
    procedure ShowSearchReplaceDialog(AReplace: boolean);
  public
    { Public declarations }
    Selwin_Selection: string;
    procedure adjustTheCursor;
  end;
  Function Translated(Sender: TObject): boolean;

type
  TDisplayProc = procedure(const s: string) of object;

const
   TAB = #09;
   CR  = #13;
   LF  = #10;
   CRLF = CR + LF;
   SEPARATORS = [' ', '.', ',', '!', '?',';',':', '''', '"', '(', ')',
                 '[', ']', '{', '}', TAB, CR, LF ];
   LOWCHARS = ['a'..'z'];
   UPCHARS = ['A'..'Z'];

var
  Form1: TForm1;
  ActiveRich: TSynEdit = nil;  //Holds the selected ActiveRich
  NumMenu: integer; //keep track of menu item number for bookmarks
  DefaultFont: String;
  DefaultFontSize: integer;
  CurrentFileName: string;
  FirstRun: Boolean;
  highest,
  lowest,
  CurrentVar,
  GUF_no     : integer;

implementation

uses Clipbrd, ShellAPI, Richedit, SynEditTypes, dlgSearchText, dlgReplaceText,
  dlgConfirmReplace, SynEditMiscProcs, gotoline, basec, ascii, cmd, About,
  Unit4;

{$R *.dfm}

var
  replaced:boolean=false;
  gbSearchBackwards: boolean;
  gbSearchCaseSensitive: boolean;
  gbSearchFromCaret: boolean;
  gbSearchSelectionOnly: boolean;
  gbSearchTextAtCaret: boolean;
  gbSearchWholeWords: boolean;
  gbSearchRegex: boolean;

  gsSearchText: string;
  gsSearchTextHistory: string;
  gsReplaceText: string;
  gsReplaceTextHistory: string;
  formw, formh, forml, formt: integer;
  inside_unit_cost_definition: boolean;
  unit_cost_definitions_found: boolean;
  this_charge, this_policy : string;

// take care of the drag and drop files
procedure TForm1.WMDropFiles(var msg : TMessage);
var
  fname: string;
  i, count  : integer;
  dropFileName : array [0..511] of Char;
  MAXFILENAME: integer;
begin
  MAXFILENAME := 511;

  // we check the query for amount of files received
  count := DragQueryFile(msg.WParam, $FFFFFFFF, dropFileName, MAXFILENAME);

  // we process them all
  for i := 0 to count - 1 do
  begin
    DragQueryFile(msg.WParam, i, dropFileName, MAXFILENAME);

    // dropFileName now has the current filename of dropped object.
    fname := dropFileName;
    CreateNewEditor();

    ActiveRich.Lines.LoadFromFile(fname);
    PageControl1.ActivePage.Caption:= fname;
    Application.Title:=ExtractFileName(fname)+' - Citizen Model Policy Editor';
    CurrentFileName:=fname;
    form1.Caption:=Application.Title;
    SelectSyntax(fname);
    StatusBar1.Panels[1].Text:='';
  end;

  // release memory used
  DragFinish(msg.WParam);
  application.BringToFront;
end;


procedure SaveFont(FName: string; Section: string; smFont: TFont);
var
  FStream: TIniFile;
begin
  FStream := TIniFile.Create(FName);
  try
    FStream.WriteString(Section, 'Name', smFont.Name);
    FStream.WriteInteger(Section, 'CharSet', smFont.CharSet);
    FStream.WriteInteger(Section, 'Color', smFont.Color);
    FStream.WriteInteger(Section, 'Size', smFont.Size);
    FStream.WriteInteger(Section, 'Style', Byte(smFont.Style));
  finally
    FStream.Free;
  end;
end;


procedure LoadFont(FName: string; Section: string; smFont: TFont);
var
  FStream: TIniFile;
begin
  FStream := TIniFile.Create(Fname);
  try
    smFont.Name    := FStream.ReadString(Section, 'Name', smFont.Name);
    smFont.CharSet := TFontCharSet(FStream.ReadInteger(Section, 'CharSet', smFont.CharSet));
    smFont.Color   := TColor(FStream.ReadInteger(Section, 'Color', smFont.Color));
    smFont.Size    := FStream.ReadInteger(Section, 'Size', smFont.Size);
    //smFont.Style   := TFontStyles(Byte(FStream.ReadInteger(Section, 'Style', Byte(smFont.Style))));
  finally
    FStream.Free;
  end;
end;

// enter fullscreen mode
procedure TForm1.ShowFullScreen(fullscreen: boolean);
var 
  HTaskbar: HWND; 
  OldVal: LongInt;
begin
  if fullscreen then // show full screen
  begin
    formw:=form1.Width;
    formh:=form1.Height;
    forml:=form1.Left;
    formt:=form1.Top;
    try
     // Find handle of TASKBAR
     HTaskBar := FindWindow('Shell_TrayWnd', nil);
     // Turn SYSTEM KEYS off, Only Win 95/98/ME
     SystemParametersInfo(97, Word(True), @OldVal, 0);
     // Disable the taskbar
     EnableWindow(HTaskBar, False);
     // Hide the taskbar
     ShowWindow(HTaskbar, SW_HIDE);
    finally
      with Form1 do
      begin
       BorderStyle:= bsNone;
       //FormStyle   := fsStayOnTop;
       Left:= 0;
       Top:= 0;
       Height:= Screen.Height;
       Width:= Screen.Width;
      end;
    end
  end
  else  // exit full screen
  begin
    //Find handle of TASKBAR
    HTaskBar := FindWindow('Shell_TrayWnd', nil);
    //Turn SYSTEM KEYS Back ON, Only Win 95/98/ME
    SystemParametersInfo(97, Word(False), @OldVal, 0);
    //Enable the taskbar
    EnableWindow(HTaskBar, True);
    //Show the taskbar
    ShowWindow(HTaskbar, SW_SHOW);
    form1.BorderStyle:=bsSizeable;
    form1.Width:=formw;
    form1.Height:=formh;
    form1.Left:=forml;
    form1.Top:=formt;
    DragAcceptFiles(Handle, true);
  end;
end;


// close the program
procedure TForm1.Exit1Click(Sender: TObject);
begin
  close;
end;

// on change handle for the richedit
procedure TForm1.REChange(Sender: TObject);
var aster:string;
begin
 if (Sender is TSynEdit) then
 begin
   aster:=PageControl1.ActivePage.Caption[Length(PageControl1.ActivePage.Caption)];
   if aster<>'*' then
   begin
      PageControl1.ActivePage.Caption:=PageControl1.ActivePage.Caption+'*';
      StatusBar1.Panels[1].Text:='Modified';
   end;
 end;
 ActiveRich.Modified:=true;
 
 {if Pascal1.Checked then
    ActiveRich.Highlighter:=SynPasSyn1;
 if CC1.Checked then
    ActiveRich.Highlighter:=SynCppSyn1;}
end;


// keypress handler
procedure TForm1.EditorKeyPress(Sender: TObject; var Key: Char);
var line:string;
  linei, col, indent: integer;
  S: String;
begin
  if key = #13 then
  begin
    key := #0;
    with sender as TSynEdit do
    begin
      {figure out line and column position of caret}
      linei := PerForm( EM_EXLINEFROMCHAR, 0, SelStart );
      Col := SelStart - Perform( EM_LINEINDEX, linei, 0 );
      {get part of current line in front of caret}
      S := Copy( lines[ linei ], 1, col );
      {count blanks and tabs in this string}
      indent := 0;
      while (indent < length( S )) and (S[indent + 1] in  [' ', #9]) do
        Inc( indent );
      {insert a linebreak followed by the substring of blanks and tabs}
      SelText := #13#10 + Copy(S, 1, indent);
    end;
  end;

  if ActiveRich.CaretY>999 then //get a bigger panel
  begin
      StatusBar1.Panels[0].Width:=200;
  end;

  line:='  ln ' + inttostr(ActiveRich.CaretY);;
  line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
  StatusBar1.Panels[0].Text:=line;
end;



// key down handler
procedure TForm1.EditorKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var line:string;
begin
  if ActiveRich.CaretY>999 then //get a bigger panel
  begin
      StatusBar1.Panels[0].Width:=200;
  end;

  if (key=$26) or (key=$28) or (key=$25) or (key=$27)then
  begin
    line:='  ln ' + inttostr(ActiveRich.CaretY);;
    line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
    StatusBar1.Panels[0].Text:=line;
  end;

  if (Key=VK_Return) or (Key=VK_Home) then
  begin
    line:='  ln ' + inttostr(ActiveRich.CaretY);;
    line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
    StatusBar1.Panels[0].Text:=line;
  end;

  if (Key=VK_Tab) or (Key=VK_Back) or (Key=VK_Home) or (Key=VK_End) then
  begin
    line:='  ln ' + inttostr(ActiveRich.CaretY);;
    line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
    StatusBar1.Panels[0].Text:=line;
  end;

  line:='  ln ' + inttostr(ActiveRich.CaretY);;
  line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
  StatusBar1.Panels[0].Text:=line;

end;


procedure TForm1.EditorKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);                  
var line:string;
begin

if ActiveRich.CaretY>999 then //get a bigger panel
begin
    StatusBar1.Panels[0].Width:=200;
end;


if (key=$26) or (key=$28) or (key=$25) or (key=$27)then
begin
line:='  ln ' + inttostr(ActiveRich.CaretY);;
line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
  StatusBar1.Panels[0].Text:=line;
end;
if (Key=VK_Return) or (Key=VK_Home) then
begin
line:='  ln ' + inttostr(ActiveRich.CaretY);;
line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
  StatusBar1.Panels[0].Text:=line;
end;
if (Key=VK_Tab) or (Key=VK_Back) or (Key=VK_Home) or (Key=VK_End) then
begin
line:='  ln ' + inttostr(ActiveRich.CaretY);;
line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
  StatusBar1.Panels[0].Text:=line;
end;

end;


// mousedown handler
procedure TForm1.EditorMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var line :string;
begin

  if ActiveRich.CaretY>999 then //get a bigger panel
  begin
     StatusBar1.Panels[0].Width:=200;
  end;

  line:='  ln ' + inttostr(ActiveRich.CaretY);;
  line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
  StatusBar1.Panels[0].Text:=line;
end;


// create a new instance of the richedit
procedure TForm1.CreateNewEditor;
var
t : TTabSheet;  // new tab
r : TSynEdit;   // our richeditor
begin
    InitGlobVars;
    ReadLabels;
    Assign_Variable_Type;
    t:= TTabsheet.Create(self);
    t.PageControl := PageControl1;
    t.parent := PageControl1;
    t.Caption:='Untitled' + inttostr(PageControl1.PageCount);
    t.BorderWidth:=2;
    r := TSynEdit.create(self);
    r.parent := t;
    r.align := alClient;
    r.Font.Name:=DefaultFont;
    r.Font.Size:=DefaultFontSize;
    r.PopupMenu:=PopupMenu1;
    r.WordWrap:=Wordwrap1.Checked;
    r.OnChange:=REChange;
    r.OnKeyDown:=EditorKeyDown;
    r.OnKeyUp:=EditorKeyUp;
    r.OnKeyPress:=EditorKeyPress;
    r.OnMouseDown:=EditorMouseDown;
    //r.PlainText:=true;
    r.HideSelection:=false;
    r.WantTabs:=true;
    r.TabWidth:=8;
    r.Options:=r.Options+[eoTabIndent];
    r.Gutter.Gradient:=true;
    t.show;
    ActiveRich := r;

    if Addlinenumbers1.Checked then
    begin
      ActiveRich.Gutter.LeftOffset:=0;
      ActiveRich.Gutter.Visible:=true;
      ActiveRich.Gutter.AutoSizeDigitCount(ActiveRich.Lines.Count);
      ActiveRich.Gutter.AutoSize:=true;
      ActiveRich.Gutter.ShowLineNumbers:=true;
    end
    else
    begin
       ActiveRich.Gutter.Visible:=false;
       ActiveRich.Gutter.ShowLineNumbers:=false;
    end;

    if ViewCurrentLine1.Checked then
        activerich.ActiveLineColor:=$DFDFDF
    else
        activerich.ActiveLineColor:=clNone;
    StatusBar1.Panels[1].Text:='';
    r.SetFocus;
    Normal1Click(nil);
    Application.Title:=t.Caption+' - Citizen Model Policy Editor';
    Form1.caption:=t.Caption+' - Citizen Model Policy Editor';
    {if PageControl1.PageCount < 1 then
    begin
       PageControl1.ActivePage.Visible:=false;
    end
    else
       PageControl1.ActivePage.Visible:=true;}
end;


// select syntax
procedure TForm1.SelectSyntax(var Filename: string);
var
   ext: string;
begin
      ext:=ExtractFileExt(Filename);
      if LowerCase(ext)='.pas' then
      begin
         ActiveRich.Highlighter:=SynPasSyn1;
         exit;
      end;

      if LowerCase(ext)='.dpr' then
      begin
         ActiveRich.Highlighter:=SynPasSyn1;
         exit;
      end;

      if (LowerCase(ext)='.c') or (LowerCase(ext)='.cpp') or (LowerCase(ext)='.cc')
          or (LowerCase(ext)='.h') then
      begin
         ActiveRich.Highlighter:=SynCppSyn1;
         exit;
      end;

      if LowerCase(ext)='.java' then
      begin
         ActiveRich.Highlighter:=SynJavaSyn1;
         exit;
      end;

      if LowerCase(ext)='.asm' then
      begin
         ActiveRich.Highlighter:=SynAsmSyn1;
         exit;
      end;

      if LowerCase(ext)='.php' then
      begin
         ActiveRich.Highlighter:=SynPHPSyn1;
         exit;
      end;

      if LowerCase(ext)='.pl' then
      begin
         ActiveRich.Highlighter:=SynPerlSyn1;
         exit;
      end;

      if LowerCase(ext)='.py' then
      begin
         ActiveRich.Highlighter:=SynPythonSyn1;
         exit;
      end;

      if (LowerCase(ext)='.html') or (LowerCase(ext)='.htm') then
      begin
         ActiveRich.Highlighter:=SynHTMLSyn1;
         exit;
      end;

      if LowerCase(ext)='.bas' then
      begin
         ActiveRich.Highlighter:=SynVBSyn1;
         exit;
      end;

      if LowerCase(ext)='.css' then
      begin
         ActiveRich.Highlighter:=SynCssSyn1;
         exit;
      end;

      if LowerCase(ext)='.js' then
      begin
         ActiveRich.Highlighter:=SynJScriptSyn1;
         exit;
      end;

      if LowerCase(ext)='.xml' then
      begin
         ActiveRich.Highlighter:=SynXMLSyn1;
         exit;
      end;

      if LowerCase(ext)='.bat' then
      begin
         ActiveRich.Highlighter:=SynBatSyn1;
         exit;
      end;

      if LowerCase(ext)='.rb' then
      begin
         ActiveRich.Highlighter:=SynRubySyn1;
         exit;
      end;
      
      if LowerCase(ext)='.sh' then
      begin
         ActiveRich.Highlighter:=SynUNIXShellScriptSyn1;
         exit;
      end;

end;

// create a new editor
procedure TForm1.New1Click(Sender: TObject);
var
      tempName : string;
begin
      //  ***************** DELETE CODE BETWEEN STARS
      //  restore last two lines of function
      tempName := 'C:\POM\MODEL2006.PSL';
      CreateNewEditor;
      PageControl1.ActivePage.Caption:= tempName;
      Application.Title:=tempName + ' - Citizen Model Policy Editor';
      Form1.Caption:=Application.Title;
      // SelectSyntax(name);
      ActiveRich.Lines.LoadFromFile(tempName);
      CurrentFileName := tempName;
    // *******************
   //CreateNewEditor;
   //CurrentFileName := 'Untitled.txt';
end;


// create with normal syntax
procedure TForm1.Normal1Click(Sender: TObject);
begin
  if not Normal1.Checked then
  begin
    Normal1.Checked:=true;
    ActiveRich.Highlighter:=nil;
  end;
end;


// on create handle
procedure TForm1.FormCreate(Sender: TObject);
var
  IniFile : TIniFile;
  thefont : tfont;
begin
  FirstRun:=true;
  DragAcceptFiles(Handle, true);
  DefaultFont := 'Courier New';
  DefaultFontSize := 14;
  thefont:=TFont.Create;

  if FileExists(extractfilepath(application.ExeName)+'\eedit.ini') then
  begin
     LoadFont(ExtractFilePath(Application.ExeName) + '\eedit.ini', 'Font', thefont);
     DefaultFont := thefont.Name;
     DefaultFontSize := thefont.Size;
     IniFile := TIniFile.Create(extractfilepath(application.ExeName)+'\eedit.ini');
     form1.left:=IniFile.ReadInteger('Options','Lpos',Left);
     form1.Top:=IniFile.ReadInteger('Options','Tpos',Top+50);
     form1.Width:=IniFile.ReadInteger('Options','Width',Width);
     form1.Height:=IniFile.ReadInteger('Options','Height',Height);
     Addlinenumbers1.Checked:=IniFile.ReadBool('Options','LineNum',FALSE);
     ViewCurrentLine1.Checked:=IniFile.ReadBool('Options','CurrentLine',TRUE);
     Wordwrap1.Checked:=IniFile.ReadBool('Options','WordWrap',FALSE);
     StatusBar1.Visible:=IniFile.ReadBool('Options','StatusBar',TRUE);
     ShowStatusBar1.Checked:=IniFile.ReadBool('Options','StatusBar',TRUE);
     IniFile.Free;
  end;
  thefont.Destroy;
end;


// show handle
procedure TForm1.FormShow(Sender: TObject);
var
  i:integer;
  filename: string;
begin
  if FirstRun then
  begin
    if paramcount<>0 then
    begin
      //PageControl1.ActivePage.Destroy;
      for i:=1 to paramcount do
      begin
        filename := paramstr(i);
        CreateNewEditor;
        ActiveRich.Lines.LoadFromFile(filename);
        PageControl1.ActivePage.Caption := filename;
        StatusBar1.Panels[1].Text:='';
        SelectSyntax(filename);
        form1.Caption:= filename + ' Citizen Model Policy Editor';
        Application.Title:=filename + ' Citizen Model Policy Editor';
        CurrentFileName:=filename;
      end;
    end
    else
      New1Click(Sender);

     FirstRun:=false;
  end;

  ActiveRich.SetFocus;
end;


// open a new file
procedure TForm1.Open1Click(Sender: TObject);
var
  name: string;
begin
    if OpenFileDialog.Execute then
    begin
      // HERETHIS
      name := OpenFileDialog.FileName;
      CreateNewEditor;
      PageControl1.ActivePage.Caption:= OpenFileDialog.FileName;
      Application.Title:=ExtractFileName(OpenFileDialog.FileName)+
                         ' - Citizen Model Policy Editor';
      Form1.Caption:=Application.Title;
      SelectSyntax(name);
      ActiveRich.Lines.LoadFromFile(OpenFileDialog.FileName);
      CurrentFileName := name;
    end;
    StatusBar1.Panels[1].Text:='';
end;


// save the file
procedure TForm1.Save1Click(Sender: TObject);
var
  name, tmp, aster:string;
  j:integer;
begin
  tmp:='';
  name:=PageControl1.ActivePage.Caption;
  for j:=1 to length(name) do
  begin
    tmp:=tmp+name[j];
    if j=8 then break;
  end;

  if tmp='Untitled' then
  begin
     Saveas1Click(sender);
  end
  else
  begin
    name:='';
    aster:=PageControl1.ActivePage.Caption[Length(PageControl1.ActivePage.Caption)];
    if aster='*' then
    begin
      for j:=1 to Length(PageControl1.ActivePage.Caption)-1 do
        name:=name+PageControl1.activepage.Caption[j];

      PageControl1.ActivePage.Caption := name;
      ActiveRich.Lines.SaveToFile(name);
      Application.Title:=ExtractFileName(PageControl1.ActivePage.Caption)+
                     ' - Citizen Model Policy Editor';
      Form1.caption:=Application.Title;
      StatusBar1.Panels[1].Text:='Wrote '+name;
      ActiveRich.Modified := false;
      SelectSyntax(name);
    end;
  end;
end;


// save as handler
procedure TForm1.Saveas1Click(Sender: TObject);
var
  j:integer;
  name, aster:string;
begin
  name:='';
  aster:=PageControl1.ActivePage.Caption[Length(PageControl1.ActivePage.Caption)];
  if aster='*' then
  begin
    for j:=1 to Length(PageControl1.ActivePage.Caption)-1 do
      name:=name+PageControl1.activepage.Caption[j];
  end
  else
     name:=PageControl1.ActivePage.Caption;
     
  SaveFileDialog.FileName:=name;
  if SaveFileDialog.Execute then
  begin
    ActiveRich.Lines.SaveToFile(SaveFileDialog.FileName);
    PageControl1.ActivePage.Caption:=SaveFileDialog.FileName;
    StatusBar1.Panels[1].Text:='Wrote '+SaveFileDialog.FileName;
    Application.Title:=ExtractFileName(PageControl1.ActivePage.Caption)+
                     ' - Citizen Model Policy Editor';
    form1.Caption:=Application.Title;                     
    ActiveRich.Modified:=false;
    name := SaveFileDialog.FileName;
    SelectSyntax(name);
  end;
end;

// when we change to another tab
procedure TForm1.PageControl1Change(Sender: TObject);
var
  i : Integer;
begin
  if PageControl1.PageCount > 0 then
  begin
    for i := 0 to PageControl1.ActivePage.ControlCount - 1 do
      if (PageControl1.ActivePage.Controls[i] is TSynEdit) then
      begin
          ActiveRich := TSynEdit(PageControl1.ActivePage.Controls[i]);
          if ActiveRich.WordWrap=false then
             Wordwrap1.Checked:=false
          else
             Wordwrap1.Checked:=true;
      end;
      Application.Title:=ExtractFileName(PageControl1.ActivePage.Caption)+
                     ' - Citizen Model Policy Editor';
      form1.caption:=Application.Title;
      if ActiveRich.Modified then
        StatusBar1.Panels[1].Text:='Modified'
      else
        StatusBar1.Panels[1].Text:='';
  end;
end;

// open read-only
procedure TForm1.OpenReadonly1Click(Sender: TObject);
begin
   Open1Click(Sender);
   ActiveRich.ReadOnly:=true;
end;

// toggle read-only
procedure TForm1.ToggleReadonly1Click(Sender: TObject);
begin
  if ToggleReadonly1.Checked then
  begin
    ActiveRich.ReadOnly:=false;
    StatusBar1.Panels[1].Text:='Read-only is OFF';
    ToggleReadonly1.Checked:=False;
  end
  else
  begin
    ActiveRich.ReadOnly:=true;
    StatusBar1.Panels[1].Text:='Read-only is ON';
    ToggleReadonly1.Checked:=true;
  end;
end;


// close file
procedure TForm1.Close3Click(Sender: TObject);
const
  SWarningText = 'Save changes to %s?';
var
  name: string;
  i,j: Integer;
begin

  if ActiveRich.Modified then
  begin
     for j:=1 to Length(PageControl1.ActivePage.Caption)-1 do
        name:=name+PageControl1.activepage.Caption[j];

     case MessageDlg(Format(SWarningText, [name]), mtConfirmation,
          [mbYes, mbNo, mbCancel], 0) of
            idYes: Save1Click(Self);
            idCancel: begin
                        exit;
                      end;
     end;
  end;

  if PageControl1.PageCount<2 then
  begin
     ActiveRich.Lines.Clear;
     ActiveRich.Modified:=false;
     PageControl1.ActivePage.Caption:='Untitled'+inttostr(PageControl1.PageCount);
     Application.Title:=PageControl1.ActivePage.Caption+' - Citizen Model Policy Editor';
     form1.Caption:=Application.Title;
  end
  else
  begin
     PageControl1.ActivePage.Destroy;
     PageControl1.SelectNextPage(false); //gp to the previous tab
     if PageControl1.PageCount > 0 then
       for i := 0 to PageControl1.ActivePage.ControlCount - 1 do
         if (PageControl1.ActivePage.Controls[i] is TSynEdit) then
         begin
           ActiveRich := TSynEdit(PageControl1.ActivePage.Controls[i]);
           Application.Title:=ExtractFileName(PageControl1.ActivePage.Caption)+
                              ' - Citizen Model Policy Editor';
           form1.Caption:=Application.Title;
         end;
  end;

end;

Procedure ShowMessage1(Instring1 : String78);
      { Show a message on the upper half of the screen }
      { centring each line in a temporary pop up window }
var
 //  Line1,
  // TemSt,
  // St1    : String78;
   msgString : string;
  // Ch : char;
  // LeadSpaces : integer;


Begin
    msgString:= concat(Instring1,'.  ');
    MessageDlg(Format(msgString, [name]), mtConfirmation,
          [mbYes], 0);

end;

Procedure ShowMessage(Instring1 : String78; Instring2: String78;
                       Instring3 : String78);
      { Show a message on the upper half of the screen }
      { centring each line in a temporary pop up window }
var
   Line1,
   TemSt,
   St1    : String78;
   msgString : string;
   Ch : char;
   LeadSpaces : integer;


Begin
    msgString:= concat(Instring1,' ');
    msgString:= concat(msgString, Instring2);
    msgString:= concat(msgString,' ');
    msgString:= concat(msgString, Instring3);
    msgString:= concat(msgString,' ');
    MessageDlg(Format(msgString, [name]), mtConfirmation,
          [mbOK], 0);

end;

// show file info
procedure TForm1.Fileinfo1Click(Sender: TObject);
var 
  MyS: TWin32FindData; 
  FName: string; 
  MyTime: TFileTime; 
  MySysTime: TSystemTime;                      //PageControl1.ActivePage.Caption
  info: TStrings;
begin
 try
   info:=TStringList.Create;
   FName:=CurrentFileName;
   info.Add('File - '+FName);
   with info do
   begin
    Add('Directory - '+ExtractFileDir(FName));
    Add('Drive - '+ExtractFileDrive(FName));
    Add('Extension - '+ExtractFileExt(FName));
    Add('File name - '+ExtractFileName(FName));
    Add('Path - '+ExtractFilePath(FName));
    Add('');
    FindFirstFile(PChar(FName), MyS);
    case MyS.dwFileAttributes of
      FILE_ATTRIBUTE_COMPRESSED: Add('Attribute - File is compressed');
      FILE_ATTRIBUTE_HIDDEN: Add('Attribute - File is hidden');
      FILE_ATTRIBUTE_NORMAL: Add('Attribute - File has no any attributes');
      FILE_ATTRIBUTE_READONLY: Add('Attribute - Read only file');
      FILE_ATTRIBUTE_SYSTEM: Add('Attribute - System file');
      FILE_ATTRIBUTE_TEMPORARY: Add('Attribute - File for temporary storage');
      FILE_ATTRIBUTE_ARCHIVE: Add('Attribute - Normal file');
    end;
    MyTime:=MyS.ftCreationTime;
    FileTimeToSystemTime(MyTime, MySysTime);
    Add(
      'Time Creation - '+
      IntToStr(MySysTime.wDay)+'.'+
      IntToStr(MySysTime.wMonth)+'.'+
      IntToStr(MySysTime.wYear)+'  '+
      IntToStr(MySysTime.wHour)+':'+
      IntToStr(MySysTime.wMinute));
    MyTime:=MyS.ftLastAccessTime;
    FileTimeToSystemTime(MyTime, MySysTime);
    Add(
      'Last time access - '+
      IntToStr(MySysTime.wDay)+'.'+
      IntToStr(MySysTime.wMonth)+'.'+
      IntToStr(MySysTime.wYear));

    Add('Size - '+IntToStr(MyS.nFileSizeLow)+' bytes');
    Add('Alternate name - '+StrPas(MyS.cAlternateFileName));
    ShowMessage1(info.Text);
    info.Free;
   end;
 except
   on Ex: Exception do MessageDlg( Ex.Message, mtError, [mbOK], 0 );
 end;
end;


// Print the file
procedure TForm1.Print1Click(Sender: TObject);
begin
  // set all properties because this can affect pagination
  fPrintOut.Title:=PageControl1.ActivePage.Caption;
  fPrintOut.Lines:=ActiveRich.Lines;
  fPrintOut.Font:=ActiveRich.Font;
  fPrintOut.Header.Clear;
  fPrintOut.Header.Add(extractfilename(fPrintOut.Title), nil, taCenter, 1);
  fPrintOut.Footer.Clear;
  fPrintOut.Footer.Add('$PAGENUM$/$PAGECOUNT$', nil, taRightJustify, 1 );
  fPrintOut.Highlighter := ActiveRich.Highlighter;
  //fPrintOut.LineNumbers := cbPrintLineNumbers.Checked;
  fPrintOut.Wrap := true;//
  // show print setup dialog and print
  with PrintDialog1 do
  begin
    MinPage := 1;
    FromPage := 1;
    MaxPage := fPrintOut.PageCount;
    ToPage := MaxPage;
    if Execute then
    begin
      fPrintOut.Copies := Copies;
      case PrintRange of
        prAllPages: fPrintOut.Print;
        prPageNums: fPrintOut.PrintRange(FromPage, ToPage);
      end;
    end;
  end;
end;

// show printer options
procedure TForm1.Printersetup1Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
const
  SWarningText = 'Save changes to %s?';
var
   i:integer;
   name:string;
   IniFile : TIniFile;

begin
    SaveFont(ExtractFilePath(Application.EXEName) + 'eedit.ini', 'Font', ActiveRich.Font);
    IniFile := TIniFile.Create(extractfilepath(application.ExeName)+'eedit.ini');
    IniFile.WriteInteger('Options','Lpos',form1.left);
    IniFile.WriteInteger('Options','Tpos',form1.top);
    IniFile.WriteInteger('Options','Width',form1.Width);
    IniFile.WriteInteger('Options','Height',form1.Height);
    IniFile.WriteBool('Options','LineNum',Addlinenumbers1.Checked);
    IniFile.WriteBool('Options','CurrentLine',ViewCurrentLine1.Checked);
    IniFile.WriteBool('Options','WordWrap',Wordwrap1.Checked);
    IniFile.WriteBool('Options','StatusBar',StatusBar1.Visible);
    IniFile.Free;

    while PageControl1.PageCount>0 do
    begin
      if ActiveRich.Modified then
      begin

        name:=LeftStr(PageControl1.activepage.Caption, Length(PageControl1.activepage.Caption)-1);
        case MessageDlg(Format(SWarningText, [name]), mtConfirmation,
          [mbYes, mbNo, mbCancel], 0) of
          idYes:Save1Click(Self);
          idCancel: begin
                    CanClose := False;
                    exit;
                    end
        end;
      end;

      PageControl1.ActivePage.Destroy;
      if PageControl1.PageCount > 0 then
       for i := 0 to PageControl1.ActivePage.ControlCount - 1 do
         if (PageControl1.ActivePage.Controls[i] is TSynEdit) then
         begin
           ActiveRich := TSynEdit(PageControl1.ActivePage.Controls[i]);
         end;
    end;
end;


// on close handle
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 DragAcceptFiles(Handle, false);
end;


// shortcuts for the form
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var line:string;
begin
// disable beep
SystemParametersInfo(SPI_SETBEEP, Word(False), nil, 0);

  if (shift=([ssCTRL])) and (key=VK_TAB) then //ctrl-tab next tab
  begin
      PageControl1.SelectNextPage(true);
      key:=0;
  end;

  if (shift=([ssCTRL])) and (key=$54) then //ctrl-t alternative to new tab
  begin
      New1Click(sender);
      key:=0;
  end;

  if (ActiveRich.ReadOnly) and (key=VK_Space) then
  begin
    sendmessage(ActiveRich.Handle, WM_VSCROLL, SB_PAGEDOWN,0);
    key:=0;
  end;


  line:='  ln ' + inttostr(ActiveRich.CaretY);;
  line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
  StatusBar1.Panels[0].Text:=line;
end;


// take care of thw word wrap
procedure TForm1.Wordwrap1Click(Sender: TObject);
begin
  if Wordwrap1.Checked then
  begin
     Wordwrap1.Checked:=false;
     ActiveRich.WordWrap:=false;
  end
  else
  begin
     Wordwrap1.Checked:=true;
     ActiveRich.WordWrap:=true;
  end;
end;



procedure TForm1.Cut1Click(Sender: TObject);
var
  line:string;
begin
    if ActiveRich.ReadOnly then exit;
        ActiveRich.CutToClipboard;

    if ActiveRich.CaretY>999 then //get a bigger panel
    begin
        StatusBar1.Panels[0].Width:=200;
    end;

    line:='  ln ' + inttostr(ActiveRich.CaretY);;
    line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
    StatusBar1.Panels[0].Text:=line;
end;



procedure TForm1.Copy1Click(Sender: TObject);
begin
  ActiveRich.CopyToClipboard;
end;



procedure TForm1.Paste1Click(Sender: TObject);
var
  line:string;
begin
  if ActiveRich.ReadOnly then exit;

  ActiveRich.SelText:=clipboard.AsText;
  if ActiveRich.CaretY>999 then //get a bigger panel
  begin
      StatusBar1.Panels[0].Width:=200;
  end;

  line:='  ln ' + inttostr(ActiveRich.CaretY);;
  line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
  StatusBar1.Panels[0].Text:=line;
end;


procedure TForm1.Undo1Click(Sender: TObject);
var
  line:string;
begin
    ActiveRich.Undo;
    if ActiveRich.CaretY>999 then //get a bigger panel
    begin
        StatusBar1.Panels[0].Width:=200;
    end;

    line:='  ln ' + inttostr(ActiveRich.CaretY);;
    line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
    StatusBar1.Panels[0].Text:=line;
end;

procedure TForm1.Redo1Click(Sender: TObject);
var
  line:string;
begin
    ActiveRich.Redo;
    if ActiveRich.CaretY>999 then //get a bigger panel
    begin
        StatusBar1.Panels[0].Width:=200;
    end;

    line:='  ln ' + inttostr(ActiveRich.CaretY);;
    line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
    StatusBar1.Panels[0].Text:=line;
end;


procedure TForm1.Delete1Click(Sender: TObject);
var
  line:string;
begin
  if ActiveRich.ReadOnly then exit;
    ActiveRich.ClearSelection;

  if ActiveRich.CaretY>999 then //get a bigger panel
  begin
    StatusBar1.Panels[0].Width:=200;
  end;

  line:='  ln ' + inttostr(ActiveRich.CaretY);;
  line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
  StatusBar1.Panels[0].Text:=line;
end;


procedure TForm1.Selectall1Click(Sender: TObject);
var
  line:string;
begin
  ActiveRich.SelectAll;

  if ActiveRich.CaretY>999 then //get a bigger panel
  begin
    StatusBar1.Panels[0].Width:=200;
  end;

  line:='  ln ' + inttostr(ActiveRich.CaretY);;
  line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
  StatusBar1.Panels[0].Text:=line;
end;


procedure TForm1.SelectNormal1Click(Sender: TObject);
begin
  ActiveRich.SelectionMode:=smNormal;
end;


procedure TForm1.SelectColumn1Click(Sender: TObject);
begin
  ActiveRich.SelectionMode:=smColumn;
end;




procedure TForm1.SelectLine1Click(Sender: TObject);
begin
  ActiveRich.SelectionMode:=smLine;
end;


procedure scrollthroughdelims( s : string; var i : integer );
begin
   while (s[i] in SEPARATORS) and (i <= Length(s)) do INC(i);
end;

procedure scrollthroughword( s : string; var w : string; var i : integer );
begin
   w := '';
   while (not (s[i] in SEPARATORS)) and ( i <= Length(s)) do
   begin
      w := w + s[i];
      INC(i);
   end;
end;

function countwords( const s : string ) : integer;
var
   i, wordnum : integer;
   w : string;
begin
   i := 1;
   wordnum := 0;
   w := '';
      while ( i <= Length(s) ) do
      begin
         scrollthroughdelims( s, i );
         scrollthroughword( s, w, i );
         if (Length(w) > 0) then
            INC(wordnum);
      end;
   result := wordnum;
end;

procedure TForm1.WordCount1Click(Sender: TObject);
var
   wordnum : integer;
   numlines : integer;
   lineindex : integer;
begin
   wordnum := 0;
   if ActiveRich.SelLength > 0 then
      ShowMessage1('Words in selected text: '+IntToStr(countwords(ActiveRich.SelText)))
   else
   begin
      numlines := ActiveRich.Lines.Count;
      for lineindex := 0 to numlines - 1 do
         wordnum := wordnum + countwords(ActiveRich.Lines.Strings[lineindex] );
      ShowMessage1(Format('Lines: %d, words: %d.',[numlines,wordnum]));
   end;
end;


procedure TForm1.DoSearchReplaceText(AReplace: boolean;
  ABackwards: boolean);
var
  Options: TSynSearchOptions;
begin
  if AReplace then
    Options := [ssoPrompt, ssoReplace, ssoReplaceAll]
  else
    Options := [];
  if ABackwards then
    Include(Options, ssoBackwards);
  if gbSearchCaseSensitive then
    Include(Options, ssoMatchCase);
  if not fSearchFromCaret then
    Include(Options, ssoEntireScope);
  if gbSearchSelectionOnly then
    Include(Options, ssoSelectedOnly);
  if gbSearchWholeWords then
    Include(Options, ssoWholeWord);
  if gbSearchRegex then
    ActiveRich.SearchEngine := SynEditRegexSearch1
  else
    ActiveRich.SearchEngine := SynEditSearch1;
  if ActiveRich.SearchReplace(gsSearchText, gsReplaceText, Options) = 0 then
  begin
    MessageDlg('Unable to find "'+ gsSearchText +
               '"', mtInformation, [mbOK], 0);
    if ssoBackwards in Options then
      ActiveRich.BlockEnd := ActiveRich.BlockBegin
    else
      ActiveRich.BlockBegin := ActiveRich.BlockEnd;
    ActiveRich.CaretXY := ActiveRich.BlockBegin;
  end;

  if ConfirmReplaceDialog <> nil then
    ConfirmReplaceDialog.Free;
end;

procedure Delay(dwMilliseconds: Longint);
var
  iStart, iStop: DWORD;
begin
  iStart := GetTickCount;
  repeat
    iStop := GetTickCount;
    Application.ProcessMessages;
  until (iStop - iStart) >= dwMilliseconds;
end;

procedure TForm1.adjustTheCursor;
var
  tempResult : string;
  currline:string;
  CaretNew: TBufferCoord;
begin
  currline:='  ln ' + inttostr(ActiveRich.CaretY);
  currline:=currline + ' col ' + inttostr(CaretNew.Char);
  StatusBar1.Panels[0].Text:=currline;
 // ActiveRich.showTheCursor;
 // ActiveRich.SetFocus;
  //ActiveRich.Modified:=true;
end;

procedure TForm1.AdvanceOneWord(Sender: TObject);
var
  tempResult : string;
  currline:string;
  CaretNew: TBufferCoord;
begin
  tempResult := ActiveRich.GetWordAtRowCol(ActiveRich.CaretXY);
  if (Length(tempResult)>0) then
      CaretNew := ActiveRich.NextWordPos
  else
      CaretNew := ActiveRich.SkipWhiteSpace;
  tempResult := ActiveRich.GetWordAtRowCol(CaretNew);
  ActiveRich.advanceWord;
  // Not Here!!
 // currline:='  ln ' + inttostr(ActiveRich.CaretY);
 // currline:=currline + ' col ' + inttostr(CaretNew.Char);
 // StatusBar1.Panels[0].Text:=currline;
 // ActiveRich.showTheCursor;
 // ActiveRich.SetFocus;
  //ActiveRich.Modified:=true;
end;


procedure TForm1.ShowSearchReplaceDialog(AReplace: boolean);
var
  dlg: TTextSearchDialog;
begin
  if AReplace then
    dlg := TTextReplaceDialog.Create(Self)
  else
    dlg := TTextSearchDialog.Create(Self);
  with dlg do try
    // assign search options
    SearchBackwards := gbSearchBackwards;
    SearchCaseSensitive := gbSearchCaseSensitive;
    SearchFromCursor := gbSearchFromCaret;
    SearchInSelectionOnly := gbSearchSelectionOnly;
    // start with last search text
    SearchText := gsSearchText;
    if gbSearchTextAtCaret then begin
      // if something is selected search for that text
      if ActiveRich.SelAvail and (ActiveRich.BlockBegin.Line = ActiveRich.BlockEnd.Line)
      then
        SearchText := ActiveRich.SelText
      else
        SearchText := ActiveRich.GetWordAtRowCol(ActiveRich.CaretXY);
    end;
    SearchTextHistory := gsSearchTextHistory;
    if AReplace then with dlg as TTextReplaceDialog do begin
      ReplaceText := gsReplaceText;
      ReplaceTextHistory := gsReplaceTextHistory;
    end;

    SearchText := ActiveRich.SelText;

    SearchWholeWords := gbSearchWholeWords;
    if ShowModal = mrOK then begin
      gbSearchBackwards := SearchBackwards;
      gbSearchCaseSensitive := SearchCaseSensitive;
      gbSearchFromCaret := SearchFromCursor;
      gbSearchSelectionOnly := SearchInSelectionOnly;
      gbSearchWholeWords := SearchWholeWords;
      gbSearchRegex := SearchRegularExpression;
      gsSearchText := SearchText;
      gsSearchTextHistory := SearchTextHistory;
      if AReplace then with dlg as TTextReplaceDialog do begin
        gsReplaceText := ReplaceText;
        gsReplaceTextHistory := ReplaceTextHistory;
      end;
      fSearchFromCaret := gbSearchFromCaret;
      if gsSearchText <> '' then begin
        DoSearchReplaceText(AReplace, gbSearchBackwards);
        fSearchFromCaret := TRUE;
      end;
    end;
  finally
    dlg.Free;
  end;
end;


procedure TForm1.Search1Click(Sender: TObject);
begin
  ShowSearchReplaceDialog(FALSE);
end;



procedure TForm1.SearchAgain1Click(Sender: TObject);
begin
  DoSearchReplaceText(FALSE, FALSE);
end;

procedure TForm1.SearchBackwards1Click(Sender: TObject);
begin
  DoSearchReplaceText(FALSE, TRUE);
end;

procedure TForm1.Replace1Click(Sender: TObject);
begin
  if ActiveRich.ReadOnly then exit;
  ShowSearchReplaceDialog(TRUE);//ReplaceDialog1.Execute;
end;



procedure TForm1.GototoLine1Click(Sender: TObject);
var
  line:integer;
  currline:string;
begin
  if form2.showmodal=mrOK then
  begin
    line:=strtoint(form2.Edit1.Text);
    ActiveRich.GotoLineAndCenter(line);
  end;

  currline:='  ln ' + inttostr(ActiveRich.CaretY);
  currline:=currline + ' col ' + inttostr(ActiveRich.CaretX);
  StatusBar1.Panels[0].Text:=currline;

end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var line:string;
begin
  if (key=VK_PRIOR) or (key=VK_NEXT) then
  begin
    line:='  ln ' + inttostr(ActiveRich.CaretY);;
    line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
    StatusBar1.Panels[0].Text:=line;
  end;

 // enable beep
SystemParametersInfo(SPI_SETBEEP, Word(true), nil, 0);
end;

procedure TForm1.Addlinenumbers1Click(Sender: TObject);
begin
  ActiveRich.Gutter.Font:=ActiveRich.Font;
  if Addlinenumbers1.Checked then
  begin
    ActiveRich.Gutter.LeftOffset:=0;
    ActiveRich.Gutter.Visible:=true;
    ActiveRich.Gutter.AutoSizeDigitCount(ActiveRich.Lines.Count);
    ActiveRich.Gutter.AutoSize:=true;
    ActiveRich.Gutter.ShowLineNumbers:=true;
  end
  else
  begin
    ActiveRich.Gutter.Visible:=false;
    ActiveRich.Gutter.ShowLineNumbers:=false;
  end;
end;

procedure TForm1.CC1Click(Sender: TObject);
begin
  if not CC1.Checked then
  begin
    CC1.Checked:=true;
    ActiveRich.Highlighter:=SynCppSyn1;
  end;
end;

procedure TForm1.Pascal1Click(Sender: TObject);
begin
  if not Pascal1.Checked then
  begin
    Pascal1.Checked:=true;
    ActiveRich.Highlighter:=SynPasSyn1;
  end;
end;



procedure TForm1.ASM1Click(Sender: TObject);
begin
  if not ASM1.Checked then
  begin
    ASM1.Checked:=true;
    ActiveRich.Highlighter:=SynAsmSyn1;
  end;

end;

procedure TForm1.XML1Click(Sender: TObject);
begin
  if not XML1.Checked then
  begin
    XML1.Checked:=true;
    ActiveRich.Highlighter:=SynJavaSyn1;
  end;

end;

procedure TForm1.XML2Click(Sender: TObject);
begin
  if not XML2.Checked then
  begin
    XML2.Checked:=true;
    ActiveRich.Highlighter:=SynXMLSyn1;
  end;

end;

procedure TForm1.VB1Click(Sender: TObject);
begin
  if not VB1.Checked then
  begin
    VB1.Checked:=true;
    ActiveRich.Highlighter:=SynVBSyn1;
  end;
end;

procedure TForm1.Perl1Click(Sender: TObject);
begin
  if not Perl1.Checked then
  begin
    Perl1.Checked:=true;
    ActiveRich.Highlighter:=SynPerlSyn1;
  end;

end;

procedure TForm1.Python1Click(Sender: TObject);
begin
  if not Python1.Checked then
  begin
    Python1.Checked:=true;
    ActiveRich.Highlighter:=SynPythonSyn1;
  end;

end;

procedure TForm1.Ruby1Click(Sender: TObject);
begin
  if not Ruby1.Checked then
  begin
    Ruby1.Checked:=true;
    ActiveRich.Highlighter:=SynRubySyn1;
  end;

end;

procedure TForm1.JavaScript1Click(Sender: TObject);
begin
  if not JavaScript1.Checked then
  begin
    JavaScript1.Checked:=true;
    ActiveRich.Highlighter:=SynJScriptSyn1;
  end;

end;

procedure TForm1.HTML1Click(Sender: TObject);
begin
  if not HTML1.Checked then
  begin
    HTML1.Checked:=true;
    ActiveRich.Highlighter:=SynHTMLSyn1;
  end;

end;

procedure TForm1.CSS1Click(Sender: TObject);
begin
  if not CSS1.Checked then
  begin
    CSS1.Checked:=true;
    ActiveRich.Highlighter:=SynCssSyn1;
  end;

end;

procedure TForm1.PHP1Click(Sender: TObject);
begin
  if not PHP1.Checked then
  begin
    PHP1.Checked:=true;
    ActiveRich.Highlighter:=SynPHPSyn1;
  end;

end;

procedure TForm1.UNIXScript1Click(Sender: TObject);
begin
  if not UNIXScript1.Checked then
  begin
    UNIXScript1.Checked:=true;
    ActiveRich.Highlighter:=SynUNIXShellScriptSyn1;
  end;

end;

procedure TForm1.DOSBatch1Click(Sender: TObject);
begin
  if not DOSBatch1.Checked then
  begin
    DOSBatch1.Checked:=true;
    ActiveRich.Highlighter:=SynBatSyn1;
  end;

end;

procedure TForm1.Baseconverter1Click(Sender: TObject);
begin
  baseconv.show;
end;

procedure TForm1.ASCIITable1Click(Sender: TObject);
begin
  asciiform.show
end;

procedure TForm1.ToLowercase1Click(Sender: TObject);
var what:string;
begin
  if ActiveRich.ReadOnly then exit;
  if ActiveRich.SelLength>0 then
  begin
    what:=ActiveRich.SelText;
    ActiveRich.SelText:=LowerCase(what);
    REChange(ActiveRich);
  end;
end;

procedure TForm1.ToUppercase1Click(Sender: TObject);
var what:string;
begin
  if ActiveRich.ReadOnly then exit;
  if ActiveRich.SelLength>0 then
  begin
    what:=ActiveRich.SelText;
    ActiveRich.SelText:=UpperCase(what);
    REChange(ActiveRich);
  end;
end;


function CapitalizeString(s:string) : String;
var Count : Integer;
begin
  for Count := 1 to Length(s) do
  begin
     if ((s[Count-1] = #32) and (s[Count+1] <> #32)) or (Count = 1) then
        s[Count] := upcase(s[Count]);
  end;
  result := s;
end;


procedure TForm1.Capitalize1Click(Sender: TObject);
var what:string;
begin
  if ActiveRich.ReadOnly then exit;
  if ActiveRich.SelLength>0 then
  begin
    what:=ActiveRich.SelText;
    ActiveRich.SelText:=CapitalizeString(what);
    REChange(ActiveRich);
  end;
end;



procedure TForm1.Insertdateandtime1Click(Sender: TObject);
begin
  Clipboard.AsText:= datetimetostr(now);
  ActiveRich.PasteFromClipboard;
  clipboard.Open;
  clipboard.Clear;
  clipboard.Close;
  REChange(ActiveRich);
end;



procedure TForm1.ExecuteCommandLine1Click(Sender: TObject);
 procedure RunDosInMemo(DosApp:String;AMemo:TSynEdit) ;
  const
     ReadBuffer = 2400;
  var
   Security : TSecurityAttributes;
   ReadPipe,WritePipe : THandle;
   start : TStartUpInfo;
   ProcessInfo : TProcessInformation;
   Buffer : Pchar;
   BytesRead : DWord;
   Apprunning : DWord;
  begin
   With Security do begin
    nlength := SizeOf(TSecurityAttributes) ;
    binherithandle := true;
    lpsecuritydescriptor := nil;
   end;
   if Createpipe (ReadPipe, WritePipe,
                  @Security, 0) then begin
    Buffer := AllocMem(ReadBuffer + 1) ;
    FillChar(Start,Sizeof(Start),#0) ;
    start.cb := SizeOf(start) ;
    start.hStdOutput := WritePipe;
    start.hStdInput := ReadPipe;
    start.dwFlags := STARTF_USESTDHANDLES +
                         STARTF_USESHOWWINDOW;
    start.wShowWindow := SW_HIDE;

    if CreateProcess(nil,
           PChar(DosApp),
           @Security,
           @Security,
           true,
           NORMAL_PRIORITY_CLASS,
           nil,
           nil,
           start,
           ProcessInfo)
    then
    begin
     repeat
      Apprunning := WaitForSingleObject
                   (ProcessInfo.hProcess,100) ;
      Application.ProcessMessages;
     until (Apprunning <> WAIT_TIMEOUT) ;
      Repeat
        BytesRead := 0;
        ReadFile(ReadPipe,Buffer[0],
        ReadBuffer,BytesRead,nil) ;
        Buffer[BytesRead]:= #0;
        OemToAnsi(Buffer,Buffer) ;
        AMemo.Text := AMemo.text + String(Buffer) ;
      until (BytesRead < ReadBuffer) ;
   end;
   FreeMem(Buffer) ;
   CloseHandle(ProcessInfo.hProcess) ;
   CloseHandle(ProcessInfo.hThread) ;
   CloseHandle(ReadPipe) ;
   CloseHandle(WritePipe) ;

   end;
  end;
//main menu item
begin
  //showmessage('This feature is still Beta, please report any bugs');
  Form3.Edit1.Text:='';
  if form3.ShowModal<>mrok then exit;
  if Form3.Edit1.Text='' then exit;

  RunDosInMemo(Form3.Edit1.Text,Activerich);
end;

procedure TForm1.Sort1Click(Sender: TObject);
var mylist:TStringList;
begin
   mylist:=TStringList.Create;
   mylist.Text:=ActiveRich.Text;
   mylist.Sorted:=true;
   mylist.Sort; //sort the text

   ActiveRich.Lines.Clear;
   ActiveRich.Text:=mylist.Text;
   REChange(ActiveRich); 
   mylist.Free;
end;


procedure ShowBinary(var Data; Count: cardinal; DispProc: TDisplayProc); 
var 
  line: string[80]; 
  i: cardinal; 
  p: PChar; 
  nStr: string[4]; 
const 
  posStart = 1; 
  binStart = 7; 
  ascStart = 57; 
  HexChars: PChar = '0123456789ABCDEF'; 
begin 
  p := @Data; 
  line := ''; 
  for i := 0 to Count - 1 do 
  begin 
    if (i mod 16) = 0 then 
    begin 
      if Length(line) > 0 then 
        DispProc(line); 
      FillChar(line, sizeof(line), ' '); 
      line[0] := Chr(72); 
      nStr := Format('%4.4X', [i]); 
      Move(nStr[1], line[posStart], Length(nStr)); 
      line[posStart + 4] := ':'; 
    end; 
    if p[i] >= ' ' then 
      line[i mod 16 + ascStart] := p[i] 
    else 
      line[i mod 16 + ascStart] := '.'; 
    line[binStart + 3 * (i mod 16)] := HexChars[(Ord(p[i]) shr 4) and $F]; 
    line[binStart + 3 * (i mod 16) + 1] := HexChars[Ord(p[i]) and $F]; 
  end; 
  DispProc(line); 
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  form7.showmodal;
end;

procedure TForm1.ViewinHex1Click(Sender: TObject);
var
  ms: TmemoryStream;
  j : Integer;
  aster, name, tabname:string;
begin
    if ActiveRich.Text='' then exit;
    ms := TmemoryStream.Create;
    ActiveRich.Lines.SaveToStream(ms);


    aster:=PageControl1.ActivePage.Caption[Length(PageControl1.ActivePage.Caption)];
    if aster='*' then
    begin
      name:='';
      for j:=1 to Length(PageControl1.ActivePage.Caption)-1 do
         name:=name+PageControl1.activepage.Caption[j];
      tabname:='Hex Dump: '+extractfilename(name);
    end
    else
      tabname:='Hex Dump: '+extractfilename(PageControl1.ActivePage.Caption);

    CreateNewEditor;
    PageControl1.ActivePage.Caption := tabname; 

    Application.Title:='Hex Dump: '+extractfilename(tabname)+' - Citizen Model Policy Editor';
    form1.Caption:=Application.Title;
    ActiveRich.ReadOnly:=true;

    try
      ShowBinary(ms.memory^, ms.size, Display);
    finally
      ms.Free
    end;
end;

procedure TForm1.Display(const S: string);
begin
  ActiveRich.Lines.Add(S);
end;

procedure TForm1.Font1Click(Sender: TObject);
begin
  FontDialog1.Font:=ActiveRich.Font;
  if FontDialog1.Execute then
  begin
    ActiveRich.Font:=FontDialog1.Font;
    DefaultFont := FontDialog1.Font.Name;
    DefaultFontSize := FontDialog1.Font.Size;
  end;
  ActiveRich.SetFocus;
end;

procedure TForm1.ViewCurrentLine1Click(Sender: TObject);
begin
  if ViewCurrentLine1.Checked then
    activerich.ActiveLineColor:=$DFDFDF
  else
     activerich.ActiveLineColor:=clNone;
  end;

procedure TForm1.PageControl1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  PageControl1.BeginDrag(False);
end;

procedure TForm1.PageControl1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
const
  TCM_GETITEMRECT = $130A;
var
  i: Integer;
  r: TRect;
begin
  if not (Sender is TPageControl) then Exit;
  with PageControl1 do
  begin
    for i := 0 to PageCount - 1 do
    begin
      Perform(TCM_GETITEMRECT, i, lParam(@r));
      if PtInRect(r, Point(X, Y)) then
      begin
        if i <> ActivePage.PageIndex then
          ActivePage.PageIndex := i;
        Exit;
      end;
    end;
  end;
end;

procedure TForm1.PageControl1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
if Sender is TPageControl then
    Accept := True;
end;

procedure TForm1.FullScreen1Click(Sender: TObject);
begin
   if FullScreen1.Checked then
   begin
      FullScreen1.Checked:=false;
      ShowFullScreen(false);
   end
   else
   begin
      FullScreen1.Checked:=true;
      ShowFullScreen(true);
   end;
end;

procedure TForm1.ShowStatusBar1Click(Sender: TObject);
begin
  if ShowStatusBar1.Checked then
  begin
    StatusBar1.Visible:=false;
    ShowStatusBar1.Checked:=false;
  end
  else
  begin
    StatusBar1.Visible:=true;
    ShowStatusBar1.Checked:=true;
  end;
end;


Procedure TForm1.InsertWithBrackets(aString : string);
var
    line : string;
begin
    if ActiveRich.ReadOnly then exit;
    ActiveRich.SelText:=concat(aString,'( ');
    ActiveRich.SelText:=concat(ActiveRich.SelText,')');
    if ActiveRich.CaretY>999 then //get a bigger panel
    begin
       StatusBar1.Panels[0].Width:=200;
    end;
    line:='  ln ' + inttostr(ActiveRich.CaretY);
    ActiveRich.CaretX :=  ActiveRich.CaretX -2;
    line:=line + ' col ' + inttostr(ActiveRich.CaretX);
    StatusBar1.Panels[0].Text:=line;
    ActiveRich.SetFocus;
end;


Procedure TForm1.InsertSimple(aString : string);
var
    line : string;
begin
    if ActiveRich.ReadOnly then exit;
    ActiveRich.SelText:=aString;
    if ActiveRich.CaretY>999 then //get a bigger panel
    begin
       StatusBar1.Panels[0].Width:=200;
    end;
    line:='  ln ' + inttostr(ActiveRich.CaretY);;
    line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
    StatusBar1.Panels[0].Text:=line;
    ActiveRich.SetFocus;
end;


Procedure TForm1.Selwin (Vary : Variable_Array; TitleStr : string);
var
    result,
    Win_Len,
    Array_Len,
    Screencnt,
    barPos,
    StringLen : integer;
    Display_String,
    Display1,
    Display2,
    line     :  String;

Procedure Find_Array_Length;
     { This finds how many lines the pop up window should take up }
     { based on the length of the array the window is to display }
var
    stringin : str50;
    codeinx     : integer;
begin
    if (Vary[0]=nil) then
    begin
       Array_Len:= -1;
       exit;
    end;
    StringIn:=Vary[0]^;
    Val(StringIn, Array_Len, Codeinx);
    if Array_Len<7 then
       Win_Len:=Array_Len
   else
       Win_Len:=7;
end;

begin
   Form4.NextGrid1.ClearRows;
   Form4.Caption:= TitleStr;
   Find_Array_Length;
   if (Array_Len <0) then
   begin
      MessageDlg(Format('No Variables in the Category.  Click Yes to continue.', [name]), mtConfirmation,
          [mbYes], 0);
      exit;
   end;
   if (pos('Choose',TitleStr)=0) then
      Form4.NxTextColumn3.Header.Caption:='Name in Survey'
   else
      Form4.NxTextColumn3.Header.Caption:=' ';
   ScreenCnt:=1;
   while (ScreenCnt<=Array_Len) do
      begin
         Display_String := Vary[ScreenCnt]^;
         barPos := pos('|',Display_String);
         stringLen := length(Display_String);
         if (pos('----',Display_String)>0) then
         begin
         end
         else if (barPos<>0) then
         begin
            Display1:= copy(Display_String,0,barPos-1);
            Display2:= copy(Display_String,barPos+1,stringLen);
            Form4.NextGrid1.AddCells([Display1,Display2]);
         end
         else
         begin
            Display1:= Display_String;
            Display2:= '';
            Form4.NextGrid1.AddCells([Display1,Display2]);
         end;
         ScreenCnt:=ScreenCnt+1;
      end;
   if (Form4.showmodal = mrOK) then
      result:= Form4.NextGrid1.SelectedRow
   else
      result:=-1;
   if (result >= 0) then
    begin
      Display_String := Vary[result+1]^;
      barPos := pos(' ',Display_String);
      if (barPos<=0)  then
        Display1:=Display_String
      else
        Display1:= copy(Display_String,0,barPos-1);
      Selwin_Selection := Display1;
      if (pos('Labels',TitleStr)=0) then
      begin
        if ActiveRich.ReadOnly then exit;
        ActiveRich.SelText:=Display1;
        if ActiveRich.CaretY>999 then //get a bigger panel
        begin
          StatusBar1.Panels[0].Width:=200;
        end;
        line:='  ln ' + inttostr(ActiveRich.CaretY);;
        line:=line + ' col ' + inttostr(ActiveRich.CaretX);;
        StatusBar1.Panels[0].Text:=line;
      end
    end
end;

procedure TForm1.IndbuttonClick(Sender: TObject);
begin
    Selwin (Ind_Array, 'Individual Variables');
end;

procedure TForm1.CreatedButtonClicked(Sender: TObject);
begin
    Selwin (User_Array, 'User Created Variables');
end;

procedure TForm1.FamButtonClicked(Sender: TObject);
begin
    Selwin (Taxun_Array, 'Family Unit Variables');
end;

procedure TForm1.HHoldButtClick(Sender: TObject);
begin
    Selwin (HHold_Array, 'Household Variables');
end;

Function FindLongVarName( Instring : str50): integer;
     { This procedure takes the string supplied to it and checks through }
     { all the names of the raw and created variables to see if it matches }
     { if there is a match then the array position of the variable is }
     { returned otherwise a zero is returned }
var
      cnter : integer;
begin
        cnter:=1;
        while ((cnter<=HighestVar) and (VarArray[cnter]^.LongPtr^<>Instring)) do
              cnter:=cnter+1;
        If cnter<=HighestVar then
           FindLongVarName:=cnter
        Else
           FindLongVarName:=0;
end;

procedure TForm1.CatButtonClick(Sender: TObject);
var
    TitleString : string;
    tempcounter : integer;
begin
    SelWin(Value_Label_Ary, ' Choose Which Set of Labels to Display: ');
    tempcounter:=FindLongVarName(Selwin_Selection);
    TitleString:= 'Choose a category:';
    if tempcounter<>0 then
    begin
       if ( VarArray[tempcounter]^.ValPtr=nil) then
          begin
             Showmessage('ERROR : Could not find categories for ' + Selwin_Selection,
                     'Please enter the category name by typing',
                     'click OK to continue');
          end
       else
          Selwin(VarArray[tempcounter]^.ValPtr^.V_Ary, TitleString);
    end;
end;

procedure TForm1.Any_in_HouseholdClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Any_in_Household.Caption;
    InsertWithBrackets(outStr);
end;

procedure TForm1.Any_In_Tax_UnitClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Any_In_Tax_Unit.Caption;
    InsertWithBrackets(outStr);

end;

procedure TForm1.Head_of_HouseholdsClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Head_of_Households.Caption;
    InsertSimple(outStr);

end;

procedure TForm1.Head_of_Tax_UnitsClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Head_of_Tax_Units.Caption;
    InsertSimple(outStr);
end;

procedure TForm1.HusbandsClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Husbands.Caption;
    InsertSimple(outStr);
end;

procedure TForm1.Number_In_HouseholdClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Number_In_Household.Caption;
    InsertWithBrackets(outStr);

end;

procedure TForm1.Number_in_Tax_UnitClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Number_in_Tax_Unit.Caption;
    InsertWithBrackets(outStr);

end;

procedure TForm1.Total_HouseholdClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Total_Household.Caption;
    InsertWithBrackets(outStr);

end;

procedure TForm1.Total_Tax_UnitClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Total_Tax_Unit.Caption;
    InsertWithBrackets(outStr);
end;

procedure TForm1.WifesClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Total_Tax_Unit.Caption;
    InsertSimple(outStr);
end;

procedure TForm1.LessClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Less.Caption;
    InsertSimple(outStr);
end;

procedure TForm1.Per_CentClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= ' %';
    InsertSimple(outStr);
end;

procedure TForm1.Per_YearClick(Sender:  TObject);
var
    outStr : string;
begin
    outStr:= Per_Year.Caption;
    InsertSimple(outStr);
end;

procedure TForm1.Withdrawn_ByClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Withdrawn_By.Caption;
    outStr:= concat(outStr, ' % of ');
    InsertSimple(outStr);
end;

procedure TForm1.End_BenefitClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= End_Benefit.Caption;
    InsertSimple(outStr);
end;

procedure TForm1.End_TaxClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= End_Tax.Caption;
    InsertSimple(outStr);
end;

procedure TForm1.Start_BenefitClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Start_Benefit.Caption;
    InsertSimple(outStr);
end;

procedure TForm1.Start_TaxClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Start_Tax.Caption;
    InsertSimple(outStr);
end;

procedure TForm1.Translate1Click(Sender: TObject);
//var
//     ok : boolean;
begin
     Translated(Sender);
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
    while (ActiveRich.endOfStream=false) do
    begin
        AdvanceOneWord(Sender);
        Delay(5);
    end;
end;


Function Translated(Sender: TObject): boolean;

const
    OrigBlank : String = '                        ';

type
    tempvaluset = record
                     Numbers : Array [0..60] of Integer;
                     Names   : Array [0..60] of Str50;
                  end;

    BufPt    = ^BuffLine;
    Buffline = Record
                  Tx   : String[100];
                  next,
                  Prev  : BufPt;
                  Col   : integer;
               end;
    Cpt      = ^User_Con;

    User_Con = Record
                  Name      : String[45];
                  BigName   : String[45];
                  Valu      : LongInt;
                  DispNum   : Longint;
                  DispType  : Integer;
                  RealVal   : Real;
                  Units     : Real;
                  Unit_Cost : Real;
                  Desc      : String;
               end;

var
    DescriptionString,
    Source1,
    Source2,
    FuncStr,
    AnalStr,
    ExpStr,
    AssignStr,
    Txt,
    BlankStr       : String;
    LastToken,
    PenToken,
    Anal_Operator  : TokenType;
    ExpTem,
    PasStr,
    Variablestr,
    UserVStr,
    LastSymbol,
    PenSymbol,
    tokenstr  : String;
    AnVar : string[24];
    new_policy,
    Com_Lev,
    CurrentVallab,
    CurrentUserVar,
    oldLine,
    tokenNumber : Integer;
    Mantissa,
    numb,
    Targ_Exp,
    Targ_Recip  : LongInt;
    UserVarUsed,
    ok,
    Existing_Var,
    Number_Real,
    BoolVar   : boolean;
    RealNum   : LongInt;
    ccw,
    RealVal   : Real;
    codePos,
    token    : integer;
    valu     : integer;
    TempVals  : TempValuSet;
    FirstFileTime,
    SecondFileTime : LongInt;
    FirstTime,
    SecondTime  : TDateTime;
    TBDefines,
    CDefines,
    tmenhead,
    bmenhead,
    pmenhead,
    cmenhead  : Text;
    AnBuf     : BufPt;
    IdBuf     : BufPt;
    PolicyBuf : BufPt;
    C_Ary     : Array[1..50] of Cpt;
    LastVar   : Str45;
    TBstr     : Str45;
    Const_Chg_Num,
    Const_Pol_Num,
    Const_Ben_Num,
    Const_Tax_Num,
    Found_Const_Num,
    Const_Num,
    Menu_Type : Integer;
    TB_ary  : Array[1..50] of Str45;
    TB_MaxNo : Integer;
    Indexing : boolean;

Function UpCaseNStr(Instring : str50):str50;
   { This takes a string supplied to it and returns it all in }
   { capital letters }
var
   outstring : str50;
   i : integer;
begin
   OutString:=Instring;
   for i:=1 to Length(Instring) do Outstring[i]:=Upcase(Instring[i]);
   UpCaseNStr:=OutString;
end;

Function TBPlace(Instring : str45) : integer;
var
	i : integer;
begin
	i := 1;
	while ((TB_Ary[i] <> '') and (TB_ary[i] <> UpCaseNStr(InString))) do
		inc(i);
	if (TB_ary[i] = '') then
      begin
         TB_Ary[i]:=UpCaseNewStr(Instring);
         Inc(TB_MaxNo);
         TBPlace := TB_MaxNo;
      end
	else
		TBPlace := i;
end;


Procedure WriteOpen(var infile :  TEXT; namestr : string);
//var
//     ch : char;
begin
     {$I-}
     assign(infile, namestr);
     rewrite(infile);
     {$I+}
     if (IOresult <> 0) then
       begin
         Showmessage('ERROR : the file - ' + namestr + ' - could not be opened',
                     'the program will abort',
                     'press any key to continue');
         // ch := readkey;
         halt;
       end
     else
       begin
         Inc(File_Ary_Pos);
         File_Ary[File_Ary_Pos] := namestr;
       end;
end;

Procedure CloseFile(namestr : string;  var infile :  TEXT);
var
     // ch : char;
     i  : integer;
begin
     {$I-}
     close(infile);
     {$I+}
     if (IOresult <> 0) then
       begin
         Showmessage('ERROR : the file - ' + namestr + ' - could not be closed',
                     'the program will abort',
                     'press any key to continue');
         // ch := readkey;
         halt;
       end
     else
       begin
         i := 1;
         while ((File_Ary[i] <> Namestr) and (i < File_Ary_Pos)) do
            inc(i);
         while (i <= File_Ary_Pos) do
            begin
              File_Ary[i] := File_Ary[i+1];
              inc(i);
            end;
         File_Ary[i] := '';
         Dec(File_Ary_Pos);
       end;
end;

Procedure InitVars;
   { Initialise the parser variables }
var
   i  : integer;
   currentDrive : string[150];
Begin
   for i := 1 to TotalVars do
      Out_Vars[i]:=0;
   for i := 1 to TotalVars do
      Out_Vars_Orig[i]:=0;
   Out_Var_No := 0;
   Const_Num := 0;
   BlankStr := OrigBlank;
   PoundSign:=false;
   GlobErr:=false;
   Existing_Var:=false;
   TxVarNo:=0;
   HsVarNo:=0;
   AnVar:='';
   AnalStr:='';
   ExpStr:='';
   ExpTem:='';
   TokenNumber:=0;
   Token:= 350;
   //GetDir(0,currentDrive);
   // currentDrive[2]:='\0';
   ChangeDir(prdrive + '\pom\new');
   //ChangeDir('C:\Program Files\Borland\Delphi7\Projects\New');
   LastToken  :=350;
   PenToken   :=350;
   WriteOpen(IdFile,'INDIV.PRG');
   WriteOpen(PolicyFile, 'POLICY.PRG');
   WriteOpen(tmenhead,'TAXHEAD.DEF');
   writeln(tmenhead,'Procedure Assign_Tmenu;');
   writeln(tmenhead,'begin');
   WriteOpen(bmenhead,'BENHEAD.DEF');
   writeln(bmenhead,'Procedure Assign_Bmenu;');
   writeln(bmenhead,'begin');
   WriteOpen(cmenhead,'CHGHEAD.DEF');
   writeln(cmenhead,'Procedure Assign_Cmenu;');
   writeln(cmenhead,'begin');
   WriteOpen(pmenhead,'POLHEAD.DEF');
   writeln(pmenhead,'Procedure Assign_Pmenu;');
   writeln(pmenhead,'begin');
   WriteOpen(cdefines,'CDEFINE.DEF');
   writeln(cdefines,'Procedure Assign_Consts;');
	 writeln(cdefines,'begin');
	 WriteOpen(TBDefines,'TBDEFINE.DEF');
	 writeln(TBDefines,'Procedure Define_RevTable;');
	 writeln(TBDefines,'begin');
   New(IdBuf);
	 IdBuf^.Prev:= Nil;
   IdBuf^.Next:= Nil;
   IdBuf^.Tx:= BlankStr;
   IdBuf^.Col:= Length(BlankStr);
   New(PolicyBuf);
	 PolicyBuf^.Prev:= Nil;
   PolicyBuf^.Next:= Nil;
   PolicyBuf^.Tx:= BlankStr;
   PolicyBuf^.Col:= Length(BlankStr);
   New(AnBuf);
	 AnBuf^.Prev:= Nil;
   AnBuf^.Next:= Nil;
   AnBuf^.Tx:= BlankStr;
   AnBuf^.Col:= Length(BlankStr);
	 Const_Pol_Num := 0;
   Const_Chg_Num := 0;
	 Const_Tax_Num := 0;
   Const_Ben_Num := 0;
   for i := 1 to 50 do
     begin
        C_Ary[i] := Nil;
        Tb_Ary[i]:= '';
     end;
   TB_MaxNo := 0;
   LastVar := '';
   Write_Mode := FALSE;
   GUF_no := 0;
   TokenStr := '';
end;

Procedure WriteBuf(var inbuf : bufPt ; var Intxt: string;
                   NewLine: boolean);
const
   shortblank : string = '                        ';
   longblank  : string = '                            ';

var
   inst,
   inst1 : string;
   posn : integer;

begin
   if (BlankStr = '') then
     begin
       Inbuf^.col :=0;
       Inbuf^.tx  :='';
     end;
   repeat
          if (Intxt[1]=' ') then delete(Intxt,1,1);
          Inst1 := Copy(Intxt,1,93 - Inbuf^.col);
          posn := Length(Inst1);
          //if (posn=0) then
          //   exit;         { PDT SEPT 2009}
          if ((posn>0)and(Intxt[posn] in['A'..'Z','a'..'z','_','0'..'9','^','.']) and
                   (posn <> Length(Intxt))) then
             begin
                while(not(Intxt[posn] in [' ',',',')','(','+','-','/','*',';'])
                   and (Posn>0)) do posn:= pred(posn);
             end;
          while((posn > 1) and (Intxt[posn] = '(')) do dec(posn);
          If ((posn>1) and (Intxt[posn]=':')) then dec(posn);
          while((posn>0)and (Intxt[posn+1] = ')')) do inc(posn);
          Inst := Copy(Intxt,1,posn);
          Delete(Intxt,1,posn);
          InBuf^.Tx := InBuf^.tx + Inst;
          InBuf^.Col := InBuf^.col + Length(Inst);
          If (InBuf^.Next = Nil) then
             begin
               New(InBuf^.Next);
               InBuf^.Next^.Prev:= Inbuf;
               Inbuf:=InBuf^.Next;
               InBuf^.Next:=Nil;
             end
          else
             InBuf := Inbuf^.Next;
          InBuf^.Tx  := BlankStr;
          InBuf^.col := Length(BlankStr);
   until(Length(Intxt) < 1);
end;

Procedure WritePolicy(Instrin : String);
begin
   WriteBuf(PolicyBuf, Instrin, false)
end;

Procedure WritePolicyLn(Instrin : String);
begin
   WriteBuf(PolicyBuf, Instrin, True)
end;

Procedure WriteP(Instrin : String);
begin
   WriteBuf(IdBuf, Instrin, false)
end;

Procedure WritePLn(Instrin : String);
begin
   WriteBuf(IdBuf, Instrin, True)
end;

Procedure WriteAnBuf(InStrin : String);
begin
   WriteBuf(Anbuf, Instrin, True);
end;

Procedure WriteAn(DispStr : string);
var
    DStr : string;
begin
    Dstr := DispStr;
    WriteBuf(Anbuf, Dstr, TRUE);
end;

Procedure WriteAnStat(DispStr : string);
var
    DStr : string;
begin
    Dstr := DispStr;
    Anbuf^.tx := OrigBlank;
    WriteBuf(Anbuf, Dstr, TRUE);
end;

Procedure WriteOut(var inbuf: bufpt; instr : string);
var
   Dstr : string;
begin
   Dstr := instr;
   WriteBuf(inbuf, Dstr, TRUE);
end;

Procedure End_Until(var inbuf : bufpt);
//var
//   Dstr : String;
begin
   BlankStr := '';
   Inbuf^.tx :='';
   Inbuf^.col := 0;
   WriteOut(inbuf,'                    end;');
   WriteOut(inbuf,'                  inc(per);');
   WriteOut(inbuf,'               until Hold[fam,per].age = MaxLint;');
   WriteOut(inbuf,'               inc(fam);');
   WriteOut(inbuf,'             until Hold[fam,1].age = MaxLint;');
end;

Procedure Begin_Repeat(var inbuf : bufpt);
//var
//   Dstr : String;
begin
   WriteOut(inbuf,'             fam:=1;');
   WriteOut(inbuf,'             repeat');
   WriteOut(inbuf,'               per := 1;');
   WriteOut(inbuf,'               repeat');
   WriteOut(inbuf,'                  with Hold[fam,per] do');
   WriteOut(inbuf,'                    begin');
   BlankStr:= OrigBlank;
   Inbuf^.tx := BlankStr;
   Inbuf^.col := Length(BlankStr);
end;

Procedure WriteBufs;

   Procedure GotoRoot(var inbuf : bufPt);
   begin
       while (InBuf^.Prev <> Nil) do
           InBuf:= InBuf^.Prev;
   end;

   Procedure WriteToFile(var Infile : text; Inbuf : bufPt);
   var
      Continuing : boolean;

      Function OnlyBlanks(Intxt : string): boolean;
      var
          j : integer;
      begin
          j:=0;
          OnlyBlanks := True;
          repeat
            Inc(j);
          until (Intxt[j] <> ' ') or (j = Length(Intxt));
          If Intxt[j] <> ' ' then OnlyBlanks := False;
      end;

   begin
      Continuing := true;
      While ((Continuing) and (Length(InBuf^.tx) >= 1)) do
        begin
           if not(OnlyBlanks(Inbuf^.tx)) then
              writeln(infile, InBuf^.tx);
           inbuf^.tx:= '';
           if Inbuf^.Next = Nil then
              Continuing := False
           else
              Inbuf := Inbuf^.Next;
        end;
   end;

begin
   if (Anbuf^.prev <> Nil) then
      begin
         End_Until(Anbuf);
         Begin_Repeat(Anbuf);
         GotoRoot(AnBuf);
         BlankStr :=  OrigBlank;
	       WriteToFile(IdFile, AnBuf);
	       GotoRoot(AnBuf);
      end;
   GotoRoot(IdBuf);
   GotoRoot(PolicyBuf);
	 BlankStr :=  OrigBlank;
	 WriteToFile(IdFile, IdBuf);
   WriteToFile(PolicyFile, PolicyBuf);
	 GotoRoot(IdBuf);
   GotoRoot(PolicyBuf);
	 BlankStr :=  OrigBlank;
   IdBuf^.Col:=Length(BlankStr);
   IdBuf^.Tx:= BlankStr;
   PolicyBuf^.Col:=Length(BlankStr);
   PolicyBuf^.Tx:= BlankStr;
end;

Function SymbolToToken: boolean;
  { This takes a string and returns a number which can be stored on the heap}
var
  i : integer;
begin
    UpSymbol := Symbol;
    for i:= 1 to Length(Symbol) do
        UpSymbol[i] := UpCase(Symbol[i]);
    i := 1;
    while ((symtab[i].tokn<>eof1) and (UpSymbol<>symtab[i].symbol)) do
           i:=i+1;
    if i<SymMax then
         begin
           SymbolToToken:=true;
           token:=symtab[i].tokn;
         end
    else
         SymbolToToken:=false;
end;

Function ValidVariable: boolean;
    { This takes a string and checks whether it is a valid variable }
var
    i : integer;
begin
    i:=1;
    while ((i<rawvarmax) and (UpSymbol<>VarArray[i]^.BigPtr^)) do
       i:=i+1;
    if UpSymbol=VarArray[i]^.BigPtr^ then
       begin
         ValidVariable:=true;
         CurrentVar:=i;
       end
    else
       ValidVariable:=false;
end;

Procedure ExpTemp(Inst :shortstr);
begin
   ExpTem := Inst;
end;

Procedure LexicalError(Instring1 : String78;
                       Instring2 : String78;
                       Instring3 : String78);
     { This is used when an error has been encountered while parsing }
     { An error message is displayed showing the type of error that }
     { has been found.  Set globerr to true so that the rest of the }
     { program knows that an error has been found.  Delay the execution }
     { of the program until the user has read the message and pressed the }
     { escape key }

Begin
   If Globerr then exit;  { if an error has already been found exit }
   GlobErr:=true;
   ShowMessage ( Instring1, Instring2, Instring3);
end;

function NumStr(N: Integer): String;
var
  OutString : string;
begin
  {
  NumStr[0] := Chr(D);
  while D > 0 do
  begin
    NumStr[D] := Chr(N mod 10 + Ord('0'));
    N := N div 10;
    Dec(D);
  end;
  }
  str(N, OutString);
  NumStr := OutString;
end;

Procedure Process_Money;
    { This is called if a number follows a pound sign, It then returns }
    { a real number with the pounds to the left of the decimal point and }
    { pence to the left.  Token is set the constant which represents }
    { MONEY }
var
    code : integer;
    tempreal : real;
begin
    tempreal:=0;
    code:=0;
    Val(Symbol,tempreal,Code);
    if (tempreal < 0.0)  then
       LexicalError(' ERROR : A Money value must be greater than 0 ','','');
    Symbol := NumStr(Numb);
    ExpTemp(Symbol);
    Token:= MONEY;
end;

Procedure Proc_Money_Const;
    { This is called if a number follows a pound sign, It then returns }
    { a real number with the pounds to the left of the decimal point and }
    { pence to the left.  Token is set the constant which represents }
    { MONEY }
var
    code : integer;
    tempreal : real;
begin
    tempreal:=0;
    code:=0;
    Val(Symbol,tempreal,Code);
    if (tempreal < 0.0)  then
       LexicalError(' ERROR : A Money value must be greater than 0 ','','');
    Numb:=trunc(TempReal);
end;

Procedure Process_Percent;
   { This is called where a number precedes a percentage sign. The number }
   { is stored in two parts - i.e. the parts to the left and right of the }
   { decimal point }
var
    realtemp : real;
    code : integer;
//    NumSt : string;
begin
    code:=0;
    realnum := 0;
    Val(Symbol,RealTemp,Code);
    if (RealTemp< 0.0) then
        LexicalError(' ERROR : A percentage cannot be less than 0','','')
    else if (code <> 0) then
        LexicalError(' ERROR : Not A valid number','','')
    else
        RealVal := RealTemp /100;
    Str(RealVal:8:3,Symbol);
end;

Procedure Process_Real;
   { this processes a real number and sets token to "REALNUMBER" }
var
   realtemp : real;
   code     : integer;
begin
   realnum := 0;
   val(symbol, realtemp, code);
   RealVal := realtemp;
   Str(RealVal:12:3,Symbol);
end;

Procedure Process_Number;
    { This processes an integer and sets token to "NUMBER" }
var
    code : integer;
begin
    code:=0;
    Val(Symbol,numb,Code);
    Exptemp(symbol);
    if ((code<>0) and (symbol<>'')) then
       LexicalError('This type of number must be an integer','','')
    else
       Token:=NUMBER;
end;

Function ValidNumber(Inst : NameStr): boolean;
    { This takes a string, checks whether it is a valid number, and returns}
    { true if it is }
var
   code  : integer;
   TempReal : real;
begin
   tempreal:=0;
   code:=0;
   Val(Inst ,tempreal,Code);
   if ((Code=0) and (Symbol<>'')) then
      begin
         ValidNumber:=true;
         if pos('.', inst) <> 0 then
            Number_real:= true;
      end
   else
      begin
         ValidNumber:=false;
         exit;
      end;
end;

Function TokenToSymbol(tok: integer):Shortstr;
            { convert a numerical token to its corresponding string }
            { so that it can be output on the screen }
var
   i: integer;
//  ch : char;
begin
   i:=1;
   if tok<>0 then
     while ((SymTab[i].tokn<>tok) and (SymTab[i].tokn<>eof1)) do
       begin
         i:=i+1;
       end;
   if ((tok<>eof1) and (tok<>0)) then
      TokenToSymbol:=SymTab[i].symbol
   else
    begin
      TokenToSymbol:='UNKNOWN SYMBOL';
      GlobErr:=true;
    end;
end;

Procedure Unexpected(ExpectToken: integer);
    { This prints an error message showing that a different token was }
    { expected to the one read last from the input stream }
begin
    LexicalError (' The symbol ' + TokenToSymbol(ExpectToken) + ' was expected ',
                   'not "' + TokenToSymbol(Token) + '" Check Your',
                   'Statement');
end;

Function ExistingUserVar(var num: integer): boolean;
   { This examines the current symbol to see if it matches the name of }
   { of a user variable which has already been created }
var
    i          : integer;
begin
    num:=1;
    i:=RawVarMax;
    while ((i < HighestVar) and (UpSymbol<>VarArray[i]^.BigPtr^)
            and (VarArray[i]<> Nil)) do i:=i+1;
    num:=i;
    if (UpSymbol = VarArray[i]^.BigPtr^) then
       begin
         ExistingUserVar:=true;
       end
    else
       begin
         ExistingUserVar:=false;
         inc(num);
       end;
end;

Function UserConstant: boolean;
var
    i          : integer;
begin
    i := 1;
    if ((Const_Num = 0)or(c_ary[1]=nil)) then
      begin
        UserConstant := False;
        exit;
      end;
    while ((i < Const_Num) and (UpSymbol <> c_ary[i]^.BigName))
         do i := i + 1;
    if (UpSymbol = c_ary[i]^.BigName) then
        begin
           UserConstant := true;
           Found_Const_Num := i;
        end
    else
        UserConstant := false;
end;

Function ValidValueLabel(var num : integer): boolean;
    { This tests to see if the string which follows a variable and an }
    { equals sign is a valid value label for the variable concerned }
var
    VarPos,
    i,
    Code,
    CatMax        : integer;
    CatMaxSt      : String;
begin
    ValidValueLabel:=false;
    if ((PenToken=Variable) AND
        (token in [EQUALS,NE,GT,GE,LT,LE,EQMV,NEMV])) then
      begin
        VarPos := Files[Numb];
        if VarArray[VarPos]^.IfValLabs then
           begin
             i:=1;
             CatMaxSt := VarArray[VarPos]^.ValPtr^.V_Ary[0]^;
             Val(CatMaxSt, CatMax, Code);
             While((i < CatMax)and(UpCaseNStr(VarArray[VarPos]^.ValPtr^.V_Ary[i]^)<>upsymbol)) do
                  i:=i+1;
             if (UpCaseNStr(VarArray[VarPos]^.ValPtr^.V_Ary[i]^)=upsymbol) then
               begin
                  ValidValueLabel:=true;
                  num:=VarArray[VarPos]^.ValPtr^.N_Ary[i];
               end;
           end;
      end;
end;

Function Analysis_lev_token: boolean;
   { This tests to see if the current token is a valid analysis level }
   { token and returns the value true if it is }
begin
   if token in [Individual, Family, Household, Total_Family, Total_Household,
   Number_in_Family, Number_in_HouseHold, Any_in_Family, Any_in_HouseHold] then
      Analysis_Lev_Token:=true
   else
      Analysis_Lev_Token:=false;
end;

Function Pointer_Token(InToken: tokentype): boolean;
    { This tests to see if the current token is a valid family or household }
    { relationship pointer and returns the value true if it is }
begin
    if InToken in [Spouses .. Husbands] then
       Pointer_Token := true
    else
       Pointer_Token := false;
end;

Function IsDigit(ch: char): boolean;
    { Tests to see if the parameter ch is a numeric character }
begin
    IsDigit:=false;
    if ((ch>='0') and (ch<='9')) then IsDigit:= true;
end;


Function TokenToPascal(tok: integer):Shortstr;
            { convert a numerical token to its corresponding string }
            { so that it can be output on the screen }
var
   i: integer;
//   ch : char;
begin
   i:=1;
   if tok<>0 then
     while ((PasTab[i].tokn<>tok) and (PasTab[i].tokn<>eof1)) do
         i:=i+1;
   if ((PasTab[i].tokn<>eof1) and (i<SymMax) and (tok<>0)) then
      TokenToPascal:=PasTab[i].symbol
   else
    begin
      TokenToPascal:='UNKNOWN SYMBOL';
      GlobErr:=true;
    end;
end;

Procedure Force_Flush_Policy_ExpStr(limit : integer);
begin
    ExpStr := ExpStr + ' ';
    WritePolicyLn(ExpStr);
    ExpStr := '';
end;

Procedure Flush_Policy_ExpStr(limit : integer);
begin
    If (Length(ExpStr) > limit) then
       begin
          ExpStr := ExpStr + ' ';
          WritePolicyLn(ExpStr);
          ExpStr := '';
       end;
end;

Procedure Flush_ExpStr(limit : integer);
begin
    If (Length(ExpStr) > limit) then
       begin
          ExpStr := ExpStr + ' ';
          WriteP(ExpStr);
          ExpStr := '';
       end;
end;

Procedure AddExp(InSymbol : string);
var
  testEnd,
  testStart : char;
begin
        {
        if (length(expstr)> 205) then
          begin
            LexicalError('ERROR: you have a single expression longer than 205',
                        'characters. You must declare this as two separate',
                        'variables and then add them together');
            exit;
          end; }
        if (length(ExpStr)<1) then
           testEnd := #0
        else
           testEnd := ExpStr[Length(ExpStr)];
        if (length(inSymbol)<1) then
           testStart := #0
        else
           testStart := InSymbol[1];
       // if (ExpStr[Length(ExpStr)] in ['0'..'9','a'..'z','A'..'Z']) and
       //    (InSymbol[1] in ['0'..'9','a'..'z','A'..'Z']) then
        If (testEnd in ['0'..'9','a'..'z','A'..'Z']) and
           (testStart in ['0'..'9','a'..'z','A'..'Z']) then
              ExpStr := ExpStr + ' ' + Insymbol
        Else
              ExpStr := ExpStr + InSymbol;
end;

Procedure Check_Real;
var
     messgstr : string78;
     upTemp   : string;
begin
     If (pensymbol='Random_Number') then
        exit
     Else if (LastToken in [withdrawn_by,times,divide]) then
        exit
     else if (VarArray[currentuservar]^.ifreal=TRUE) then
        exit;
     If (UserVStr = UpCaseNewStr(TBStr) + '_RATE') then
        exit;
     messgstr:= 'ERROR : only limited operations are allowed on ';
     if not(TempCh in ['\','*','<','>','=',')','(']) then
        LexicalError(messgstr,
                     'Real Type Variables.  You may only use a real value',
                     'next to one of: \, *, <, >, =');
end;

Function ValidArray: boolean;
var
   max,
   code,
   i : integer;
   valstr : str50;
begin
   ValidArray:=FALSE;
   if (Array_Array[0]=Nil) then
      exit;
   valstr:=array_array[0]^;
   val(valstr,max,code);
   for i:= 1 to max do
     begin
        valstr:=array_array[i]^;
        valstr:=upcasenewstr(valstr);
        if (valstr=UPSYMBOL) then
           ValidArray:= TRUE;
     end;
end;

Procedure ReadSymbol(Sender: TObject);
{  This routine moves the cursor in the current window right one word. }
var
 // i : integer;
  LengthCnt,
  Startclass : integer;

  Procedure SkipWhite;
  begin
       while not(ActiveRich.endOfStream) and
               not(ActiveRich.GetCharAtCursor in ['!'..'}','']) do
                  ActiveRich.advanceChar;
  end;

  Procedure FindNextWord;
       { find the beginning of the next word }
   var
      tempChar : char;
      st1 : namestr;
      tempResult : string;
      currline:string;
      CaretNew: TBufferCoord;
      i,
      curCaretY,
      curlineBufflen : integer;
   begin { FindNextWord }
       curCaretY:=ActiveRich.CaretY;
       currline:=ActiveRich.Lines[curCaretY-1];
       curlineBufflen := length(currline);
       i:=0;
       while (i <= curlineBuffLen) and   not(ActiveRich.endOfStream) and
               not(ActiveRich.GetCharAtCursor in ['!'..'}','']) do
                  ActiveRich.advanceChar;
      { This function appears to skip everything that is not between
        the exclamation character and the pound sign }
      { The first stage is to see if we are on whitespace or a character }
      //tempResult := ActiveRich.GetWordAtRowCol(ActiveRich.CaretXY);
      tempChar := ActiveRich.GetCharAtCursor;
      if (tempChar=' ') then
          CaretNew := ActiveRich.NextWordPos
      else
          SkipWhite;
      delay(1);
   end;

  function ClassFunc : integer;
  var Ch : char;
  begin {Class of ReadSymbol}
    Ch := ActiveRich.GetCharAtCursor();
    if not(Ch in ['!'..'}','']) then ClassFunc := 1
    else if Ch = '$' then ClassFunc := 2
    else if Ch in ['A'..'Z','a'..'z'] then ClassFunc := 3
    else if Ch in ['0'..'9'] then ClassFunc := 4
    else if Ch in ['<','>'] then ClassFunc :=5
    else if Ch in ['[',']','.','(',')','%',':','+','=','-','*','/'] then ClassFunc := 6;
  end; {Class of ReadSymbol}

  function ReClass : integer;
  var
    Ch : char;
    ReClassVal : integer;
  begin {Class of ReadSymbol}
    Ch := ActiveRich.GetCharAtCursor();
    if not(Ch in ['!'..'}','']) then ReClassVal := 1
    else if Ch in ['0'..'9',','] then
       begin
          if StartClass = 3 then
            ReClassVal:=3
          else if StartClass = 4 then
            ReClassVal:=4
       end
    else if Ch in ['A'..'Z','a'..'z','&','','$','_',''''] then ReClassVal := 3
    else if Ch in ['='] then ReClassVal:=5
    else ReClassVal:=7;
    ReClass:= ReClassVal;
  end; {ReClass of ReadSymbol}

  procedure MoveTheCursor;
  var
    currline : string;
  begin
    currline:='  ln ' + inttostr(ActiveRich.CaretY);
    currline:=currline + ' col ' + inttostr(ActiveRich.CaretX);
    //StatusBar1.Panels[0].Text:=currline;
  end;

  procedure Advance;   { move on character forward }
  var
    currline : string;
  begin
      ActiveRich.advanceChar;
      // adjustTheCursor;
  end; {Advance of ReadSymbol}

  procedure Retreat;   { move on character forward }
  begin
      ActiveRich.retreatChar;
  end; {Advance of ReadSymbol}

  function EndOfStream : boolean;
  var
     resultHere : boolean;
  begin {EndOfStream of ReadSymbol}
     resultHere := ActiveRich.endOfStream;
     EndOfStream := resultHere;
  end; {EndOfStream of ReadSymbol}

  procedure Skip_Comment;
  var Ch1 : char;

  begin
     Ch1:= ActiveRich.GetCharAtCursor;
     If (Ch1 = '{') then
       begin
         repeat
           Advance;
           Ch1:= ActiveRich.GetCharAtCursor;
         until ((Ch1 = '}') or EndofStream);
         Advance;
         findnextword;
       end;
  end;

  Procedure SetPushChar;
       { find the first character of the next word and put it in a special }
       { variable "PushChar" }
  var
      testChar : char;
      origLine : integer;
      origXY,
      CaretNow: TBufferCoord;
   begin
      testChar := ActiveRich.GetCharAtCursor;
      origXY   := ActiveRich.CaretXY;
      CaretNow := ActiveRich.CaretXY;
      if not(testChar in ['!'..'}','']) then
        begin
          while (CaretNow.Line=ActiveRich.CaretY) and not(testChar in ['!'..'}',''])
                  and not(ActiveRich.endOfStream) do
              begin
                  Advance;
                  testChar := ActiveRich.GetCharAtCursor;
              end;
            If ((CaretNow.Line=ActiveRich.CaretY) and (testChar in ['!'..'}',''])) then
                  TempCh:=testChar;
            If (testChar in ['!'..'}','']) then
              begin
                while ((ActiveRich.CaretX > 0) and (testChar in ['!'..'}',''])) do
                  begin
                      Retreat; // Colno := Pred (Colno);
                      testChar := ActiveRich.GetCharAtCursor;
                  end;
                  Advance;    // Colno := Succ (Colno);
              end;
          end;
          ActiveRich.CaretX:= origXY.Char;
          ActiveRich.CaretY:= origXY.Line;
   end; { SetPushChar }

   Procedure ReadinSymbol;
       { read in a word from the text stream and store it in the variable }
       { symbol }
   Var
        DecPoint : Boolean;

           Procedure deleteCommas;
           var
              newSymbol : string;
              ch        : char;
              len,
              cnt       : integer;

           begin
              len := length(symbol);
              newSymbol:= '';
              for cnt:=1 to len do
                begin
                   ch := symbol[cnt];
                   if (ch in ['0'..'9','.']) then
                      newSymbol:= newSymbol + symbol[cnt];
                end;
              symbol := newSymbol;
           end;

           Procedure Check_For_Decimal_Point;
              { check to see if a decimal point has been  encountered }
              { within a numeric string }
           Begin
                 If ((ActiveRich.GetCharAtCursor = '.') AND (StartClass = 4)) then
                  begin
                   if (ActiveRich.GetNextChar in ['0'..'9']) then
                     begin
                        If DecPoint then LexicalError ('ERROR : You Are only allowed one',
                                        'Decimal Point in the Middle','of A Number');
                        LengthCnt := LengthCnt + 1;
                        Symbol[LengthCnt]:=ActiveRich.GetCharAtCursor;
                        Advance;
                        DecPoint := true;
                     end;
                  end;
           End;

   Begin
       DecPoint := False;
       Skip_Comment;
       Startclass := ClassFunc;
       if StartClass > 1 then
          begin
            If StartClass = 2 then
              begin
                PoundSign := True;
                Advance;
                While (ActiveRich.GetCharAtCursor = ' ') Do
                                Advance;
                StartClass := ClassFunc;
                If StartClass <> 4 then
                  LexicalError('ERROR A number must always follow a pound sign','','');
              end;
              LengthCnt := 1;
              Symbol[LengthCnt]:=ActiveRich.GetCharAtCursor;
              Advance;
              Check_For_Decimal_Point;
              while (not EndOfStream) and (ReClass = Startclass) and (LengthCnt < 38) do
                begin
                  LengthCnt:=LengthCnt + 1;
                  Symbol[LengthCnt]:=ActiveRich.GetCharAtCursor;
                  Advance;
                  Check_For_Decimal_Point;
                end;
                Symbol[0]:=Char(LengthCnt);
          end;
          If StartClass = 4 then
            begin
              deleteCommas;
              FindNextWord;
              if ActiveRich.GetCharAtCursor = '%' then
              begin
                PerCentage := True;
                Advance; // Colno := Succ(Colno);
              end;
            end;
   End;

   Procedure CheckClass;
      { Check to see what type of character is currently being }
      { read in from the text stream }
   var
      st1  : namestr;
      temp : real;
      code : integer;
   begin
       Case StartClass of
           4 : begin
                 Val(Symbol, temp, Code);
                 if Code<>0 then
                     LexicalError (' A String starting with a number is invalid ','','');
               end;
           5 : begin
                 if not((Symbol ='>')  OR (Symbol ='<')  OR
                     (Symbol ='>=') OR  (Symbol ='<=')) then
                     LexicalError (' A symbol Starting with < OR > must be one of the ',
                                   ' Following : >=, <=, >, < ','');
               end;
           6 : begin
                 if not(Symbol[1] in ['.','(',')','%','',':','+','=','-','*','/','[',']']) then
                     LexicalError(' Only one of the following symbols ',
                                  ' acceptable: ., %, , :, +, =, -, *, / ','');
               end
       end;
   end;

begin
   FindNextWord;
   if (not(Globerr)) then
      begin
        ErrorCol := ActiveRich.CaretX; //Curwin^.ColNo;
        ErrorLine := ActiveRich.CaretY; // Curwin^.CLineNo;
        if ((ErrorLine=9) and (ErrorCol=1)) then
          ErrorCol:= ErrorCol - 1 + 1;
      end;
   if EndOfStream then
      symbol:='EOF1'
   else
      begin
         ReadInSymbol;
         CheckClass;
         MoveTheCursor;
         //with Curwin^ do
         //    gotoxy(Succ (Colno-LeftEdge),FirstLineNo+LineNo);
         SetPushChar;
      end;
end;

Function StrNum(Instring : ShortStr): Longint;
var
   valu : Longint;
   code : integer;
begin
   val(Instring,valu,code);
   if code = 0 then
      StrNum := valu
   else
      StrNum := 0;
end;


Procedure NextToken;
   { This reads the next symbol from the input stream and then finds the }
   { token which it represents }
var
   code,
   TestNum      : integer;
begin
  try
   if (Globerr = TRUE) then
      token := eof1;
   if (token = eof1) then
      exit;
   AddExp(ExpTem);
   Inc(TokenNumber);
   if (TokenNumber = 2) then
       LastToken := Token
   else if (TokenNumber > 2) then
       begin
          PenToken := LastToken;
          LastToken := Token;
          PenSymbol := LastSymbol;
       end;
   LastSymbol := Symbol;
   readsymbol(Sender);
   if symbol='EOF1' then
     token:=eof1
   else if not(IsDigit(symbol[1])) then
     begin
       if SymbolToToken then
         begin
             if (token in [TRUE1, FALSE1]) then
               begin
                   if (VarArray[CurrentUservar]^.Ifbool=FALSE) then
                     begin
                       If ((lasttoken in [then1,colon]) or
                           ((lasttoken=equals)and(pentoken=curuservar))) then
                               LexicalError('ERROR : You are trying to assign the value',
                                            'TRUE or FALSE to a variable which is not boolean',
                                            'you can only do this with a boolean variable');
                     end;
                   if (symbol = 'TRUE') then
                      numb:=1
                   else
                      numb:=0;
                   ExpTemp(Symbol);
               end
             else if ((Token = Per_Year)or(Token = Per_Month)) then
               begin
                   If ValidNumber (LastSymbol) then
                     begin
                         Delete(ExpStr,Length(ExpStr)-(Length(LastSymbol)-1),
                                Length(LastSymbol));
                         if (Token = Per_Month) then
                            ExpTemp(NumStr(StrNum(LastSymbol) * 12))
                         else
                            ExpTemp(NumStr(StrNum(LastSymbol)));
                         // ExpTemp(NumStr(StrNum(LastSymbol) div 52));
                         NextToken;
                     end
                   else
                     LexicalError ('ERROR The Term Per_Year MUST follow a',
                                   'Valid Number','');
               end
             Else if Analysis_Lev_Token then
               begin
                   numb:=token;
                   token:=Analysis_level;
               end
             else if Pointer_Token(token) then
               begin
                   numb:=token;
                   token:=Pointer;
                   exptem:= '';
               end
             else
               begin
                   PasStr:= TokenToPascal(Token);
                   if ((token = equals) and ((lasttoken = curuservar)or
                       (Indexing=TRUE))) then
                      PasStr := ':=';
                   if ((PasStr<>'') and (PasStr<>'UNKNOWN SYMBOL')) then
                      ExpTemp(PasStr);
               end;
         end
       else
         begin
           if ValidValueLabel(TestNum) then
             begin
               token:=NUMBER;
               numb:=TestNum;
               ExpTemp(numstr(TestNum));
             end
           else if ExistingUserVar(TestNum) then
             begin
               UserVarUsed := True;
               token:=VARIABLE;
               variablestr:=symbol;
               ExpTemp(variablestr);
               numb:=TestNum;
               if (UpSymbol=UserVStr) then
                  token := CurUserVar;
               if (VarArray[numb]^.IfReal = TRUE) then
                 begin
                   check_real;
                   token := REALNUMBER;
                 end;
             end
           else if ValidArray then
             begin
               token:=ARRAY1;
               variablestr:=symbol;
               exptemp(variablestr);
             end
           else if ValidVariable then
             begin
               token:=VARIABLE;
               variablestr:=symbol;
               ExpTemp(variablestr);
               numb:=TestNum;
             end
           else if UserConstant then
             begin
               if (Menu_Type = Start_Tax) then
                  begin
                      tokenstr := 'T['+ NumStr(Const_Tax_Num) +
                                 '].C[' + NumStr(Found_Const_Num) +
                                 ']^.';
                      if (UserVStr = UpCaseNewStr(TBStr) + '_RATE') then
                          begin
                             tokenstr := tokenstr +'OLD';
                             ExpTemp(tokenstr);
                             tokenstr := '';
                             token := USER_CONST;
                             exit;
                          end;
                  end
               else
                  begin
                      tokenstr := 'B['+ NumStr(Const_Ben_Num) +
                                 '].C[' + NumStr(Found_Const_Num) +
                                 ']^.';
                      if (UserVStr = UpCaseNewStr(TBStr) + '_TAPER') then
                          begin
                             tokenstr := tokenstr +'OLD';
                             ExpTemp(tokenstr);
                             tokenstr := '';
                             token := USER_CONST;
                             exit;
                          end;
                  end;
               if (c_ary[Found_Const_Num]^.disptype = PerCent) then
                  begin
                    tokenstr := tokenstr +'OLDREAL';
                    symbol := tokenstr;
                    token := REALNUMBER;
                    check_real;
                    ExpTemp(TokenStr);
                  end
               else
                  begin
                    tokenstr := tokenstr +'OLD';
                    ExpTemp(tokenstr);
                    symbol := '';
                    token := USER_CONST;
                  end;
             end
           else if reserved_word(UpSymbol) then
             begin
                ExpTemp(Symbol);
                Token := VARIABLE;
             end
           else
             begin
             if ( UserConstant ) then
                 LexicalError ('ERROR: A command or data variable was expected',
                   'The Symbol ' + Symbol + ' was not recognised','');
             end;
         end;
     end
   else if IsDigit(symbol[1]) then
     begin
       If (pensymbol='REVENUE') then
          begin
             symbol:= symbol + '.0';
             Number_Real:=true;
          end;
       If ValidNumber(Symbol) then
          begin
             If PoundSign then
                Process_Money
             Else if Percentage then
                begin
                   token := REALNUMBER;
                   if (Indexing=FALSE) then
                      begin
                         check_real;
                         Process_Percent;
                      end;
                end
             Else if Number_Real then
                begin
                   token := REALNUMBER;
                   if (pensymbol <> 'REVENUE') then
                      check_real;
                   Process_Real;
                end
             Else
                Process_Number;
          end
       else
          LexicalError('ERROR: a Valid Number was expected','','');
     end;
 finally
   PoundSign:=false;
   Percentage:=false;
   Number_Real:=false;
 end;
end;

Procedure Accept(ExpectToken: tokentype);
   { This accepts a token of a given type and looks for the next token }
   { or if the current token is not of the expected type then it prints }
   { an error message }
begin
   if token <> ExpectToken then
      Unexpected(ExpectToken);
   nexttoken;
end;

Procedure Swallow(ExpToken: tokentype);
   { This accepts a token of a given type and looks for the next token }
   { or if the current token is not of the expected type then it prints }
   { an error message }
begin
   if (token = ExpToken) then
     begin
        exptem:='';
        NextToken;
     end;
end;

Procedure AssignUserVar(var vnum : integer);
   { This creates a new entry in the Variable Array }
var
   Filestr : String[12];
   i : byte;
   varok   : boolean;
begin
   LastVar := UserVStr;
   UserVStr:=UpCaseNStr(Symbol);
   VarOK := True;
   for i := 1 to length(UserVStr) do
       if (ord(UserVStr[i])=39) then VarOK := FALSE;
   If (VarOK = FALSE) then
       begin
          LexicalError('ERROR: You cannot have a quotation mark',
                       'in the middle of a variable name',
                       'You must delete it before you can proceed');
          exit;
       end;
   CurrentUserVar:=VNum;
   if vnum=highestvar then
       Inc(UserFileNum);
   with VarArray[VNum]^ do
     begin
       assigned:=true;
       VarArray[VNum]^.LongPtr^:=Symbol;
       VarArray[VNum]^.BigPtr^:=UserVStr;
       VarArray[VNum]^.Level := Anal_Level[1];
       VarArray[VNum]^.VarName := 'CALC';
       IfVallabs:=False;
       IfMoney:=False;
       Factor:=1;
       IfBool:=False;
       IfReal:=False;
     end;
end;

Procedure Statement; forward;

Procedure Expression; forward;

Procedure Constant;
   { this places the values of different types of constant on the heap }
   { and shows an error message if it is not a valid constant }
var
   val : Longint;
begin
  val:=-99;
  case token of
      TRUE1 : val :=1;
      FALSE1: val :=0;
      NUMBER: val :=numb;
      HI    : val :=highest;
      LO    : val :=lowest;
      PERCENT,
      MONEY,
      REALNUMBER: exit;
  end;
  if val=-99 then
      LexicalError(' A constant i.e. a number, True, false, '+
                   'Highest, Lowest,etc was expected','','');
end;

Procedure Varyable;
    { This processes a variable and puts a VARIABLE token on the heap }
    { and the number of the variable in the file array }
var
    filenum : integer;
    tempstring : String78;
begin
    if not(OpenVarFile(variablestr,filenum)) then
        begin
          Tempstring:='ERROR : could find variable ' + variablestr;
          LexicalError(Tempstring,'','');
        end;
    numb:= filenum;
end;

Function IsConstant:boolean;  { This returns true if the current token is }
                              { a number or a special constant            }
begin
    if token in [REALNUMBER, PERCENT,MONEY,NUMBER,
                           TRUE1,FALSE1,HI,LO] then
       IsConstant:=true
    else
       IsConstant:=false;
end;

Procedure Process_Pointer;
   { This puts a family or household relationship pointer on the heap }
var
   LastTok : integer;
begin
   if (Pointer_Token(PenToken)) then
       begin
          LexicalError(
          'ERROR - You have two pointers to household members',
                       'in a row. You are only allowed one',
                       '');
          exit;
       end;
   LastTok := Numb;
   NextToken;
   If (LastTok = Head_of_Households) then FuncStr := 'Hold[1,1]^.'
   else if (LastTok = Head_of_Familys) then FuncStr := 'Hold[fam,1]^.'
   else if (LastTok = Husbands) then FuncStr := 'Hold[fam, HUSPOS]^.'
   else if (LastTok = Wifes) then FuncStr    := 'Hold[fam, WIFPOS]^.'
   else LexicalError('ERROR ' + TokentoSymbol(numb) +
             ' must be preceded by the words',
             'Head_of_Household''s or Head_of_Tax_Unit''s','');
end;

Procedure ProcessValueLabel;
   { This processes a value label and puts it on the heap }
var
   i,
   Val : integer;

begin
    If not(VarArray[CurrentUserVar]^.IfVallabs) then
      begin
         VarArray[CurrentUserVar]^.IfVallabs:=True;
         CurrentValLab :=0;
      end;
    ReadSymbol(Sender);
    i := 0;
    repeat
       inc(i);
       if (UpCaseNewStr(Symbol) = UpCaseNewStr(TempVals.Names[i])) then
          begin
             Val:= i;
             NextToken;
             AddExp(NumStr(i));
             exit;
          end;
    until (i > CurrentVallab);
    CurrentValLab:=Succ(CurrentValLab);
    TempVals.Numbers[CurrentValLab]:=CurrentValLab;
    TempVals.Names[CurrentValLab]:=Symbol;
    Val:=CurrentValLab;
    if (lasttoken = Colon) then
       ExpTem := '';
    NextToken;
    AddExp(NumStr(CurrentValLab));
end;

Procedure Push_Anal_token;
   { This puts an analysis level token on the heap }
begin
  Inc(Com_Lev);
  Anal_Operator := Numb;
  Case Anal_Operator of
       Any_In_HouseHold,
       Number_In_Household,
       Total_HouseHold    :  begin
                               Anal_Level[Com_Lev]:=Household;
                               Inc(HsVarNo);
                               AnVar := 'Hs[' + NumStr(HsVarNo) + ']';
                             end;
       Any_In_Family,
       Number_in_Family,
       Total_Family       :  begin
                                Anal_Level[Com_Lev]:=Family;
                                Inc(TxVarNo);
			                          AnVar := 'TxUns[fam].Tx' + NumStr(TxVarno);
                             end;
  end;
  NextToken;
end;

Procedure Process_Anal_Func;
begin
   Case Anal_Operator of
     Any_In_Family :
          WriteAnStat('If (' + AnalStr + ') then ' + Anvar + ':= 1;');
     Number_In_Family :
          WriteAnStat('If (' + AnalStr + ') then '
                          + Anvar + ':= ' + Anvar + '+ 1;');
     Total_Family :
          WriteAnStat(AnVar +':= '+ Anvar + ' + ' + AnalStr + ';');
     Any_In_Household :
          WriteAnStat('If (' + AnalStr + ') then ' + Anvar + ':= 1;');
     Number_In_Household :
          WriteAnStat('If (' + AnalStr + ') then '
                          + Anvar + ':= ' + Anvar + '+ 1;');
     Total_Household :
          WriteAnStat(AnVar + ':= ' + Anvar + ' + ' + AnalStr + ';');
   end;
end;

Procedure Write_Expression;
begin
    if (Com_Lev = 1) then
       begin
          if (ExpStr <> '') then WritePln(ExpStr);
          ExpStr := '';
       end
    else
       begin
          AnalStr := AnalStr + ExpStr;
          ExpStr := '';
       end;
end;

Procedure Process_Array;
begin
   exptemp(variablestr);
   nexttoken;
   accept(lsquare);
   If not (token in [VARIABLE,CURUSERVAR,NUMBER]) then
          begin
              LexicalError('ERROR - The index for this array must come here'+
              LastSymbol,'','');
          end;
   NextToken;
   Accept(rsquare);
end;

Procedure Factor;
     { This processes a factor }
var
    TempStr :  String;
    tbnum   : integer;
begin
    case token of
      RANDOM         : Begin
                          if (tbstr='') then
                          begin
                             exptem:='Random';
                             exptem:= exptem+'(100)';
                          end;
                          exptem:= exptem+'(100)';
                          accept(RANDOM);
                         // accept(LBRACK);
                         // nexttoken;
                          { if (tbstr<>'') then
                             begin
                                tbnum:=tbplace(tbstr);
                                str(tbnum,tempstr);
                                addexp(',');
                                addexp(tempstr);
                             end;
                          accept(RBRACK);  }
                       end;
      EXP1,
      ABS1           : Begin
                          nexttoken;
                          accept(LBRACK);
                          expression;
                          accept(RBRACK);
                       end;
      ANALYSIS_LEVEL : Begin
                          Analstr := '';
                          UserVarUsed := False;
                          TempStr := ExpStr;
                          ExpTem := '';
                          Push_Anal_Token;
                          accept(LBRACK);
                          ExpStr:='';
                          while ((token <> RBRACK) and
                                 (globerr = FALSE)) do
                              Expression;
                          Write_Expression;
                          Dec(Com_Lev);
                          Process_Anal_Func;
                          ExpStr := TempStr;
                          If Anal_Operator in[Any_in_household,Any_in_Family]
                              then AddExp('(' + Anvar + '= 1)')
                          else
                              AddExp(AnVar);
                          ExpTem:='';
                          accept(RBRACK);
                       end;
      IS_FLAG : ProcessValueLabel;
      POINTER : Begin
                   Process_Pointer;
                   AddExp(FuncStr);
                   if not(Token in [Variable,CurUserVar]) then
                      begin
                         LexicalError('ERROR - A variable must come after '+
                         LastSymbol,'','');
                      end
                   else
                      begin
                         Expstr := expstr + symbol;
                         ExpTem := '';
                         Factor;
                      end;
                end;
      LBRACK  : Begin
                   accept(token);
                   repeat
                     Expression;
                   until ((token = RBRACK) or Globerr);
                   accept(RBRACK);
                end;
      NOT1    : begin
                   accept(NOT1);
                   Factor;
                end;
    USER_CONST: begin
                   NextToken;
                end;
    ARRAY1    : begin
                   process_array;
                end;
      VARIABLE,
    CURUSERVAR: begin
                   varyable;
                   NextToken;
                end;
    REALNUMBER: begin
                   ExpTemp(Symbol);
                   NextToken;
                end;
      else
         begin
           if IsConstant then
              Constant
           else
              LexicalError('ERROR - The Symbol ' + Symbol +
                                  ' is not acceptable',
                                  'at this point in your equation','');
           NextToken;
         end;
    end;
end;

Procedure WithDrawExpr;
   { This processes a withdrawal rate expression }
var
    FactStr : String;
    FactPos : Integer;

begin
    FactPos := Length(ExpStr);
    Factor;
    While token = WITHDRAWN_BY do
       begin
          FactStr := Copy (ExpStr,FactPos+1,Length(ExpStr) - FactPos);
          Delete(ExpStr, FactPos+1, Length(ExpStr) - FactPos);
          ExpStr :=  ExpStr + 'Withdrawn_by(' + FactStr;
          ExpTem:='';
          NextToken;
          AddExp(',');
          AddExp(ExpTem);
          AddExp(',');
          ExpTem:='';
          NextToken;
          ExpTem:='';
          Accept(TIMES);
          AddExp('(');
          Expression;
          AddExp('))');
       end;
    While token = TO_POWER_OF do
       begin
          FactStr := Copy (ExpStr,FactPos+1,Length(ExpStr) - FactPos);
          Delete(ExpStr, FactPos+1, Length(ExpStr) - FactPos);
          ExpStr :=  ExpStr + 'To_Power_Of(' + FactStr;
          AddExp(',');
          ExpTem:='';
          NextToken;
          ExpTem:='';
          Accept(LBRACK);
          ExpTem:='';
          AddExp(Symbol);
          NextToken;
          Accept(RBRACK);
       end;
end;

Procedure MultExpr;
   { This processes a multiplication/division expression }
var
  op : tokentype;
  WithPos,
  WithPos1,
  WithPos2 : Integer;
  Fact1,
  Fact2,
  WithStr  : String;
begin
  WithPos := Length(ExpStr);
  WithDrawExpr;
  if ((LastToken = REALNUMBER) and (token = TIMES)) then
      begin
         WithStr := Copy (ExpStr, WithPos+1,Length(ExpStr) - WithPos);
         Delete(ExpStr, WithPos + 1, Length(ExpStr) - WithPos);
         ExpStr := ExpStr + 'round(' + WithStr + '*';
         ExpTem:='';
         NextToken;
         WithdrawExpr;
         AddExp(')');
      end
  else if (token in [TIMES]) then
      begin
         WithPos1 := Length(ExpStr);
         Fact1 := Copy (ExpStr, WithPos+1,Length(ExpStr) - WithPos);
         NextToken;
         WithPos2 := Length(ExpStr);
         WithDrawExpr;
         if (LastToken = REALNUMBER) then
           begin
             Fact2 := Copy(ExpStr,WithPos2+1,Length(ExpStr)-WithPos2);
             Delete(ExpStr, WithPos + 1, Length(ExpStr) - WithPos);
             ExpStr:=ExpStr+'round('+Fact1+'*'+Fact2+')'
           end;
      end
  else if (token = DIVIDE) then
      begin
         WithStr := Copy (ExpStr, WithPos+1,Length(ExpStr) - WithPos);
         Delete(ExpStr, WithPos + 1, Length(ExpStr) - WithPos);
         if (VarArray[currentuservar]^.ifreal=TRUE) then
            ExpStr := ExpStr + 'Div0(' + WithStr + ','
         else
            ExpStr := ExpStr + 'DivInt(' + WithStr + ',';
         ExpTem:='';
         NextToken;
         WithdrawExpr;
         AddExp(')');
      end
  else if (token = DIV1) then
      begin
         NextToken;
         WithdrawExpr;
      end;
end;

Procedure PlusExpr;
    { this processes an addition or subtraction expression }
var
    op : tokentype;
    MultPos : Integer;
    MultStr : String;

                              { compile an expression involving addition}
                              { or subtraction }
begin
   MultPos := Length(ExpStr);
   MultExpr;
   if token in [plus, minus] then
     begin
         nextToken;
         MultExpr;
     end
   else if token = Less then
     begin
         MultStr := Copy (ExpStr, MultPos+1,Length(ExpStr) - MultPos);
         Delete(ExpStr, MultPos + 1, Length(ExpStr) - MultPos);
         ExpStr := ExpStr + 'Less(' + MultStr + ',';
         ExpTem:='';
         NextToken;
         Multexpr;
         AddExp(')');
     end;

   Flush_Expstr(230);
end;

Function IsRelOp:boolean;
    { This tests to see if the current token is a valid relational operator }
begin
   if token in [EQUALS,NE,GT,GE,LT,LE,EQMV,NEMV] then
      IsRelOp:=true
   else
      IsRelOp:=false;
end;

Procedure RelExpr;
                                  { compile a relational expression }
begin
  PlusExpr;
  while isRelOp do
    begin
        nexttoken;
        PlusExpr;
    end;
end;

Procedure AndExpr;               { compile RelExpr ... and RelExpr ....}
                                 { and RelExpr ....                    }
begin
   RelExpr;
   while token = AND1 do
     begin
        if (lasttoken <> RBRACK) then
           LexicalError('ERROR: The symbol AND must always follow',
                        'A closing bracket.  Different clauses in a condition',
                        'must be enclosed in brackets.');
        nextToken;
        RelExpr;
     end;
end;

Procedure Expression;          { compile an expression }
begin
   if token = plus then accept(plus);
   if token = minus then
     accept(minus);
   andExpr;
   while token = OR1 do
     begin
       if (lasttoken <> RBRACK) then
           LexicalError('ERROR: The symbol OR must always follow',
                        'A closing bracket.  Different clauses in a condition',
                        'must be enclosed in brackets.');
       NextToken;
       AndExpr;
     end;
end;

Procedure IfThenElse;
   { Parses an if ... then ... else expression }
begin
   blankstr:= origblank;
   accept(if1);
   expression;
   accept(then1);
   Flush_ExpStr(0);
   idbuf^.tx := idbuf^.tx + '    ';
   blankstr := blankstr + '    ';
   if not(token =if1) then
      begin
         if (paramstr(1) = 'IX') then
            begin
               if ((UpCaseNewStr(symbol) = UserVStr) and (TempCh = '=')) then
                  begin
                     Swallow(Variable);
                     Swallow(equals);
                  end;
               Addexp(assignstr);
            end
         else
            begin
               swallow(CurUservar);
               if (token = is_flag) then
                 addexp(UserVStr)
               else
                 addexp(AssignStr);
               swallow(Equals);
             end;
      end;
   expression;
   flush_expstr(0);
   blankstr := origblank;
   delete(idbuf^.tx,(length(idbuf^.tx)-4),4);
   if (token=else1) then
     begin
       accept(else1);
       if not(token in[if1,CurUserVar]) then
         begin
           if (paramstr(1) = 'IX') then
             begin
               if ((UpCaseNewStr(symbol) = UserVStr) and (TempCh = '=')) then
                  begin
                     Swallow(Variable);
                     Swallow(equals);
                  end;
               Addexp(assignstr);
             end
           else
             begin
               swallow(CurUservar);
               if (token = is_flag) then
                 addexp(UserVStr)
               else
                 addexp(AssignStr);
               swallow(Equals);
             end;
         end;
       statement;
     end;
end;

Procedure Statement;
   { parses a statement }
begin
   case token of
       if1 : IfThenElse;
     else
       expression;
   end;
end;

Procedure GotoStartOfNextRule;
    { Go to the left hand edge of the current line within the input stream }
begin
    ActiveRich.startOfLine;
    ActiveRich.CaretX:=1;
    delay(5);
    //EditBeginningLine;
end;

Procedure EditEndLine;
{  This routine positions the cursor to the right of the last non-
   blank character in the line.
}
var
  ypos : integer;
begin
  {Position after last char}
 { with Curwin^, Curline^ do
  begin
    Colno := BuffLen;
    while (Txt^ [Colno] = ' ') and (Colno > 1) do
      Colno := Pred (Colno);
    if Colno < BuffLen then
      if Txt^ [Colno] <> ' ' then
    Colno := Succ (Colno);
  end; }
  ActiveRich.endOfLine;
end;


Procedure FindNextLine;
   var
      st1 : namestr;
      i   : Integer;
   begin
     EditEndLine;
     repeat
         ActiveRich.nextLine;
         ActiveRich.startOfLine;
     until ActiveRich.endOfStream or (ActiveRich.GetCharAtCursor in ['!'..'}','']);
     If (ActiveRich.endOfStream) then Symbol := 'EOF1';
   end;

Procedure Start_Policy_or_Charge;
begin
    new_policy:=0;
    inside_unit_cost_definition:=true;
    unit_cost_definitions_found:=true;
    Menu_Type := Token;
    ReadSymbol(Sender);
    TBstr := Symbol;
    ExpStr :=  '';
    ccw:=1;
    if (token = Start_Charge) then
       Inc(Const_Chg_Num)
    else
       Inc(Const_Pol_Num);
    Const_Num := 0;
    FindNextLine;
    DescriptionString:='';
    Source1:='';
    Source2:='';
    Targ_Exp:=0;
    Targ_Recip:=0;
end;

Procedure Start_TB;
begin
    if (unit_cost_definitions_found) then
    begin
        LexicalError(' ERROR : You cannot have a tax or benefit policy definition here because',
                     ' you have already used a START_CHARGE or a START_POLICY key word.',
                     ' Put all of these unit_cost definitions at the end of your model.');
    end;
    new_policy:=0;
    Menu_Type := Token;
    ReadSymbol(Sender);
    TBstr := Symbol;
    End_Until(idbuf);
    ExpStr :=     '{ START OF PROCEDURE '+ TBStr + '}';
    Flush_ExpStr(0);
    ExpStr :=     '             Proc_'+ TBStr+';';
    Flush_ExpStr(0);
    Begin_Repeat(idbuf);
    ccw:=1;
    if (token = Start_Tax) then
       Inc(Const_Tax_Num)
    else
       Inc(Const_Ben_Num);
    Const_Num := 0;
    FindNextLine;
    DescriptionString:= '';
    Source1:='';
    Source2:='';
    Targ_Exp:=0;
    Targ_Recip:=0;
end;

Procedure End_TB;
var
    targstr : str50;
    tnum  : integer;
    TBnum : integer;

begin
    tnum := 1;
    TBNum := TBPlace(TBStr);
    If (VarArray[currentuservar-1]^.Level = HouseHold) then
      begin
         ExpStr := ExpStr + 'If ((fam=1) and (per=1)) then ';
         Flush_ExpStr(0);
         Expstr:= '                ';
      end
    Else if (VarArray[currentuservar-1]^.Level = Family) then
      begin
         ExpStr := ExpStr + 'If (per=1) then ';
         Flush_ExpStr(0);
         Expstr:= '                ';
      end;
    ExpStr := 'TxBn_Ary[' + NumStr(TBNum) + ']^.OLD := TxBn_Ary['
              + Numstr(TBNum) + ']^.OLD + ';
    Flush_ExpStr(0);
    Expstr:= '                ';
    If (VarArray[currentuservar-1]^.Level = HouseHold) then
         ExpStr := ExpStr+'Rev_Mult('+LastVar+',HO_GrFact(fam,per,'+ Numstr(TBnum)+'));'
    Else if (VarArray[currentuservar-1]^.Level = Family) then
         ExpStr := ExpStr+'Rev_Mult('+LastVar+',TU_GrFact(fam,per,'+ NumStr(TBnum)+'));'
    Else
         ExpStr := ExpStr+'Rev_Mult('+LastVar+',Ind_GrFact(fam,per,'+NumStr(TBnum)+'));';
    Flush_ExpStr(0);
    ExpStr := 'If (' + Lastvar + ' > 0) then';
    Flush_ExpStr(0);
    ExpStr := '   TxBn_Ary[' + NumStr(TBNum) + ']^.CRecip := TxBn_Ary['
              + Numstr(TBNum) + ']^.CRecip + ';
    Flush_ExpStr(0);
    Expstr:= '                ';
    If (VarArray[currentuservar-1]^.Level = HouseHold) then
         ExpStr := ExpStr+'HO_GrFact(fam,per,'+NumStr(TBnum)+');'
    Else if (VarArray[currentuservar-1]^.Level = Family) then
         ExpStr := ExpStr+'TU_GrFact(fam,per,'+NumStr(TBnum)+');'
    Else
         ExpStr := ExpStr+'Ind_GrFact(fam,per,'+NumStr(TBnum)+');';
    Flush_ExpStr(0);
    End_Until(idbuf);
    ExpStr:= '{ END OF PROCEDURE '+ TBStr + ' } ';
    Flush_ExpStr(0);
    Begin_Repeat(idbuf);
    WriteBufs;
    Writeln(TBDefines,'   New(TxBn_Ary[',NumStr(TBNum),']);');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Name   := ''',LastVar,''';');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.OLD    := 0;');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Valu   := 0;');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.CRecip := 0;');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.NRecip := 0;');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Recip  := ',Targ_Recip,';');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Exp    := ',Targ_Exp,';');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Source1 := ''',Source1,''';');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Source2 := ''',Source2,''';');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.ccw:= ',ccw:3:3,';');
    if (new_policy=0) then
       begin
           Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.OldStatus:=True;');
           Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.NewStatus:=True;');
       end
    else
       begin
           Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.OldStatus:=False;');
           Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.NewStatus:=False;');
       end;
    if (token = End_Tax) then
       begin
          Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Mode := ',Tax,';');
          writeln(tmenhead,'   MenuAssign(''',TBstr,''',Tax,',new_policy,');');
          if (LastVar <> UpCaseNewStr(TBStr)) then
            begin
               LexicalError(
                  'The second to last definition must be the tax bill for',
                  TBStr + '. Enter an equation to calculate this',
                  'and call the variable : ' + TBStr);
                  FindNextLine;
                  exit;
            end;
          Idbuf^.tx := Idbuf^.tx + 'total_taxes := total_taxes + ' + LastVar + ';';
	       while (C_ary[tnum] <> Nil) do
	       begin
          if (C_Ary[tnum]^.realval=0) then
              C_Ary[tnum]^.realval:=C_Ary[tnum]^.valu;
      		writeln(cdefines,'   SetConstant(Tax,',Const_Tax_Num,',',Tnum,
		          ',''',C_Ary[tnum]^.name,''',',C_Ary[tnum]^.valu,',',
		      C_Ary[tnum]^.disptype,',',C_Ary[tnum]^.dispnum,',',C_Ary[tnum]^.realval:8:4,');');
      		inc(tnum);
          end;
          TargStr := UpCaseNewStr(TBStr) + '_RATE';
          If (UserVStr <> TargStr) then
            LexicalError(
                  'The last definition must be the marginal tax rate for',
                  TBStr + '. Enter an equation to calculate this ',
                  'and call the variable : ' + TBStr + '_Rate')
          else
            begin
                WriteBufs;
                Idbuf^.tx := Idbuf^.tx + 'marg_rate_before := marg_rate_before +' +  UserVStr +';';
                WriteBufs;
            end;
       end
    else
       begin
          Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Mode := ',Benefit,';');
          writeln(bmenhead,'   MenuAssign(''',TBstr,''',Benefit,',new_policy,');');
          if (LastVar <> UpCaseNewStr(TBStr)) then
            begin
               LexicalError(
                  'The second to last definition must be the benefit amount for',
                  TBStr + '. Enter an equation to calculate this',
                  'and call the variable : ' + TBStr);
                  FindNextLine;
                  exit;
            end;
          Idbuf^.tx := Idbuf^.tx + 'total_benefits := total_benefits + ' + LastVar + ';';
          while (C_ary[tnum] <> Nil) do
            begin
               if (C_Ary[tnum]^.realval=0) then
                    C_Ary[tnum]^.realval:=C_Ary[tnum]^.valu;
               writeln(cdefines,'   SetConstant(Benefit,',Const_Ben_Num,',',Tnum,
                    ',''',C_Ary[tnum]^.name,''',',C_Ary[tnum]^.valu,',',
                    C_Ary[tnum]^.disptype,',',C_Ary[tnum]^.dispnum,',',C_Ary[tnum]^.realval:8:3,');');
               inc(tnum);
            end;
          TargStr := UpCaseNewStr(TBStr) + '_TAPER';
          If (UserVStr <> TargStr) then
             LexicalError(
                  'The last definition must be the taper for',
                  TBStr + '. Enter an equation to calculate this ',
                  'and call the variable : ' + TBStr + '_Taper')
          else
            begin
                WriteBufs;
                Idbuf^.tx := Idbuf^.tx + ' marg_rate_before := marg_rate_before + ' + UserVStr + ';';
                WriteBufs;
            end;
       end;
    tnum := 1;
    while (C_Ary[tnum] <> NIL) do
      begin
         dispose(C_Ary[tnum]);
         C_Ary[tnum]:= NIL;
         Inc(tnum);
      end;
    Const_Num := 0;
    FindNextLine;
    tbstr:='';
end;

Procedure End_Policy_or_Charge;
var
    targstr : str50;
    tnum  : integer;
    TBnum : integer;
    lConstants : integer;

begin
    tnum := 1;
    TBNum := TBPlace(TBStr);
    ExpStr := 'TxBn_Ary[' + NumStr(TBNum) + ']^.OLD := TxBn_Ary['
              + Numstr(TBNum) + ']^.OLD + ';
    {
        In the next block of code we should cycle through all the units in this section.
        For each User-Defined Constant we should multiply the number of units
        by the unit cost.
    }
    if (token = End_Charge) then
      begin
        ExpStr:= 'This_Tax := ';
        lConstants:=0;
        for lConstants:= 1 to (Const_Num-1) do
          begin
            ExpStr := ExpStr +  '(C['+ NumStr(Const_Chg_Num) + '].C['+NumStr(lConstants)+']^.unit_cost * ' +
                                'C['+ NumStr(Const_Chg_Num) + '].C['+NumStr(lConstants)+']^.units) +' ;
            Flush_Policy_ExpStr(0);
          end;
        if (lConstants=0) then lConstants:= 1;
        ExpStr := ExpStr + '(C['+ NumStr(Const_Chg_Num) + '].C['+NumStr(lConstants)+']^.unit_cost * ' +
                      'C['+ NumStr(Const_Chg_Num) + '].C['+NumStr(lConstants)+']^.units);' ;
        Force_Flush_Policy_ExpStr(0);
        ExpStr := 'TxBn_Ary[' + NumStr(TBNum) + ']^.OLD := TxBn_Ary['
              + Numstr(TBNum) + ']^.OLD + This_Tax;';
        Force_Flush_Policy_ExpStr(0);
        ExpStr := 'total_taxes := total_taxes + This_Tax;';
        Force_Flush_Policy_ExpStr(0);
      end
    else
      begin
        ExpStr:= 'This_Benefit := ';
        lConstants:=0;
        for lConstants:= 1 to (Const_Num-1) do
          begin
            ExpStr := ExpStr +  '(P['+ NumStr(Const_Pol_Num) + '].C['+NumStr(lConstants)+']^.unit_cost * ' +
                                'P['+ NumStr(Const_Pol_Num) + '].C['+NumStr(lConstants)+']^.units) +' ;
            Flush_Policy_ExpStr(0);
          end;
        if (lConstants=0) then lConstants:= 1;
        ExpStr := ExpStr + '(P['+ NumStr(Const_Pol_Num) + '].C['+NumStr(lConstants)+']^.unit_cost * ' +
                           'P['+ NumStr(Const_Pol_Num) + '].C['+NumStr(lConstants)+']^.units);' ;
        Force_Flush_Policy_ExpStr(0);
        ExpStr := 'TxBn_Ary[' + NumStr(TBNum) + ']^.OLD := TxBn_Ary['
                   + Numstr(TBNum) + ']^.OLD + This_Benefit;';
        Force_Flush_Policy_ExpStr(0);
        ExpStr := 'total_benefits := total_benefits + This_Benefit;';
        Force_Flush_Policy_ExpStr(0);
      end;
    // ExpStr:= '{ END OF PROCEDURE '+ TBStr + ' } ';
    Flush_Policy_ExpStr(0);
    WriteBufs;
    Writeln(TBDefines,'   New(TxBn_Ary[',NumStr(TBNum),']);');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Name   := ''',UpCaseNewStr(TBStr),''';');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.OLD    := 0;');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Valu   := 0;');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.CRecip := 0;');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.NRecip := -99;');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Recip  := ',Targ_Recip,';');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Exp    := ',Targ_Exp,';');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Source1 := ''',Source1,''';');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Source2 := ''',' ',''';');
    Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.ccw:= ',ccw:3:3,';');
    if (new_policy=0) then
       begin
         Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.OldStatus:=True;');
         Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.NewStatus:=True;');
       end
    else
       begin
         Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.OldStatus:=False;');
         Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.NewStatus:=False;');
       end;
    if (token = End_Charge) then
       begin
         Writeln(TBDefines, '   TxBn_Ary['+NumStr(TBNum)+']^.Mode := ',Charge,';');
         writeln(cmenhead,  '   MenuAssign(''',TBstr,''',Charge,',new_policy,');');
	       while (C_ary[tnum] <> Nil) do
	       begin
            writeln(cdefines,'   SetPolicyConstant(Charge,',Const_Chg_Num,',',Tnum,
		          ',''',C_Ary[tnum]^.name,''',',C_Ary[tnum]^.valu,',',
		          C_Ary[tnum]^.disptype,',',C_Ary[tnum]^.dispnum,',',C_Ary[tnum]^.realval:16:4,',',
              C_Ary[tnum]^.unit_cost:16:4, ',', C_Ary[tnum]^.units:16:4,
              ',''',C_Ary[tnum]^.Desc,''');');
      		  inc(tnum);
         end;
       end
    else
       begin
          Writeln(TBDefines,'   TxBn_Ary['+NumStr(TBNum)+']^.Mode := ',Policy,';');
          writeln(pmenhead,'   MenuAssign(''',TBstr,''',Policy,',new_policy,');');
          while (C_ary[tnum] <> Nil) do
          begin
             writeln(cdefines,'   SetPolicyConstant(Policy,',Const_Pol_Num,',',Tnum,
               ',''',C_Ary[tnum]^.name,''',',C_Ary[tnum]^.valu,',',
               C_Ary[tnum]^.disptype,',',C_Ary[tnum]^.dispnum,',',C_Ary[tnum]^.realval:16:4,',',
              C_Ary[tnum]^.unit_cost:16:4, ',', C_Ary[tnum]^.units:16:4,
              ',''',C_Ary[tnum]^.Desc,''');');
             inc(tnum);
          end;
       end;
    tnum := 1;
    Flush_Policy_ExpStr(0);
    while (C_Ary[tnum] <> NIL) do
      begin
         dispose(C_Ary[tnum]);
         C_Ary[tnum]:= NIL;
         Inc(tnum);
      end;
    Const_Num := 0;
    FindNextLine;
    tbstr:='';
    inside_unit_cost_definition:=false;
end;


Function curwinCurline: String;
var
    startline: String;
    linePos:   integer;
begin
    linePos:= ActiveRich.CaretY;
    startline := ActiveRich.Lines[linePos -1];
    curwinCurline:= startline;
end;

Function Process_Const: boolean;
var
    ok : boolean;
    errMess,
    startline : String;
    dummy, linePos  : integer;
begin
    If (validvariable or existinguservar(dummy)) then
       begin
          errMess := 'Error on ' + symbol + ' You cannot have a user constant with';
          LexicalError(errMess,
                       'the same name as a data variable',
                       'or a user defined variabled');
          // setcursormode(cursoron);
          ActiveRich.showTheCursor;
          exit;
       end;
    inc(Const_Num);
    linePos:= ActiveRich.CaretY;
    startline := ActiveRich.Lines[linePos -1];
    New(C_Ary[Const_Num]);
    C_ary[Const_Num]^.Name := symbol;
    C_Ary[Const_Num]^.BigName := UpCaseNStr(Symbol);
    nexttoken;
    if token <> Equals then
      Unexpected(Equals);
    ReadSymbol(Sender);
    if PoundSign then
        begin
           C_ary[Const_Num]^.disptype := money;
           Proc_Money_Const;
           C_ary[Const_Num]^.realval:=0;
           C_ary[Const_Num]^.valu := numb;
        end
    Else if Percentage then
        begin
           C_Ary[Const_Num]^.disptype := PerCent;
           Process_Percent;
           C_ary[Const_Num]^.valu:=round(realval*100);
           C_ary[Const_Num]^.realval := realval;
        end
    Else if Number_Real then
        begin
           C_Ary[Const_Num]^.disptype := RealNumber;
           Process_Real;
           C_ary[Const_Num]^.valu:=trunc(realval*100);
           C_ary[Const_Num]^.realval:=realval;
        end
    Else
        begin
           C_Ary[Const_Num]^.disptype := Number;
           Process_Number;
           C_ary[Const_Num]^.valu:=numb;
           C_Ary[const_Num]^.realval := 0;
        end;
    ReadSymbol(Sender);
    ok := SymbolToToken;
    if (token = Per_Year) then
       begin
          C_Ary[Const_Num]^.valu := C_Ary[Const_Num]^.Valu;
          C_Ary[Const_Num]^.dispnum := numb;
          C_Ary[Const_Num]^.disptype := Per_Year;
       end
    else if (token = Per_Month) then
       begin
          C_Ary[Const_Num]^.valu := C_Ary[Const_Num]^.Valu * 12;
          C_Ary[Const_Num]^.dispnum := numb;
          C_Ary[Const_Num]^.disptype := Per_Month;
       end
    else
       C_Ary[Const_Num]^.dispnum := -9;
    C_Ary[Const_Num]^.Units:= 0;
    if (curwinCurline = startline) then
       FindNextLine;
    if (globErr) then
       Process_Const:=false
    else
       Process_Const:=true;
end;

Function ReadString: string;
var
    outstr : string;
    testChar : char;
begin
    outstr:='';
    repeat
       if (length(outstr)>0) and (outstr[length(outstr)]<>'.') then
          outstr:=outstr+' ';
       if (symbol[1] in ['.',',','''']) then
          delete(outstr,length(outstr),1);
       outstr:=outstr+symbol;
       ReadSymbol(Sender);
    until ((symbol=')') or (length(outstr)>250));
    if (length(outstr)>250) then
       begin
          LexicalError('ERROR: Source Note cannot be longer than 250 characters',
                       'in length.  You must shorten it','');
          ReadString:='';
       end;
    ReadString:= OutStr;
end;

Function Process_Policy_or_Charge_Const: boolean;
var
    ok : boolean;
    errMess,
    startline : String;
    dummy, linePos  : integer;
begin
    If (validvariable or existinguservar(dummy)) then
       begin
          errMess := 'Error on ' + symbol + ' You cannot have a user constant with';
          LexicalError(errMess,
                       'the same name as a data variable',
                       'or a user defined variabled');
          ActiveRich.showTheCursor;
          exit;
       end;
    inc(Const_Num);
    linePos:= ActiveRich.CaretY;
    startline := ActiveRich.Lines[linePos -1];
    New(C_Ary[Const_Num]);
    C_ary[Const_Num]^.Name := symbol;
    C_Ary[Const_Num]^.BigName := UpCaseNStr(Symbol);
    ReadSymbol(Sender);
    ok := SymbolToToken;
    if (token <> unit_cost) then
       begin
          errMess := 'Error on ' + symbol + ' You must have a the key word Unit_Cost';
          LexicalError(errMess,
                       'at this point.  This will represent the cost per unit of the policy items',
                       'funded or units of tax collected in a full year.');
          ActiveRich.showTheCursor;
          exit;
       end;
    nexttoken;
    if token <> Equals then
      Unexpected(Equals);
    ReadSymbol(Sender);
    if PoundSign then
        begin
           C_ary[Const_Num]^.disptype := money;
           Proc_Money_Const;
           C_ary[Const_Num]^.realval:=0;
           C_ary[Const_Num]^.valu := numb;
           C_ary[Const_Num]^.unit_cost := numb;
        end
    Else
        begin
          errMess := 'Error on ' + symbol + ' You must have a monetary value';
          LexicalError(errMess,
                       'at this point.  A dollar sign or other currency',
                       'symbol must be used');
          ActiveRich.showTheCursor;
          exit;
        end;
    ReadSymbol(Sender);
    ok := SymbolToToken;
    if (token <> units) then
       begin
          errMess := 'Error on ' + symbol + ' You must have a the key word Units';
          LexicalError(errMess,
                       'at this point.  This will represent the number of units of the policy item',
                       'that you intend to fund.');
          ActiveRich.showTheCursor;
          exit;
       end;
    nexttoken;
    if token <> Equals then
      Unexpected(Equals);
    ReadSymbol(Sender);
    Process_Real;
    C_ary[Const_Num]^.units:=RealVal;
    //if (curwinCurline = startline) then
    ReadSymbol(Sender);
    ok := SymbolToToken;
    if (token <> description) then
       begin
          errMess := 'Error on ' + symbol + ' You must have a the key word Description';
          LexicalError(errMess,
                       'at this point.  This should explain what this unit cost is in plain',
                       'language.');
          ActiveRich.showTheCursor;
          exit;
       end;
    NextToken;
    Accept(EQUALS);
    ReadSymbol(Sender);
    DescriptionString:= ReadString;
    if (length(DescriptionString) > 250) then
       begin
          errMess := 'Error on ' + symbol + ' The Description must be';
          LexicalError(errMess,
                       ' 250 characters in length',
                       'or less.');
          ActiveRich.showTheCursor;
          exit;
       end;
    C_ary[Const_Num]^.Desc:=DescriptionString;
    ReadSymbol(Sender);
    // FindNextLine;
    if (globErr) then
       Process_Policy_or_Charge_Const:=false
    else
       Process_Policy_or_Charge_Const:=true;
end;

Function MaxLabs(VarStr : String): String;
var
    valu,
    code,
    i : integer;
    TempMax : string[10];
begin
    i:=1;
    while ((i<highestvar) and (VarStr<>VarArray[i]^.BigPtr^)) do
       i:=i+1;
    if (UpSymbol<>VarArray[i]^.BigPtr^) then
        MaxLabs := '0'
    else if (VarArray[i]^.ValPtr = Nil) then
        MaxLabs := '0'
    else
       begin
          TempMax := VarArray[i]^.ValPtr^.V_Ary[0]^;
          val(TempMax, valu, code);
          valu := valu - 1;
          str(valu, TempMax);
          MaxLabs := TempMax;
       end;
end;

Procedure Set_Gross_Var;
var

    MaxCatStr,
    numstr : string[10];
    valu,
    code   : integer;

begin
    UserVStr := '';
    NextToken;
    accept(LBRACK);
    numstr := Symbol;
    val(numstr, valu, code);
    if ((code<>0) or (valu<>(GUF_No + 1))) then
      begin
          LexicalError('ERROR : the numbers for your Grossing Variables',
                     'Must start at 1 and increase by one for each new',
                     'Variable');
          exit;
       end;
    if((Weight_Mode<>0)and(Weight_Mode<>VarArray[highestvar]^.Level))then
       begin
          LexicalError('ERROR : All Grossing Variables must be at the same',
                     'level of analysis (e.g. they must all be household',
                     'variables or all tax unit variables');
          exit;
       end
    else
       Weight_Mode := VarArray[highestvar]^.Level;
    Inc(GUF_No);
    accept(NUMBER);
    accept(RBRACK);
    accept(COLON);
    ExpStr := 'GUF_Index[' + NumStr + '] := ' + symbol + ';';
    WritePln(ExpStr);
    MaxCatStr := MaxLabs(UPSYMBOL);
    if (MaxCatStr = '0') then
      begin
          LexicalError('ERROR : Your Grossing Variables must be variables',
                       'with category labels','');
          exit;
       end;
    accept(VARIABLE);
    ExpStr := 'GUF_Cats[' + NumStr + '] := ' + MaxCatStr + ';';
    WritePLn(ExpStr);
    Accept(FULLSTOP);
end;
                {
Function ReadString: string;
var
    outstr : string;
    testChar : char;
begin
    outstr:='';
    repeat
       if (length(outstr)>0) and (outstr[length(outstr)]<>'.') then
          outstr:=outstr+' ';
       if (symbol[1] in ['.',',','''']) then
          delete(outstr,length(outstr),1);
       outstr:=outstr+symbol;
       ReadSymbol(Sender);
    until ((symbol=')') or (length(outstr)>250));
    if (length(outstr)>250) then
       begin
          LexicalError('ERROR: Source Note cannot be longer than 250 characters',
                       'in length.  You must shorten it','');
          ReadString:='';
       end;
    ReadString:= OutStr;
end;             }

Procedure Set_Policy_Status;
begin
    NextToken;
    if (symbol='=') then
      ReadSymbol(Sender);
    Symbol:=UpcaseNewStr(symbol);
    if ((symbol<>'CURRENT') and (symbol<>'NEW')) then
       begin
         LexicalError('ERROR : Must have the words CURRENT or',
                    'NEW at this point','');
         exit;
       end;
    ExpTem:='';
    If (symbol='NEW') then
       new_policy:= 1;
    ReadSymbol(Sender);
    GotoStartofNextRule;
end;

Procedure Set_Calibration;
     {  This is to set target revenue or expenditure data for a given }
     {  tax or benefit, so that validation tables can be written out }
     {  inside the tabulator }

var
     numst : string;
     valu  : LongInt;
     code  : integer;
     tbnum : integer;

begin
    ReadSymbol(Sender);
    ReadSymbol(Sender);
    numst:= Symbol;
    val(symbol, ccw, code);
    if (code<>0) then
      begin
          LexicalError('ERROR : There must be a number at this point',
                       'which represents the factor by which the number of FES',
                       'cases must be mulitplied for this tax or benefit');
          exit;
       end;
    tbnum:=tbplace(tbstr);
end;

Procedure Set_Target_Data;
     {  This is to set target revenue or expenditure data for a given }
     {  tax or benefit, so that validation tables can be written out }
     {  inside the tabulator }

var
     numst : string;
     valu  : LongInt;
     len,
     code  : integer;
     realTemp : real;

begin
    NextToken;
    if (symbol=':') then
      ReadSymbol(Sender);
    Symbol:= UpCaseNewStr(Symbol);
    if ((symbol<>'REVENUE') and (symbol<>'EXPENDITURE')) then
       begin
         LexicalError('ERROR : Must have the words REVENUE or',
                    'EXPENDITURE at this point','');
         exit;
       end;
    NextToken;
    Accept(Equals);
  //  numst:= Symbol;
    val(symbol, realtemp, code);
    RealVal := realtemp / 1000;
    Str(RealVal:12:0, numst);
    val(numst, valu, code);
    if (code<>0) then
      begin
          LexicalError('ERROR : There must be a number in thousands of pesos',
                       'representing the official EXPENDITURE or REVENUE for',
                       'the current tax or benefit');
          exit;
       end;
    Targ_Exp:= Valu;
    NextToken;
    Accept(Source);
    Accept(EQUALS);
    ReadSymbol(Sender);
    Source1:= ReadString;
    ReadSymbol(Sender);
    Symbol:= UpCaseNewStr(Symbol);
    if ((symbol<>'PAYERS') and (symbol<>'RECIPIENTS')) then
       begin
         LexicalError('ERROR : Must have the words PAYERS or',
                    'RECIPIENTS at this point','');
         exit;
       end;
    NextToken;
    Accept(Equals);
    numst:= Symbol;
    val(numst, valu, code);
    if (code<>0) then
      begin
          LexicalError('ERROR : There must be a number representing the number of people',
                       'paying a particular tax or receiving a particular benefit','');
          exit;
       end;
    Targ_Recip:= Valu;
    NextToken;
    Accept(Source);
    Accept(EQUALS);
    ReadSymbol(Sender);
    Source2:= ReadString;
    ReadSymbol(Sender);
    GotoStartOfNextRule;
end;

Procedure Set_Policy_Target_Data;
     {  This is to set target revenue or expenditure data for a given }
     {  tax or benefit, so that validation tables can be written out }
     {  inside the tabulator }

var
     numst : string;
     valu  : LongInt;
     len,
     code  : integer;
     realTemp : real;

begin
    NextToken;
    if (symbol=':') then
      ReadSymbol(Sender);
    Symbol:= UpCaseNewStr(Symbol);
    if ((symbol<>'REVENUE') and (symbol<>'EXPENDITURE')) then
       begin
         LexicalError('ERROR : Must have the words REVENUE or',
                    'EXPENDITURE at this point','');
         exit;
       end;
    NextToken;
    Accept(Equals);
    val(symbol, realtemp, code);
    RealVal := realtemp / 1000;
    Str(RealVal:12:0, numst);
    val(numst, valu, code);
    if (code<>0) then
      begin
          LexicalError('ERROR : There must be a number in thousands pesos',
                       'representing the Citizen Model''s estimate for',
                       'the current Unit Cost or Unit Charge (with an academic reference).');
          exit;
       end;
    Targ_Exp:= Valu;
    NextToken;
    Accept(Source);
    Accept(EQUALS);
    ReadSymbol(Sender);
    Source1:= ReadString;
    ReadSymbol(Sender);
    Symbol:= UpCaseNewStr(Symbol);
    Targ_Recip:= -9;
    GotoStartOfNextRule;
end;

Procedure Set_Write_Var;
var
    numst : string[10];
    code  : integer;
begin
    UserVStr := '';
    NextToken;
    accept(LBRACK);
    numst:= Symbol;
    val(numst, valu, code);
    if ((code<>0) or (valu<>(Out_Var_No + 1))) then
      begin
          LexicalError('ERROR : the numbers for your Grossing Variables',
                     'Must start at 1 and increase by one for each new',
                     'Variable');
          exit;
       end;
    Inc(Out_Var_No);
    accept(NUMBER);
    accept(RBRACK);
    accept(COLON);
    If (VarArray[numb]^.ifbool= TRUE) then
       begin
          LexicalError('ERROR : You cannot write a boolean variable to',
                       'a new data set','');
          exit;
       end;
    Out_Vars[out_var_no]:= findoutvarnumber(symbol);
    Out_Vars_Orig[out_var_no]:= findvarnumber(symbol);
    accept(VARIABLE);
end;

Procedure ValidUserVar;
    { This checks to see if the symbol supplied is a valid user variable }

var
   Dummyin : boolean;
   ch     : char;
   i,
   varnum,
   oldcases,
   DummyVar : integer;
begin
   ReadSymbol(Sender);
   UpSymbol := Symbol;
   for i:= 1 to Length(Symbol) do
        UpSymbol[i] := UpCase(Symbol[i]);
   if symbol='EOF1' then
       token:=eof1
   else if Reserved_Word(UpSymbol) then
        LexicalError('ERROR: ' + UPSYMBOL + ' is a RESERVED word.  It has',
                     'already been defined.  You can use it in an equation',
                     'but you cannot have a new variable with this name')
   else if IsDigit(symbol[1]) then
        LexicalError(' ERROR: program Expected a User-Declared Variable which must start with',
                     'A letter not a Number','')
   else if ValidVariable then
        LexicalError('A User-declared Variable was expected here - you have given the',
                     'Name of an existing Data Variable','')
   else if ExistingUserVar(varnum) then
            LexicalError(Symbol + ' is the name of an existing variable',
                         'You must supply the name of a new variable',
                         'before continuing')
   else
        begin
           If VarArray[VarNum] = Nil then
             begin
                New(VarArray[VarNum]);
                New(VarArray[VarNum]^.LongPtr);
                New(VarArray[VarNum]^.BigPtr);
                VarArray[VarNum + 1] := Nil;
             end;
           HighestVar:=Succ(HighestVar);
	         AssignUserVar(VarNum);
           AssignStr:= UserVStr + ':= ';
        end;
   NextToken;
   Accept(LBRACK);
   globerr := FALSE;
   VarArray[varnum]^.IfReal  := FALSE;
   VarArray[varnum]^.IfBool  := FALSE;
   VarArray[varnum]^.Ifmoney := FALSE;
   if not(token in [integer1,real1,money1,boolean1]) then
      LexicalError('You must declare the type of your variable at this',
                   'point in brackets it must be one of :',
                   'INTEGER, REAL, MONEY, or BOOLEAN');
   case token of
        real1    : VarArray[varnum]^.IfReal  := TRUE;
        boolean1 : VarArray[varnum]^.IfBool  := TRUE;
        money1   : VarArray[varnum]^.Ifmoney := TRUE;
   end;
   nexttoken;
   Accept(RBRACK);
   Accept(COLON);
   If (token=TIMES) then
      begin
         VarArray[varnum]^.IfDisplay:=TRUE;
         Accept(TIMES);
      end
   else
      VarArray[varnum]^.IfDisplay:=FALSE;
   ExpStr:='';
   If Token <> If1 then
      AddExp(AssignStr);
end;

Function Analysis_Level : boolean;
   { This reads the next word from the input stream to see if it }
   { is a valid analysis level indicator }
var
   dummyok  : boolean;
   dummynum : integer;
begin
   dummyok:= SymbolToToken;
   if not (token in [Individual, Family, HouseHold]) then
       begin
          Analysis_Level := false;
          exit;
       end
   else
       begin
          numb := token;
          anal_level[1] := token;
          Analysis_Level := True;
       end;
   Com_Lev:= 1;
end;

Procedure AssignValueLabels;
   { This assigns an array of strings in memory to hold the value of }
   { any value labels which have been created }
var
   TemStr : Str50;
   i      : integer;
begin
   New(VarArray[CurrentUserVar]^.ValPtr);
   VarArray[CurrentUserVar]^.ValPtr^.N_Ary[0]:=CurrentValLab;
   Str((CurrentValLab + 1), TemStr);
   New(VarArray[CurrentUserVar]^.ValPtr^.V_Ary[0]);
   VarArray[CurrentUserVar]^.ValPtr^.V_Ary[0]^:=TemStr;
   for i:=1 to CurrentValLab do
     begin
        VarArray[CurrentUserVar]^.ValPtr^.N_Ary[i]:=i;
        New(VarArray[CurrentUserVar]^.ValPtr^.V_Ary[i]);
        VarArray[CurrentUserVar]^.ValPtr^.V_Ary[i]^:=TempVals.Names[i];
        TempVals.Names[i]:= '';
     end;
   New(VarArray[CurrentUserVar]^.ValPtr^.V_Ary[CurrentValLab + 1]);
   VarArray[CurrentUserVar]^.ValPtr^.V_Ary[CurrentValLab + 1]^:=
                              '------------- End of List -------------';
end;

Procedure Delete_From_VarArray(VarSymbol : namestr);
      { This deletes a variable from the variable array }
var
  varnum,
  cnt    : integer;
begin
 { if (pos('CB_',VarSymbol)>0) then
      begin
         MessageDlg(Format('No Variables in the Category.  Click Yes to continue.', [name]), mtConfirmation,
          [mbYes], 0);
      end;    }
  varnum := findvarnumber(VarSymbol);
  if (varnum <= 0) or (varnum > Highestvar) then exit;
  VarArray[varnum]^.longptr^:='';
end;

Procedure CloseProg;
begin
   writeln(tmenhead,'end;');
   CloseFile('TAXHEAD.DEF',tmenhead);

   writeln(bmenhead,'end;');
   CloseFile('BENHEAD.DEF',bmenhead);

   writeln(cmenhead,'end;');
   CloseFile('CHGHEAD.DEF',cmenhead);

   writeln(pmenhead,'end;');
   CloseFile('POLHEAD.DEF',pmenhead);

   writeln(cdefines,'end;');
   CloseFile('CDEFINE.DEF',cdefines);
   Writeln(TBDefines,'   TxBn_Ary[',NumStr(TBPlace('XXX')),']:= Nil;');
	 Writeln(TBdefines,'end;');
   CloseFile('TBDEFINE.DEF',TBDefines);
   if (globerr) then
      begin
         CloseFile('INDIV.PRG',  idfile);
         CloseFile('POLICY.PRG', PolicyFile);
         exit;
      end;
end;

Procedure ValidOld_Var;
begin
   NextToken;
   If ValidVariable then
      begin
         token:=VARIABLE;
         variablestr:=symbol;
         ExpTemp(variablestr);
         Assignstr := variablestr + ':= ';
         NextToken;
         Accept(COLON);
         ExpStr:='';
         If Token <> If1 then
            AddExp(AssignStr);
         Write_Mode := TRUE;
      end
   else
      LexicalError('ERROR : you must have a valid data variable',
                   'after a WRITE command',
                   symbol + ' is not acceptable');
end;

Procedure ErrorReset;
begin
    { EditGotoLine(ErrorLine);
    EditGotoColumn(ErrorCol); }
    //SetCursorMode(CursorOn);
    ActiveRich.showTheCursor;
end;


Procedure Process_Var;
begin
    statement;
    while (not(globerr) and (token<>eof1) and (token<>FullStop)) do
       expression;
    AddExp(';');
    Write_Expression;
    if ((Anal_Level[1]<> Individual) and (token<>eof1)) then
       begin
          End_Until(idbuf);
          Begin_Repeat(idbuf);
       end;
    ReadSymbol(Sender);
end;

Function OneRule : boolean;
var
    ok : boolean;
begin
    token := 0;
    ExpStr:='';
    ExpTem:='';
    BoolVar := false;
    OneRule := False;
    GotoStartOfNextRule;
    Symbol:='';
    ReadSymbol(Sender);
    ok:= SymbolToToken;
    if Symbol='EOF1' then
       begin
           Beep;
           LexicalError('No Text for the Current Rule ',
                        'Please Remember That You Must Place the Cursor',
                        'On the First Line of the Relevant Rule When you Start');
           Exit;
       end
    else if (token in [Start_Tax, Start_Benefit]) then
      Start_TB
    else if (token in [Start_Policy, Start_Charge]) then
      Start_Policy_or_Charge
    else if (token in [End_Tax, End_Benefit]) then
      End_TB
    else if (token in [End_Charge, End_Policy]) then
      End_Policy_or_Charge
    else if (token = POLICY_STATUS) then
      Set_Policy_Status
    else if (token = TARGET_DATA) then
      begin
          if (inside_unit_cost_definition) then
            Set_Policy_Target_Data
          else
            Set_Target_Data;
      end
    else if (token = POLICY_TARGET_DATA) then
      Set_Policy_Target_Data
    else if (token = CASELOAD_CALIBRATION) then
      Set_Calibration
    else
      Begin
         if ((Analysis_Level) or
             (token in [WRITE1,WRITEVAR,GROSSING_VAR]))  then
            begin
               if (token = WRITE1) then
                  begin
                    ReadSymbol(Sender);
                    if Analysis_Level then
                       ValidOld_Var;
                    if not globerr then
                       Process_Var;
                  end
               else if (token = WRITEVAR) then
                  Set_Write_Var
               else if (token = GROSSING_VAR) then
                  Set_Gross_Var
               else
                  begin
                    ValidUserVar;
                    if not globerr then
                       Process_Var;
                    If (not(Globerr) and (VarArray[CurrentUserVar]^.IfValLabs)) then
                       AssignValueLabels;
                    if (Globerr) then
                         Delete_From_VarArray(UserVStr);
                  end;
               if not Globerr then
                 begin
                   OneRule:= True;
                   BlockTo:=Nil;
                   WriteBufs;
                 end
               else
                 begin
                   OneRule:= false;
                   Symbol:='EOF1';
                   BlockTo:=Nil;
                   BlockFrom:=Nil;
                   ErrorReset;
                 end;
            end
         else
            begin
               if (inside_unit_cost_definition) then
                begin
                  if not(Process_Policy_or_Charge_Const) then
                    LexicalError('The model expects the first word to be either Individual''s',
                      'Family''s, or Houshold''s.  Or else it must be a constant',
                      'N.B. The cursor should be on fist line of a definition');
                end
               else
                begin
                  if not(Process_Const) then
                    LexicalError('The model expects the first word to be either Individual''s',
                      'Family''s, or Houshold''s.  Or else it must be a constant',
                      'N.B. The cursor should be on fist line of a definition');
                end;
            end;
      end;
end;

Procedure ResetVars;
var
    i : integer;
begin
    for i := (RawVarMax + 1) to HighestVar do
       begin
          dispose(VarArray[i]^.LongPtr);
          dispose(VarArray[i]);
          VarArray[i] := Nil;
       end;
    highestvar := RawVarMax;
end;

Procedure Indices;
var
     i,
     code,
     vcnt : integer;
     varstr : str50;
     tempreal : real;
begin
     Indexing:=TRUE;
     ReadSymbol(Sender);
     UpSymbol := Symbol;
     for i:= 1 to Length(Symbol) do
        UpSymbol[i] := UpCase(Symbol[i]);
     if (UPSYMBOL <> 'MAIN_FACTOR') then
        begin
           LexicalError('When Indexing the 1st must be MAIN_FACTOR.  This specifies',
                        'A number by which all money variables will be inflated',
                        'unless another method of indexation is specifically stated');
           ErrorReset;
           exit;
        end;
     NextToken;
     Accept(Equals);
     If (not(token in [number,realnumber])) then
         begin
           LexicalError('A number was expected at this point','','');
           ErrorReset;
           exit;
         end;
     Val(Symbol,MainFact,Code);
     Swallow(PerCent);
     vcnt := 1;
     for vcnt := 1 to MaxRaws do
        Spec_Vars[vcnt] := 0;
     ExpStr := '';
     ExpTem := '';
     NextToken;
     vcnt := 1;
     while ((symbol <> 'EOF1') and (globerr = FALSE)) do
        begin
          UpSymbol := Symbol;
          VarStr:= Symbol;
          AssignStr := Symbol + ' := ';
          for i:= 1 to Length(Symbol) do
              UpSymbol[i] := UpCase(Symbol[i]);
          UserVStr := UPSYMBOL;
          if (ValidVariable = FALSE) then
            begin
              LexicalError('ERROR.  When Indexing the equations must start',
                          'with an existing data variable','');
              ErrorReset;
              Exit;
            end;
          Spec_Vars[vcnt]:= CurrentVar;
          Com_Lev := 1;
          Anal_Level[1] := Individual;
          vcnt := vcnt + 1;
          NextToken;
          Accept(Colon);
          ExpStr := '';
          if (token <> if1) then
             begin
                Val(Symbol,tempreal,Code);
                tempreal:=tempreal / 100;
                Str(tempreal:3:3,Symbol);
                Addexp(AssignStr);
                ExpStr:= ExpStr +'Round('+varstr+'*'+symbol + ');';
                ReadSymbol(Sender);
             end
          else if not(globerr) then
             Process_Var;
          if not Globerr then
             begin
                BlockTo:=Nil;
                Flush_ExpStr(0);
                WriteBufs;
             end
          else
             begin
                Symbol:='EOF1';
                BlockTo:=Nil;
                BlockFrom:=Nil;
                ErrorReset;
             end;
        end;
end;

Procedure Process_Arrays;
var
  initfile,
  decfile   : TEXT;
  aryidx    : integer;
  AryName   : Str50;

  Procedure Process_Array;
  var

    vals,
    Arylen    : integer;
  begin
    ReadSymbol(Sender);
    Symbol:=UpCaseNewStr(symbol);
    AryName:= Symbol;
    New(Array_Array[aryidx]);
    Array_Array[aryidx]^:=AryName;
    NextToken;
    Accept(lsquare);
    Accept(number);
    AryLen := numb;
    If (symbol<>']') then
      LexicalError('ERROR: expected "]" character',
                         ' ','- Press ESC ');
    writeln(decfile,'   ',AryName,' : Array [1..',AryLen,'] of Real;');

    for vals:=  1 to AryLen do
      begin
         ReadSymbol(Sender);
         Symbol:=UpcaseNewStr(Symbol);
         if (symbol<>AryName) then
            LexicalError('ERROR: expected Array Name '+AryName,
                         ' ','- Press ESC ');
         NextToken;
         Accept(lsquare);
         Accept(number);
         Accept(rsquare);
         ReadSymbol(Sender);
         RealVal:=0;
         Process_Real;
         if (RealVal=0) then
            LexicalError('ERROR: expected a real number at this point',
                         ' ','- Press YES to continue ');
         writeln(initfile,'  ',AryName,'[',vals,']:=',realval:3:4,';');
      end;

    ExpStr:='';
  end;

begin
    New(Array_Array[0]);
    WriteOpen(decfile,'ARYDCLAR.PAS');
    WriteOpen(initfile,'ARAYINIT.PAS');
    writeln(initfile,'Procedure Init_Arrays;');
    writeln(initfile,'Begin');
    aryidx:=0;
    While (symbol='ARRAY') do
       begin
          inc(aryidx);
          process_array;
          ReadSymbol(Sender);
          symbol:= upcasenewstr(symbol);
       end;
    str(aryidx,aryname);
    Array_Array[0]^:=aryname;
    writeln(initfile,'End;');
    close(initfile);
    close(decfile);
end;

Begin               { Main Block of the Translator Procedure }
    Indexing:=FALSE;
    inside_unit_cost_definition:= false;
    unit_cost_definitions_found:=false;
    TBStr:='';
    GetDir(0,CurDirSt);
    ChangeDir(prdrive + '\pom\new');
    Translated:=true;
    Initvars;
    CurrentUserVar:=1;
    symbol := '';
    if (ParamStr(1) = 'IX') then
       begin
          indices;
       end
    else
       begin
          GotoStartOfNextRule;
          ReadSymbol(Sender);
          Symbol:=UpcaseNewStr(Symbol);
          If (Symbol='ARRAY')  then
             process_arrays
          else
             array_array[0]:=Nil;
          while ((symbol <> 'EOF1') and (globerr = FALSE)) do
             ok := OneRule;
       end;
    CloseProg;
    if not(Globerr) then
            begin
                 ShowMessage('Your Tax-Benefit Rules have been converted.',
                             'Press OK','to continue.');
                 ActiveRich.hideTheCursor;   //SetCursorMode(CurSorOff);
                 TrUtils;
                 If (out_var_no > 0) then
                    New_Dict;
                 ActiveRich.hideTheCursor; //SetCursorMode(CurSorOn);
            end
         else
            ResetVars;
    ChangeDir(CurDirSt);
end;

procedure TForm1.Per_MonthClick(Sender: TObject);
var
    outStr : string;
begin
    outStr:= Per_Month.Caption;
    InsertSimple(outStr);
end;

end.

end.
